package es.gva.cit.catalogClient.protocols;

import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.StringTokenizer;

import org.jzkit.search.provider.iface.SearchException;
import org.jzkit.search.util.ResultSet.IRResultSetException;
import org.jzkit.z3950.gen.v3.Z39_50_APDU_1995.InitializeResponse_type;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: Z3950Protocol.java,v 1.21.2.1 2006/09/20 12:01:18 jorpiell Exp $
 * $Log: Z3950Protocol.java,v $
 * Revision 1.21.2.1  2006/09/20 12:01:18  jorpiell
 * Se ha cambiado la versin de la jzkit, se ha incorporado la funcionalidad de cargar arcims
 *
 * Revision 1.22  2006/09/20 11:20:17  jorpiell
 * Se ha cambiado la versin de la librera jzkit de la 1 a la 2.0
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class Z3950Protocol {

	/**
	   * Makes a query
	   * @param url
	   * @param object
	   * @param firstRecord
	   * @return
	 * @throws IRResultSetException 
	 * @throws SearchException 
	   */
	  public Collection doQuery(URL url, Object object, int firstRecord){    
		  Z3950Connection connection = Z3950ConnectionFactory.getConnection(url);
		  return connection.search((String)object,firstRecord);
	 }  

	  
	  /**
	   * 
	   * @param url
	   * @return
	   */
	  public String openConnection(URL url) {      
		  Z3950Connection connection = Z3950ConnectionFactory.getConnection(url);
		  return connection.connect();
	  }
	  
	  /**
	   * 
	   * @param url
	   * @return
	   */
	  public boolean isProtocolSupported(URL url) {    
	     Z3950Connection connection = Z3950ConnectionFactory.getConnection(url);
	     if (connection.connect() == null){
	    	 return false;
	     }
	     return true;
	  }

	  /**
	   * Return the database
	   * @param url
	   * @return
	   */
	  public static String getDatabase(URL url) {
		  StringTokenizer sti = new StringTokenizer(url.getPath(), "/");
		  if (sti.countTokens() == 0) {
			  return "geo";
		  } else {
			  return sti.nextToken();
		  }
	  }
}
