/*
 * Created on 31-may-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationListener;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.SelectableDataSource;
import com.iver.cit.gvsig.gui.Table;
import com.iver.cit.gvsig.gui.View;
import com.iver.cit.gvsig.project.ProjectTable;
import com.iver.cit.gvsig.project.ProjectView;


/**
 * Extensin encargada de limpiar la seleccin.
 *
 * @author Vicente Caballero Navarro
 */
public class ClearSelectionExtension extends Extension {
	/**
	 * @see com.iver.mdiApp.plugins.IExtension#updateUI(java.lang.String)
	 */
	public void execute(String s) {
		if (s.compareTo("DEL_SELECTION") == 0) {
			boolean refresh = false;
			com.iver.andami.ui.mdiManager.IWindow view =PluginServices.getMDIManager().getActiveWindow();

			if (view instanceof View){
				View vista = (View) view;
				ProjectView model = vista.getModel();
				MapContext mapa = model.getMapContext();
				MapControl mapCtrl = vista.getMapControl();
				for (int i = 0; i < mapa.getLayers().getLayersCount(); i++) {
					/* JMV: Esto deberia de ser asi (Las capas son 'Selectable' o no)
					 * pero de momento lo cambiamos para que use una capa vectorial
					 *

					if (map.getLayers().getLayer(i) instanceof Selectable) {
						if (mapa.getLayers().getLayer(i).isActive()) {
							Selectable selectable = (Selectable) mapa.getLayers().getLayer(i);

							if (selectable.getSelection().cardinality() != 0) {
								refresh = true;
							}
	                        selectable.clearSelection();
						}
					}

					*/
					if (mapa.getLayers().getLayer(i) instanceof FLyrVect) {
						if (mapa.getLayers().getLayer(i).isActive()) {

							try {
								SelectableDataSource dataSource;

								dataSource = ((FLyrVect)mapa.getLayers().getLayer(i)).getRecordset();
								if (dataSource.getSelection().cardinality() != 0) {
									refresh = true;
								}
						        dataSource.clearSelection();
							} catch (DriverException e) {
								e.printStackTrace();
							}

						}
					}
				}

				if (refresh) {
					mapCtrl.drawMap(false);
				}
			}else if (view instanceof Table){
				Table table = (Table) view;
				ProjectTable model = table.getModel();
				SelectableDataSource dataSource;
				dataSource = model.getModelo().getRecordset();
				if (dataSource.getSelection().cardinality() != 0) {
					refresh = true;
				}
			    dataSource.clearSelection();
			    if (refresh) {
			    	table.refresh();
				}
			}
		}
    }

	/**
	 * @see com.iver.mdiApp.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		com.iver.andami.ui.mdiManager.IWindow view = PluginServices.getMDIManager().getActiveWindow();

		if (view == null) {
			return false;
		}
		if (view instanceof View) {
			MapContext mapa = ((View) view).getModel().getMapContext();
			return mapa.getLayers().getLayersCount() > 0;
		}
		if (view instanceof Table) {
			return true;
		}

		return false;
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		com.iver.andami.ui.mdiManager.IWindow view = PluginServices.getMDIManager().getActiveWindow();
		if (view == null) {
			return false;
		}
		if (view instanceof View){
			MapContext mapa = ((View) view).getMapControl().getMapContext();
			for (int i = 0; i < mapa.getLayers().getLayersCount(); i++) {
				if (mapa.getLayers().getLayer(i) instanceof FLyrVect) {
					FLyrVect lyrVect = (FLyrVect) mapa.getLayers().getLayer(i); 
					if (lyrVect.isActive()) {
						if (lyrVect.isAvailable())
							try {
								if (lyrVect.getRecordset().getSelection().cardinality() > 0)
									return true;
							} catch (DriverException e) {
								e.printStackTrace();
								NotificationManager.addWarning("Capa " + lyrVect.getName() + " sin recordset correcto",e);
							}
					}
				}
			}
		}
		if (view instanceof Table){
			return ((Table)view).getSelectedRowIndices().length>0;
		}
		return false;
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}
}
