/*
 * Created on 31-may-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui;

import java.text.NumberFormat;
import java.text.ParseException;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.hardcode.gdbms.engine.data.DataSource;
import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.layerOperations.AlphanumericData;
import com.iver.cit.gvsig.project.ProjectView;
/**
 * Dilogo de propiedades del tema.
 *
 * @author Vicente Caballero Navarro
 */
public class FThemePropertiesDialog extends JPanel implements IWindow {
	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JTabbedPane jTabbedPane = null;
	private javax.swing.JPanel phiperenlace = null;
	private javax.swing.JPanel phnorte = null;
	private javax.swing.JPanel phsur = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JComboBox jComboBox = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JComboBox jComboBox1 = null;
	private javax.swing.JPanel pbotones = null;
	private javax.swing.JButton baceptar = null;
	private javax.swing.JButton bcancelar = null;
	private javax.swing.JPanel pvisualizacion = null;
	private FLayer m_layer;
	private javax.swing.JPanel pvnorte = null;
	private javax.swing.JPanel pvsur = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JLabel jLabel3 = null;
	private javax.swing.JTextField tminEscala = null;
	private javax.swing.JTextField tMaxScale = null;
	private ProjectView view;

	private JLabel jLabel4 = null;
	private JTextField jTextField2 = null;
	private JPanel pvCenter = null;
	private JLabel jLabel5 = null;
	private JLabel jLabel6 = null;
	
	private NumberFormat nf = NumberFormat.getInstance();

	/**
	 * This is the default constructor
	 *
	 * @param layer DOCUMENT ME!
	 * @param view DOCUMENT ME!
	 */
	public FThemePropertiesDialog(FLayer layer, ProjectView view) {
		super();
		this.view = view;
		m_layer = layer;
		initialize();
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.setSize(367, 184);
		this.add(getJContentPane());
		if (m_layer.getMinScale() != -1)
		    getTminEscala().setText(nf.format(m_layer.getMinScale()));
		if (m_layer.getMaxScale() != -1)
		    getTMaxScale().setText(nf.format(m_layer.getMaxScale()));
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJTabbedPane(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getPbotones(), java.awt.BorderLayout.SOUTH);
		}

		return jContentPane;
	}

	/**
	 * This method initializes jTabbedPane
	 *
	 * @return javax.swing.JTabbedPane
	 */
	private javax.swing.JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new javax.swing.JTabbedPane();
			jTabbedPane.setPreferredSize(new java.awt.Dimension(320,140));
			jTabbedPane.addTab(PluginServices.getText(this, "Hiperenlace"),
				null, getPhiperenlace(), null);
			jTabbedPane.addTab(PluginServices.getText(this, "Visualizacion"),
				null, getPvisualizacion(), null);
		}

		return jTabbedPane;
	}

	/**
	 * This method initializes phiperenlace
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPhiperenlace() {
		if (phiperenlace == null) {
			phiperenlace = new javax.swing.JPanel();
			phiperenlace.setLayout(new java.awt.BorderLayout());
			phiperenlace.setPreferredSize(new java.awt.Dimension(300,150));
			phiperenlace.add(getPhnorte(), java.awt.BorderLayout.NORTH);
			phiperenlace.add(getPhsur(), java.awt.BorderLayout.CENTER);
			phiperenlace.setVisible(true);
		}

		return phiperenlace;
	}

	/**
	 * This method initializes phnorte
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPhnorte() {
		if (phnorte == null) {
			jLabel4 = new JLabel();
			phnorte = new javax.swing.JPanel();
			jLabel4.setText(PluginServices.getText(this,"extension"));
			phnorte.add(getJLabel(), null);
			phnorte.add(getJComboBox(), null);
			phnorte.add(jLabel4, null);
			phnorte.add(getJTextField2(), null);
		}

		return phnorte;
	}

	/**
	 * This method initializes phsur
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPhsur() {
		if (phsur == null) {
			phsur = new javax.swing.JPanel();
			phsur.add(getJLabel1(), null);
			phsur.add(getJComboBox1(), null);
		}

		return phsur;
	}

	/**
	 * This method initializes jLabel
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText(PluginServices.getText(this, "Campo") + "   ");
		}

		return jLabel;
	}

	/**
	 * This method initializes jComboBox
	 *
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBox() {
		if (jComboBox == null) {
			try {
				if (m_layer instanceof AlphanumericData) {
					AlphanumericData layer = (AlphanumericData) m_layer;
					DataSource ds;
					ds = layer.getRecordset();

					String[] names = new String[ds.getFieldCount()];

					for (int i = 0; i < ds.getFieldCount(); i++) {
						names[i] = ds.getFieldName(i);
					}

					jComboBox = new javax.swing.JComboBox(names);

					if (view.getSelectedField() != null) {
						jComboBox.setSelectedItem(view.getSelectedField());
					}
				}else{
					jComboBox = new javax.swing.JComboBox();
				}
			} catch (DriverException e) {
				NotificationManager.addError("No se pudo obtener la tabla", e);
			} catch (com.iver.cit.gvsig.fmap.DriverException e) {
				NotificationManager.addError("No se pudo obtener la tabla", e);
			}
		}

		return jComboBox;
	}

	/**
	 * This method initializes jLabel1
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText(PluginServices.getText(this, "Accion_Predefinida") +
				"  ");
		}

		return jLabel1;
	}

	/**
	 * This method initializes jComboBox1
	 *
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBox1() {
		if (jComboBox1 == null) {
			jComboBox1 = new javax.swing.JComboBox();
			jComboBox1.addItem(PluginServices.getText(this,
					"Enlazar_a_ficheros_de_imagen"));
			jComboBox1.addItem(PluginServices.getText(this,
			"Enlazar_a_fichero_de_texto"));
			if (view.getSelectedField() != null) {
				jComboBox1.setSelectedIndex(view.getTypeLink());
			}
		}

		return jComboBox1;
	}

	/**
	 * This method initializes pbotones
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPbotones() {
		if (pbotones == null) {
			pbotones = new javax.swing.JPanel();
			pbotones.add(getBaceptar(), null);
			pbotones.add(getBcancelar(), null);
		}

		return pbotones;
	}

	/**
	 * This method initializes baceptar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBaceptar() {
		if (baceptar == null) {
			baceptar = new javax.swing.JButton();
			baceptar.setText(PluginServices.getText(this, "Aceptar"));
			baceptar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						view.setTypeLink(jComboBox1.getSelectedIndex());
						if (jComboBox.getSelectedItem()!=null){
						view.setSelectedField((jComboBox.getSelectedItem()).toString()
											   .trim());
						view.setExtLink(getJTextField2().getText());
						}
						try
						{
							m_layer.setMinScale((nf.parse(getTminEscala().getText())).doubleValue());						
						}
						catch (ParseException ex)
						{
						    // No hacemos nada. Si mete algo mal, pasamos de 
						    // lo que haya metido y a otra cosa.
						    if (getTminEscala().getText().compareTo("") == 0)
						        m_layer.setMinScale(-1);
						    else
						        System.err.print(ex.getLocalizedMessage());
						}
						try
						{
						    m_layer.setMaxScale((nf.parse(getTMaxScale().getText())).doubleValue());						
						}
						catch (ParseException ex)
						{
						    if (getTMaxScale().getText().compareTo("") == 0)
						        m_layer.setMaxScale(-1);
						    else
						        System.err.print(ex.getLocalizedMessage());

						}		
						PluginServices.getMDIManager().closeWindow(FThemePropertiesDialog.this);
						m_layer.getMapContext().invalidate();
					}
				});
		}

		return baceptar;
	}

	/**
	 * This method initializes bcancelar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBcancelar() {
		if (bcancelar == null) {
			bcancelar = new javax.swing.JButton();
			bcancelar.setText(PluginServices.getText(this, "Cancelar"));
			bcancelar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						//					View view =(View)App.instance.getMDIContext().getActiveView();
						//view.getMapControl().setTool(MapControl.);
						PluginServices.getMDIManager().closeWindow(FThemePropertiesDialog.this);
					}
				});
		}

		return bcancelar;
	}

	/**
	 * This method initializes pvisualizacion
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPvisualizacion() {
		if (pvisualizacion == null) {
			pvisualizacion = new javax.swing.JPanel();
			pvisualizacion.setLayout(new java.awt.BorderLayout());
			pvisualizacion.setPreferredSize(new java.awt.Dimension(300,60));
			pvisualizacion.add(getPvnorte(), java.awt.BorderLayout.NORTH);
			pvisualizacion.add(getPvCenter(), java.awt.BorderLayout.CENTER);
			pvisualizacion.add(getPvsur(), java.awt.BorderLayout.SOUTH);
		}

		return pvisualizacion;
	}

	/**
	 * This method initializes pvnorte
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPvnorte() {
		if (pvnorte == null) {
			jLabel6 = new JLabel();
			jLabel5 = new JLabel();
			pvnorte = new javax.swing.JPanel();
			jLabel5.setText(m_layer.getName());
			jLabel6.setText("Nombre de la capa : ");
			pvnorte.add(jLabel6, null);
			pvnorte.add(jLabel5, null);
		}

		return pvnorte;
	}

	/**
	 * This method initializes pvsur
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getPvsur() {
		if (pvsur == null) {
			pvsur = new javax.swing.JPanel();
			pvsur.add(getJLabel3(), null);
			pvsur.add(getTMaxScale(), null);
		}

		return pvsur;
	}

	/**
	 * This method initializes jLabel2
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			jLabel2.setText(PluginServices.getText(this, "Escala_Minima") +
				"  1:");
		}

		return jLabel2;
	}

	/**
	 * This method initializes jLabel3
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel3() {
		if (jLabel3 == null) {
			jLabel3 = new javax.swing.JLabel();
			jLabel3.setText(PluginServices.getText(this, "Escala_Maxima") +
				"  1:");
		}

		return jLabel3;
	}

	/**
	 * This method initializes tminEscala
	 *
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getTminEscala() {
		if (tminEscala == null) {
			tminEscala = new javax.swing.JTextField();
			tminEscala.setPreferredSize(new java.awt.Dimension(150, 20));
		}

		return tminEscala;
	}

	/**
	 * This method initializes jTextField1
	 *
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getTMaxScale() {
		if (tMaxScale == null) {
			tMaxScale = new javax.swing.JTextField();
			tMaxScale.setPreferredSize(new java.awt.Dimension(150, 20));
		}

		return tMaxScale;
	}

	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public WindowInfo getWindowInfo() {
		WindowInfo m_viewinfo = new WindowInfo(WindowInfo.MODALDIALOG);
		m_viewinfo.setTitle(PluginServices.getText(this, "propiedades_capa"));

		return m_viewinfo;
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.IWindow#windowActivated()
	 */
	public void viewActivated() {
	}
	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setPreferredSize(new java.awt.Dimension(40,20));
			if (view.getSelectedField() != null) {
				jTextField2.setText(view.getExtLink());
			}
		}
		return jTextField2;
	}
	/**
	 * This method initializes pvCenter	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPvCenter() {
		if (pvCenter == null) {
			pvCenter = new JPanel();
			pvCenter.add(getJLabel2(), null);
			pvCenter.add(getTminEscala(), null);
		}
		return pvCenter;
	}
  } //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
