package com.iver.cit.gvsig.gui.layout;

import java.awt.KeyEventDispatcher;
import java.awt.event.KeyEvent;
import java.awt.geom.Rectangle2D;

import javax.swing.JPanel;
import javax.swing.JTextField;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.gui.layout.fframes.IFFrame;

public class LayoutKeyEvent implements KeyEventDispatcher{
	private static IFFrame[] selectFFrames;
    private int difX;
    private int difY;

	public boolean dispatchKeyEvent(KeyEvent e) {
		IWindow view = PluginServices.getMDIManager().getActiveWindow();

		if (e.getID() == KeyEvent.KEY_PRESSED || !(view instanceof Layout) || e.getSource().getClass()!=JPanel.class)
			return false;
		Layout layout=(Layout)view;
		if (!layout.isEditable())
			return false;
		IFFrame[] fframes = layout.getFFrameSelected();
		int dif = 10;
		if (e.getModifiers() == KeyEvent.CTRL_MASK) {
			switch (e.getKeyCode()) {
			case KeyEvent.VK_C:
				if (fframes.length==0)
					return false;
				selectFFrames = new IFFrame[fframes.length];
				for (int i = 0; i < fframes.length; i++) {
					selectFFrames[i] = fframes[i].cloneFFrame(layout);
				}
				break;
			case KeyEvent.VK_X:
				if (fframes.length==0)
					return false;
				selectFFrames = new IFFrame[fframes.length];
				for (int i = 0; i < fframes.length; i++) {
					selectFFrames[i] = fframes[i].cloneFFrame(layout);
				}
				layout.delFFrameSelected();
				layout.refresh();
				break;
			case KeyEvent.VK_V:
				IFFrame copyFFrame = null;
				layout.getEFS().startComplexCommand();
				for (int i = 0; i < selectFFrames.length; i++) {
					copyFFrame = selectFFrames[i].cloneFFrame(layout);
					if (i == 0)
						layout.addFFrame(copyFFrame, true, true);
					else
						layout.addFFrame(copyFFrame, false, true);
				}
				layout.getEFS().endComplexCommand(
						PluginServices.getText(this, "paste_elements"));
				layout.refresh();
				break;
			case KeyEvent.VK_Z:
				layout.getEFS().undo();
				layout.updateFFrames();
				layout.refresh();
				PluginServices.getMainFrame().enableControls();
				break;
			case KeyEvent.VK_Y:
				layout.getEFS().redo();
				layout.updateFFrames();
				layout.refresh();
				PluginServices.getMainFrame().enableControls();
				break;
			}
		} else {
			switch (e.getKeyCode()) {
			case KeyEvent.VK_LEFT:
				difX = difX - dif;
				break;

			case KeyEvent.VK_RIGHT:
				difX = difX + dif;
				break;
			case KeyEvent.VK_UP:
				difY = difY - dif;
				break;
			case KeyEvent.VK_DOWN:
				difY = difY + dif;
				break;
			case KeyEvent.VK_DELETE:
			case KeyEvent.VK_BACK_SPACE:
				layout.delFFrameSelected();
				layout.refresh();
				break;
			}
			if (e.getKeyCode()==KeyEvent.VK_LEFT || e.getKeyCode()==KeyEvent.VK_RIGHT || e.getKeyCode()==KeyEvent.VK_UP || e.getKeyCode()==KeyEvent.VK_DOWN) {
				if (fframes.length==0)
					return false;
				layout.getEFS().startComplexCommand();
			for (int i = 0; i < fframes.length; i++) {
				IFFrame fframeAux = fframes[i].cloneFFrame(layout);
				Rectangle2D r = getRectMove(fframes[i]
						.getBoundingBox(layout.getAT()), difX, difY);
				fframeAux.setBoundBox(FLayoutUtilities.toSheetRect(r,
						layout.getAT()));
				layout.getEFS().modifyFFrame(fframes[i], fframeAux);
			}
			layout.getEFS().endComplexCommand(
					PluginServices.getText(this, "move_elements"));
			layout.updateFFrames();
			layout.refresh();
			}
			difX = 0;
			difY = 0;

		}
		return true;
	}
	private Rectangle2D getRectMove(Rectangle2D r,int difX,int difY) {
		Rectangle2D rectMove=new Rectangle2D.Double();
		rectMove.setRect(r.getX()+difX,r.getY()+difY,r.getWidth(),r.getHeight());
		return rectMove;
	}

}
