/*
 * Created on 17-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informaci�n Geogr�fica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ib��ez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.panels;

import java.awt.Container;
import java.awt.Event;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.util.ArrayList;
import java.util.Vector;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.filechooser.FileFilter;

import org.cresques.cts.IProjection;
import org.cresques.filter.RasterFilter;
import org.cresques.filter.RasterFilterStackManager;
import org.cresques.filter.BrightnessContrast.BrightnessContrastStackManager;
import org.cresques.io.GeoRasterFile;
import org.cresques.px.Extent;
import org.cresques.ui.BrightnessContrast.EnhancedBrightnessContrastPanel;
import org.cresques.ui.raster.BandSetupPanel;
import org.cresques.ui.raster.FilterRasterDialogPanel;
import org.cresques.ui.raster.InfoPanel;
import org.cresques.ui.raster.RasterTransparencyPanel;

import com.hardcode.driverManager.Driver;
import com.hardcode.driverManager.DriverLoadException;
import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.fmap.drivers.RasterDriver;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.fmap.layers.LayerFactory;
import com.iver.cit.gvsig.fmap.layers.StatusLayerRaster;

/**
 * <P>
 * Dialogo para las propiedades de un raster. Esta maneja los eventos y aplica
 * filtros sobre el raster a travs de l gestor de la pila de filtros seg�n la
 * seleccin del usuario. Este dialogo contiene varios paneles:
 * </P>
 * <UL>
 * <LI>Propiedades</LI>
 * <LI>Seleccin de bandas</LI>
 * <LI>Transparencia</LI>
 * <LI>Realce</LI>
 * </UL>
 * @author Nacho Brodin <brodin_ign@gva.es>
 */
public class PropertiesRasterDialog extends FilterRasterDialogPanel implements IWindow, MouseListener, ActionListener, FocusListener{

	private JPanel									propPanel = null;
	private IProjection 							currentProjection = null;
	private FLyrRaster	 							fLayer = null;
	private static final int						nprops = 13;
	private Object[][]								props = null;
	private RasterFilterStackManager 				stackManager = null;
	private Status									status = null;
	private String 									filename = null;
	private	long 									filesize = 0;
	private	int 									width = 0;
	private	int 									height = 0;
	private JFileChooser							fileChooser = null;
	private String									lastPath = new String("./");
	private StatusLayerRaster						rasterStatus = null;
	private int										sizeX = 486, sizeY = 352;

	/**
	 * Clase que guarda el estado del dialogo y gestiona la restauraci�n
	 * del estado inicial en caso de cancelar.
	 * @author Nacho Brodin <brodin_ign@gva.es>
	 */
	class Status{
		public String					inicAlpha;
		public int 						bandR;
		public int 						bandG;
		public int 						bandB;
		private ArrayList				filesAdd = new ArrayList();
		private ArrayList				filesRem = new ArrayList();
		private ArrayList				filters = null;


		public Status(String alpha, int bandR, int bandG, int bandB){
			this.inicAlpha = alpha;
			this.bandR = bandR;
			this.bandG = bandG;
			this.bandB = bandB;
			filters = stackManager.getStringsFromStack();
		}

		/**
		 * Aade un fichero  a la lista de a�adidos. Si estaba en la de eliminados
		 * lo quitamos.
		 * @param file Fichero a�adido
		 */
		public void addFile(String file){
			filesAdd.add(file);
			for(int j=0;j<filesRem.size();j++){
				if(file.equals((String)filesRem.get(j)))
						filesRem.remove(j);
			}

		}

		/**
		 * Elimina un fichero de la lista de a�adidos si ha sido a�adido. Si ya estaba
		 * antes no estar� en la lista de a�adidos por lo que habr� que ponerlo en la
		 * lista de eliminados.
		 * @param file	Fichero eliminado
		 */
		public void removeFile(String file){
			boolean isAdd = false;
			for(int i=0;i<filesAdd.size();i++){
				if(((String)filesAdd.get(i)).equals(file)){
					filesAdd.remove(i);
					isAdd =  true;
				}
			}
			if(!isAdd)
				filesRem.add(file);

		}

		/**
		 * Restaura el Estado salvado
		 * @param status Estado
		 */
		public void restoreStatus(PropertiesRasterDialog props){
			//Devolvemos la pila de filtros al estado inicial
			//if(stackManager != null)
			//	stackManager.deleteTempFilters();

			//Devolvemos el alpha al estado inicial
			int opac = Integer.parseInt(status.inicAlpha);
			opac = (int)((opac*255)/100);
			fLayer.getSource().setTransparency(true);
			fLayer.setTransparency(255-opac);
			rasterStatus.transparency = 255-opac;

			//Devolvemos el estado inicial de las bandas

			if (fLayer != null) {
				fLayer.getSource().setBand(GeoRasterFile.RED_BAND, status.bandR);
				fLayer.getSource().setBand(GeoRasterFile.GREEN_BAND, status.bandG);
				fLayer.getSource().setBand(GeoRasterFile.BLUE_BAND, status.bandB);
				rasterStatus.bandR = status.bandR;
				rasterStatus.bandG = status.bandG;
				rasterStatus.bandB = status.bandB;
			}


			//Los que han sido a�adidos los quitamos
			for(int i=0;i<filesAdd.size();i++)
				fLayer.delFile((String)this.filesAdd.get(i));

			//Los que fueron quitados los a�adimos
			for(int i=0;i<filesRem.size();i++)
				fLayer.addFiles((String)this.filesRem.get(i));

			//Restauramos los filtros
			if(filters!=null && ((FLyrRaster)fLayer).getSource().getFiles() != null)
				stackManager.createStackFromStrings(filters, ((FLyrRaster)fLayer).getSource().getFiles());

			fLayer.getMapContext().invalidate();
			//this.show();
		}

		public void show(){
			System.out.println("***Lista A�adidos***");
			for(int i=0;i<filesAdd.size();i++){
				System.out.println(filesAdd.get(i).toString());
			}
			System.out.println("***Lista Eliminados***");
			for(int i=0;i<filesRem.size();i++){
				System.out.println(filesRem.get(i).toString());
			}
			System.out.println("*********************");
		}

	}

	public class DriverFileFilter extends FileFilter{

		private Driver driver;

		public DriverFileFilter(String driverName) throws DriverLoadException{
			driver = LayerFactory.getDM().getDriver(driverName);
		}

		/**
		 * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
		 */
		public boolean accept(File f) {
			if (f.isDirectory()) return true;
			if (driver instanceof RasterDriver){
				return ((RasterDriver) driver).fileAccepted(f);
			}else{
				throw new RuntimeException("Tipo no reconocido");
			}
		}

		/**
		 * @see javax.swing.filechooser.FileFilter#getDescription()
		 */
		public String getDescription() {
			return ((Driver) driver).getName();
		}
	}

	/**
	 * Inicializador de valores de la ventana de dialogo.
	 * @param app
	 */
	public PropertiesRasterDialog(FLyrRaster layer, ArrayList ranges){
		fLayer = layer;
		if(fLayer.getStatus()==null){
			rasterStatus = new StatusLayerRaster();
			fLayer.setStatus(rasterStatus);
		}else
			rasterStatus = (StatusLayerRaster)fLayer.getStatus();
		init();
		this.setRanges(ranges);
		setTranslation();

		EnhancedBrightnessContrastPanel ep = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");
		ep.lstBrightness.getJSlider().addMouseListener(this);
		ep.lstContrast.getJSlider().addMouseListener(this);
		ep.getCheckSliderText().getJTextField().addKeyListener(this);
		ep.lstBrightness.getJTextField().addActionListener(this);
		ep.lstContrast.getJTextField().addActionListener(this);
		ep.lstBrightness.getJTextField().addFocusListener(this);
		ep.lstContrast.getJTextField().addFocusListener(this);
	}

	/**
	 * Asigna los textos a los paneles
	 */
	private void setTranslation(){
		BandSetupPanel bandSetup = (BandSetupPanel)super.getPanelByClassName("BandSetupPanel");

		bandSetup.getFileList().getJButtonAdd().setText(PluginServices.getText(this,"Anadir"));
		bandSetup.getFileList().getJButtonRemove().setText(PluginServices.getText(this,"Eliminar"));
		bandSetup.getFileList().lbandasVisibles.setText(PluginServices.getText(this,"bandas"));

		RasterTransparencyPanel tpan = (RasterTransparencyPanel)super.getPanelByClassName("RasterTransparencyPanel");

		tpan.getTransparencyCheck().setText(PluginServices.getText(this,"activar"));
		tpan.getPTransparencyByPixel().setBorder(javax.swing.BorderFactory.createTitledBorder(null, PluginServices.getText(this,"transparencia_pixel"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		tpan.getOpacityCheck().setText(PluginServices.getText(this,"activar"));
		tpan.getOpacityPanel().setBorder(javax.swing.BorderFactory.createTitledBorder(null, PluginServices.getText(this,"opacidad"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));


		EnhancedBrightnessContrastPanel ep = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");

		ep.lLineal.setText(PluginServices.getText(this, "lineal_directo"));
		ep.lRemove.setText(PluginServices.getText(this, "eliminar_extremos"));
		ep.cstEnhanced.setName(PluginServices.getText(this, "recorte_colas")+" ( % )");
		ep.lBrightC.setText(PluginServices.getText(this, "brillo_y_contraste"));
		ep.lstBrightness.setName(PluginServices.getText(this, "brillo"));
		ep.lstContrast.setName(PluginServices.getText(this, "contraste"));
		ep.lpreview.setText(PluginServices.getText(this, "previsualizacion"));
		ep.getPBrightCont().setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1), (PluginServices.getText(this, "brillo_y_contraste")), javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, java.awt.Color.black));
		ep.getPEnhanced().setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1), (PluginServices.getText(this, "realce")), javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, java.awt.Color.black));

		InfoPanel ip = (InfoPanel)super.getPanelByClassName("InfoPanel");

		ip.cabInfo = new String(PluginServices.getText(this, "Informacion"));
		ip.cabCoord = new String(PluginServices.getText(this, "coor_geograficas"));
		ip.cabProy = new String(PluginServices.getText(this, "Proyecciones"));
		ip.cabOrig = new String(PluginServices.getText(this, "origen_de_datos"));
		ip.cabMeta = new String(PluginServices.getText(this, "metadatos"));

		//Recorremos los Tab y traducimos el nombre
		for(int i=0;i<this.getTab().getTabCount();i++){
			if(this.getTab().getTitleAt(i).equals("Info"))
				this.getTab().setTitleAt(i,PluginServices.getText(this,"info"));
			if(this.getTab().getTitleAt(i).equals("Transparencia"))
				this.getTab().setTitleAt(i,PluginServices.getText(this,"Transparencia"));
			if(this.getTab().getTitleAt(i).equals("Bandas"))
				this.getTab().setTitleAt(i,PluginServices.getText(this,"bandas"));
			if(this.getTab().getTitleAt(i).equals("Realce"))
				this.getTab().setTitleAt(i,PluginServices.getText(this,"realce"));
		}

		this.getAcceptButton().setText(PluginServices.getText(this,"Aceptar"));
		this.getApplyButton().setText(PluginServices.getText(this,"Aplicar"));
		this.getCancelButton().setText(PluginServices.getText(this,"Cancelar"));
	}

	/**
	 * Asigna un FLayerRaster
	 * @param layer	capa a asignar
	 */
	public void setFLyrRaster(FLyrRaster layer){
		fLayer = layer;
	}



	/**
	 * Carga los datos del panel info.
	 */
	private void loadInfoData(){
		if(fLayer.getSource()!=null){
			props = new Object[nprops][2];
			props[0][0] = new String(PluginServices.getText(this,"Fichero")+":");
			props[0][1] = filename;
			props[1][0] = new String(PluginServices.getText(this,"tamano")+":");
			props[1][1] = new String(String.valueOf(this.filesize)+" bytes");
			props[2][0] = new String(PluginServices.getText(this,"ancho_alto")+":");
			props[2][1] = this.width+" , "+this.height;
			props[3][0] = new String(PluginServices.getText(this,"formato")+":");
			props[3][1] = filename.substring(
						filename.lastIndexOf('.')+1,
						filename.length());
			props[4][0] = new String(PluginServices.getText(this,"tipo_dato")+":");
			String type = null;
			switch(fLayer.getSource().getDataType()){
				case 0: type = new String("BYTE");break;
				case 1: type = new String("USHORT");break;
				case 2: type = new String("SHORT");break;
				case 3: type = new String("INT");break;
				case 4: type = new String("FLOAT");break;
				case 5: type = new String("DOUBLE");break;
				default: type = new String("UNDEFINED");break;
			}
		    props[4][1] = type;
		    props[4][0] = new String(PluginServices.getText(this, "georeferenciado")+":");
		    if(fLayer.isGeoreferenced()) props[4][1] = new String(PluginServices.getText(this, "si"));
		    else props[4][1] = new String(PluginServices.getText(this, "no"));
		    props[5][0] = new String(PluginServices.getText(this,"num_bandas")+":");
			props[5][1] = new String(String.valueOf(fLayer.getSource().getNumBands()));
		    props[6][0] = new String(PluginServices.getText(this,"coor_geograficas"));
			props[7][0] = new String(PluginServices.getText(this,"xmin")+":");
			props[7][1] = String.valueOf(fLayer.getSource().getFullExtent().getMinX());
			props[8][0] = new String(PluginServices.getText(this,"ymin")+":");
			props[8][1] = String.valueOf(fLayer.getSource().getFullExtent().getMinY());
			props[9][0] = new String(PluginServices.getText(this,"xmax")+":");
			props[9][1] = String.valueOf(fLayer.getSource().getFullExtent().getMaxX());
			props[10][0] = new String(PluginServices.getText(this,"ymax")+":");
			props[10][1] = String.valueOf(fLayer.getSource().getFullExtent().getMaxY());

			double tamRealX = fLayer.getSource().getFullExtent().getMaxX()-fLayer.getSource().getFullExtent().getMinX();
			double tamRealY = fLayer.getSource().getFullExtent().getMaxY()-fLayer.getSource().getFullExtent().getMinY();
			double tamX = Math.round((tamRealX/this.width)*10000000);
			double tamY = Math.round((tamRealY/this.height)*10000000);

			String tamPixX = String.valueOf(tamX/10000000);
			String tamPixY = String.valueOf(tamY/10000000);

			props[11][0] = new String(PluginServices.getText(this, "tamPixX"));
			props[11][1] = tamPixX + " " + new String(PluginServices.getText(this, "m/pixel"));
			props[12][0] = new String(PluginServices.getText(this, "tamPixY"));
			props[12][1] = tamPixY + " " + new String(PluginServices.getText(this, "m/pixel"));

			if(!fLayer.isGeoreferenced()){
				props[11][1] = "-";
				props[12][1] = "-";
			}

		}else{
			props = new Object[1][2];
			props[0][0] = new String("No props");
			props[0][1] = new String("-");
		}

	}

	/**
	 * A�ade bandas al contador de bandas del FilterRasterDialogPanel
	 * @param numBands N�mero de bandas a a�adir
	 */
	public void addNumBands(int numBands){
		nbands += numBands;
		RasterTransparencyPanel tpan = (RasterTransparencyPanel)super.getPanelByClassName("RasterTransparencyPanel");
		if(tpan != null && tpan.getPTranspByPixel().isControlEnabled())
			tpan.setActiveTransparencyControl(true);
	}

	/**
	 * Inicializa el jDialog
	 */
	public void init() {

		//this.setLayout(new FlowLayout());

		setName("filterRaster");
		ArrayList attr = ((FLyrRaster)fLayer).getSource().getAttributes();
   		for (int i=0; i<attr.size(); i++) {
			Object[] a = (Object []) attr.get(i);
			if(a[0].toString().equals("Filename"))
				filename = a[1].toString();
			if(a[0].toString().equals("Filesize"))
				filesize = ((Long)a[1]).intValue();
			if(a[0].toString().equals("Width"))
				width = ((Integer)a[1]).intValue();
			if(a[0].toString().equals("Height"))
				height = ((Integer)a[1]).intValue();
		}

   		this.loadInfoData();
		super.init(props);

		InfoPanel info = (InfoPanel)super.getPanelByClassName("InfoPanel");
		info.columnNames[0] = PluginServices.getText(this,"propiedad");
		info.columnNames[1] = PluginServices.getText(this,"Valor");
		//info.resetTable();
		//info.initialize();

		//this.add(getContentPane());

		this.setSize(this.sizeX, this.sizeY);

		//contentPane.getAcceptButton().setEnabled(false);
		this.getAcceptButton().addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				acceptButtonActionPerformed(evt);
				//Solo cuando le damos a aceptar guardamos la situaci�n actual de los
				//ficheros cargados en el StatusLayerRaster
				if(rasterStatus!=null){
					ArrayList rs = new ArrayList();
					for(int i=0;i<fLayer.getSource().getFiles().length;i++)
						rs.add(fLayer.getSource().getFiles()[i].getName());
					rasterStatus.files = rs;
				}
				closeJDialog();
			}
		});
		this.getCancelButton().addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
				closeJDialog();
			}
		});
		this.getApplyButton().addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				acceptButtonActionPerformed(evt);
			}
		});
		BandSetupPanel bandSetup = (BandSetupPanel)super.getPanelByClassName("BandSetupPanel");
		bandSetup.getFileList().getJButtonAdd().addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt){
				addFileBand(evt);

			}
		});
		bandSetup.getFileList().getJButtonRemove().addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt){
				delFileBand(evt);
			}
		});

	}

	/**
	 * Salva el estado inicial por si se cancela
	 */
	public void readStat(){
		RasterTransparencyPanel tpan = (RasterTransparencyPanel)super.getPanelByClassName("RasterTransparencyPanel");
		status = new Status(tpan.getOpacityText().getText(),
							getAssignedBand(GeoRasterFile.RED_BAND),
							getAssignedBand(GeoRasterFile.GREEN_BAND),
							getAssignedBand(GeoRasterFile.BLUE_BAND));
	}

	/**
	 * This method initializes jContentPane
	 */
	public Container getContentPane() {
		return this;
	}

	/**
	 * Asigna una proyecci�n
	 * @param prj
	 */
	public void setProjection(IProjection prj) {
		this.currentProjection = prj;
	}

	public void closeJDialog() {
		try{
			PluginServices.getMDIManager().closeWindow(PropertiesRasterDialog.this);
		}catch(ArrayIndexOutOfBoundsException e){
			//Si la ventana no se puede eliminar no hacemos nada
		}
	}

	/**
	 * Asigna el RasterFilterStackManager
	 * @param stackManager
	 */
	public void setRasterFilterStackManager(RasterFilterStackManager stackManager){
		this.stackManager = stackManager;
		stackManager.resetTempFilters();
	}

	/**
	 *
	 * @param flag
	 * @return
	 */
	public int getAssignedBand(int flag) {
		BandSetupPanel bandSetup = (BandSetupPanel)super.getPanelByClassName("BandSetupPanel");
		return bandSetup.getAssignedBand(flag);
	}

	/**
	 * Obtiene las bandas que el usuario ha seleccionado que son visibles.
	 * Devuelve una cadena: RGB, R, G, B, RG, RB, GB
	 * @return Bandas visibles
	 */
	public String getVisibleBands(){
		BandSetupPanel bandSetup = (BandSetupPanel)super.getPanelByClassName("BandSetupPanel");
		return bandSetup.getFileList().getJComboBox().getSelectedItem().toString();
	}

	/**
	 * Pulsar aceptar con el panel de bandas seleccionado hace que se procesen los valores
	 * introducidos en este.
	 * @return true si estaba seleccionado el panel de bandas y se ha procesado la
	 * acci�n y false si no lo estaba.
	 */
	public void processBandPanel(){
		//if(this.getTab().getSelectedComponent() == this.getBandSetup()){
		fLayer.getSource().setBand(GeoRasterFile.RED_BAND,
					getAssignedBand(GeoRasterFile.RED_BAND));
		fLayer.getSource().setBand(GeoRasterFile.GREEN_BAND,
					getAssignedBand(GeoRasterFile.GREEN_BAND));
		fLayer.getSource().setBand(GeoRasterFile.BLUE_BAND,
					getAssignedBand(GeoRasterFile.BLUE_BAND));
		rasterStatus.bandR = getAssignedBand(GeoRasterFile.RED_BAND);
		rasterStatus.bandG = getAssignedBand(GeoRasterFile.GREEN_BAND);
		rasterStatus.bandB = getAssignedBand(GeoRasterFile.BLUE_BAND);

		//Comprobamos si hay alguna banda que no est� asignada y aplicamos el filtro
		StringBuffer sb = new StringBuffer();
		if(getAssignedBand(GeoRasterFile.RED_BAND) == -1)
			sb.append("R");
		if(getAssignedBand(GeoRasterFile.GREEN_BAND) == -1)
			sb.append("G");
		if(getAssignedBand(GeoRasterFile.BLUE_BAND) == -1)
			sb.append("B");

		if(!sb.toString().equals(""))
			stackManager.addRemoveBands(sb.toString());
		else
			stackManager.removeFilter(stackManager.getTypeFilter("removebands"));

		//Al reasignar las bandas tenemos que tenerlo en cuenta en el sharpening
		RasterFilter sharp = stackManager.getFilter("sharpening");
		if(sharp != null){
			int[] order = {getAssignedBand(GeoRasterFile.RED_BAND),getAssignedBand(GeoRasterFile.GREEN_BAND),getAssignedBand(GeoRasterFile.BLUE_BAND)};
			sharp.removeParam("order");
			sharp.addParam("order", order);
		}
		fLayer.getMapContext().invalidate();

		InfoPanel pInfo = (InfoPanel)super.getPanelByClassName("InfoPanel");
		pInfo.setBands(getAssignedBand(GeoRasterFile.RED_BAND),getAssignedBand(GeoRasterFile.GREEN_BAND),getAssignedBand(GeoRasterFile.BLUE_BAND));
	}

	/**
	 * Pulsar aceptar con el panel de transparecias seleccionado hace que se procesen los valores
	 * introducidos en este.
	 * @return true si estaba seleccionado el panel de transparencias y se ha procesado la
	 * acci�n y false si no lo estaba.
	 */
	public void processTransparencyPanel(){
		//OPACIDAD
		RasterTransparencyPanel tpan = (RasterTransparencyPanel)super.getPanelByClassName("RasterTransparencyPanel");
		String sOpac = tpan.getOpacityText().getText();
		if(!sOpac.equals("") && tpan.getOpacityCheck().isSelected()){
			int opac = Integer.parseInt(sOpac);
			opac = (int)((opac*255)/100);
			fLayer.getSource().setTransparency(true);
			fLayer.setTransparency(255-opac);
			rasterStatus.transparency = 255-opac;
		}else{
			fLayer.getSource().setTransparency(false);
			fLayer.setTransparency(0);
			rasterStatus.transparency = 0;
		}

		//TRANSPARENCIA
		if(	tpan.getTransparencyCheck().isSelected()){
			stackManager.addTransparencyFilter(	tpan.getPTranspByPixel().getEntries(),
												0x10,	//Transparencia
												0xff,	//Color Transparencia R
												0xff,	//Color Transparencia G
												0xff);	//Color Transparencia B
		}else{
			fLayer.getSource().getFilterStack().removeFilter(stackManager.getTypeFilter("transparency"));
		}

	}

	private void processBrightnessContrastPanel(){
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");
		// Si est� activo el panel de brillo y contraste tomamos los valores y cargamos un filtro de
		// brillo y contraste

		BrightnessContrastStackManager bcStackManager = (BrightnessContrastStackManager)stackManager.getManagerByClass(BrightnessContrastStackManager.class);
		if(ebcPanel.getCBrightC().isSelected()){
			int incrBrillo = (int)Math.round(Double.valueOf(ebcPanel.lstBrightness.getTextValue()).doubleValue());
			int incrContraste = (int)Math.round(Double.valueOf(ebcPanel.lstContrast.getTextValue()).doubleValue());
			bcStackManager.addBrightnessFilter(incrBrillo);
			bcStackManager.addContrastFilter(incrContraste);

			if(incrBrillo == 0) stackManager.removeFilter(bcStackManager.brightness);
			if(incrContraste == 0) stackManager.removeFilter(bcStackManager.contrast);

		}else{
			stackManager.removeFilter(bcStackManager.brightness);
			stackManager.removeFilter(bcStackManager.contrast);
		}
		fLayer.getMapContext().invalidate();
	}

	/**
	 * Pulsar aceptar con el panel de realce seleccionado hace que se procesen los valores
	 * introducidos en este.
	 * @return true si estaba seleccionado el panel de realce y se ha procesado la
	 * acci�n y false si no lo estaba.
	 */
	public void processEnhancedPanel(){
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");

		//Filtro de realce lineal seleccionado
		if(ebcPanel.getCEnhanced().isSelected()){
			if((ebcPanel.getJCheckBox().isSelected()) && (!ebcPanel.getCheckSliderText().getJCheckBox().isSelected()))
				stackManager.addEnhancedFilter(true, fLayer.getSource().getFiles()[0].getName());
			else
				stackManager.addEnhancedFilter(false, fLayer.getSource().getFiles()[0].getName());

			//Recorte de colas seleccionado
			if(ebcPanel.getCheckSliderText().getJCheckBox().isSelected()){
				stackManager.removeFilter(stackManager.getTypeFilter("computeminmax"));
				double recorte = Double.parseDouble(ebcPanel.getCheckSliderText().getTextValue())/100;
				if(ebcPanel.getJCheckBox().isSelected())
					stackManager.addTailFilter(recorte, 0D, true);
				else
					stackManager.addTailFilter(recorte, 0D, false);
			}else{
				stackManager.removeFilter(stackManager.getTypeFilter("tail"));
				stackManager.addComputeMinMaxFilter();
			}

		}
		// Sin filtro lineal seleccionado
		if(!ebcPanel.getCEnhanced().isSelected()){
			stackManager.removeFilter(stackManager.getTypeFilter("computeminmax"));
			stackManager.removeFilter(stackManager.getTypeFilter("tail"));
			stackManager.removeFilter(stackManager.getTypeFilter("enhanced"));
		}
		fLayer.getMapContext().invalidate();
	}

	/**
	 * Gestiona la acci�n cuando se pulsa aplicar/aceptar o aplicar en el control
	 * de propiedades de raster
	 * @param e
	 */
	public void acceptButtonActionPerformed(ActionEvent e) {
		this.processBandPanel();
		this.processTransparencyPanel();
		this.processBrightnessContrastPanel();
		this.processEnhancedPanel();

		//Pasamos por todos los tabs registrados ejecutando su actionPerformed
		for(int i=0;i<super.getTab().getTabCount() ;i++){
			JPanel p = (JPanel)super.getTab().getComponentAt(i);
			if(p instanceof IRasterPropertiesRegistrable)
				((IRasterPropertiesRegistrable)p).actionPerformed(stackManager, this, fLayer);
    	}
	}

	/**
	 * A�ade una banda al raster
	 * @param e
	 */
	private void addFileBand(ActionEvent e){
		String[] driverNames = null;

		//Creaci�n del dialogo para selecci�n de ficheros

		fileChooser = new JFileChooser(lastPath);
		fileChooser.setMultiSelectionEnabled(true);
		fileChooser.setAcceptAllFileFilterUsed(false);
        try {
			driverNames = LayerFactory.getDM().getDriverNames();
			FileFilter auxF;
			for (int i = 0; i < driverNames.length; i++) {

				if (driverNames[i].endsWith("gvSIG Image Driver")){
				    auxF = new DriverFileFilter(driverNames[i]);
					fileChooser.addChoosableFileFilter(auxF);
				}
			}
		} catch (DriverLoadException e1) {
			NotificationManager.addError("No se pudo acceder a los drivers", e1);
		}
		int result = fileChooser.showOpenDialog(PropertiesRasterDialog.this);

		if(result == JFileChooser.APPROVE_OPTION){
			File[] files = fileChooser.getSelectedFiles();

		 	BandSetupPanel bandSetup = (BandSetupPanel)super.getPanelByClassName("BandSetupPanel");
		 	lastPath = files[0].getPath();

		 	//Lo a�adimos a la capa si no esta

		 	Vector v = new Vector();
            for(int i=0;i<files.length;i++){

            	//Comprobamos que el fichero no est�
            	boolean exist = false;
            	for(int j=0;j<fLayer.getSource().getFiles().length;j++){
            		if(fLayer.getSource().getFiles()[j].getName().endsWith(files[i].getName()))
            			exist = true;
            	}
            	if(!exist){
            		try{
            			Rectangle2D extentOrigin = fLayer.getFullExtent();

            			GeoRasterFile geoRasterFile = GeoRasterFile.openFile(fLayer.getProjection(), files[i].getAbsolutePath());
            			Extent extentNewFile = geoRasterFile.getExtent();
            			nbands += geoRasterFile.getBandCount();

						//Comprobamos que el extent y tama�o del fichero a�adido sea igual al
						//fichero original. Si no es as� no abrimos la capa y mostramos un aviso

            			double widthNewFile = (extentNewFile.getMax().getX()-extentNewFile.getMin().getX());
            			double heightNewFile = (extentNewFile.getMax().getY()-extentNewFile.getMin().getY());

            			if( (widthNewFile-extentOrigin.getWidth()) > 1.0 ||
            				(widthNewFile-extentOrigin.getWidth()) < -1.0 ||
            				(heightNewFile-extentOrigin.getHeight()) > 1.0 ||
            				(heightNewFile-extentOrigin.getHeight()) < -1.0){
            				JOptionPane.showMessageDialog(	null,
            												PluginServices.getText(this, "extents_no_coincidentes"),
															"",
															JOptionPane.ERROR_MESSAGE);
            				return;
            			}

            			if(	(extentNewFile.getMax().getX()-extentNewFile.getMin().getX())!=extentOrigin.getWidth() ||
								(extentNewFile.getMax().getY()-extentNewFile.getMin().getY())!=extentOrigin.getHeight()	){
            				JOptionPane.showMessageDialog(null,
									PluginServices.getText(this, "extents_no_coincidentes"), "", JOptionPane.ERROR_MESSAGE);
							return;
            			}

            		}catch(Exception exc){
            			exc.printStackTrace();
            		}

            		//Lo a�adimos a la capa
            		fLayer.addFiles(files[i].getAbsolutePath());
            		//Mantiene la lista de ficheros a�adidos por si se cancela
            		status.addFile(files[i].getAbsolutePath());


            	}else{
            		JOptionPane.showMessageDialog(null,
							PluginServices.getText(this, "fichero_existe")+" "+files[i].getAbsolutePath(), "", JOptionPane.ERROR_MESSAGE);
            	}
            }

            //A�adimos los georasterfile a la tabla del Panel

            v = new Vector();
            Vector vInfo = new Vector();
            for(int i=0;i<fLayer.getSource().getFiles().length;i++){
            	boolean exist = false;
            	for(int j=0;j<bandSetup.getNBands();j++){
            		if(fLayer.getSource().getFiles()[i].getName().endsWith(bandSetup.getBandName(j)))
            			exist = true;
            	}
            	if(!exist)
            		v.add(fLayer.getSource().getFiles()[i]);
            	vInfo.add(fLayer.getSource().getFiles()[i]);
            }

            grf = new GeoRasterFile[v.size()];
            for(int i=0;i<grf.length;i++){
            	grf[i] = (GeoRasterFile)v.get(i);
            }
            GeoRasterFile[] infoGrf = new GeoRasterFile[vInfo.size()];
            for(int i = 0; i<infoGrf.length ; i++){
            	infoGrf[i] = (GeoRasterFile)vInfo.get(i);
            }

            this.addFiles(grf);
            this.addInfoFiles(infoGrf);
		}
	}

	/**
	 * Asigna la lista de GeoRasterFile
	 * @return
	 */
	public void setGeoRasterFile(GeoRasterFile[] grf){
		this.grf = grf;
	}

	/**
	 * Elimina una banda del raster. Si queda solo un fichero o no se ha
	 * seleccionado ninguna banda no hace nada.
	 * @param e
	 */
	private void delFileBand(ActionEvent e){
		BandSetupPanel bandSetup = (BandSetupPanel)super.getPanelByClassName("BandSetupPanel");

		if(	bandSetup.getFileList().getJList().getSelectedValue()!=null &&
			bandSetup.getFileList().getNFiles() > 1){
			String pathName = bandSetup.getFileList().getJList().getSelectedValue().toString();
			GeoRasterFile geoRasterFile = GeoRasterFile.openFile(fLayer.getProjection(), pathName);
			nbands -= geoRasterFile.getBandCount();
			fLayer.delFile(pathName);
			String file = pathName.substring(pathName.lastIndexOf("/")+1);
			file = file.substring(file.lastIndexOf("\\")+1);
			this.removeFile(file);

			//Mantiene la lista de ficheros eliminados por si se cancela
			status.removeFile(pathName);
		}

		Vector vInfo = new Vector();
        for(int i=0;i<fLayer.getSource().getFiles().length;i++){
        	vInfo.add(fLayer.getSource().getFiles()[i]);
        }

		GeoRasterFile[] infoGrf = new GeoRasterFile[vInfo.size()];
        for(int i = 0; i<infoGrf.length ; i++){
        	infoGrf[i] = (GeoRasterFile)vInfo.get(i);
        }

        this.addInfoFiles(infoGrf);

	}

	/**
	 * El bot�n de cancelar recupera el estado anterior a la apertura de
	 * este dialogo.
	 * @param e	Evento
	 */
	private void cancelButtonActionPerformed(ActionEvent e) {
		this.status.restoreStatus(this);
		fLayer.getMapContext().invalidate();
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.IWindow#getWindowInfo()
	 */
	public WindowInfo getWindowInfo() {
		WindowInfo m_viewinfo=new WindowInfo(WindowInfo.MODALDIALOG | WindowInfo.RESIZABLE);
    		m_viewinfo.setTitle(PluginServices.getText(this, "propiedades_raster"));
		return m_viewinfo;
	}

	/**
	 * Devuelve el stackManager que se esta utilizando actualmente.
	 * @return stackManager.
	 */
	public RasterFilterStackManager getStackManager(){
		return this.stackManager;
	}

	/**
	 * Devuelve el layer que se est� utilizando actualmente
	 * @return FLyrRaster actual.
	 */
	public FLyrRaster getFLyrRaster(){
		return this.fLayer;
	}

	//********************************************************************
	//***********************EVENTOS DE RAT�N*****************************

	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mouseReleased(MouseEvent e) {
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");
		if (((e.getSource() == ebcPanel.lstBrightness.getJSlider()) || (e.getSource() == ebcPanel.lstContrast.getJSlider())) &&
			 (ebcPanel.getJCheckBox1().isSelected() == true))
			processBrightnessContrastPanel();
	}

	/*public void keyPressed(KeyEvent e) {
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");
		if(e.getSource() == ebcPanel.getCheckSliderText().getJTextField()){
			ebcPanel.getCheckSliderText().getJSlider().setValue((int) Math.round(Double.valueOf(ebcPanel.getCheckSliderText().getTextValue()).doubleValue()));
		}

	}

	public void keyReleased(KeyEvent e) {
		// TODO Auto-generated method stub

	}

	public void keyTyped(KeyEvent e) {
		// TODO Auto-generated method stub

	}*/

	public void brightnessContrastPreview(Event e){

	}

	public void actionPerformed(ActionEvent e){
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");

		ebcPanel.getLabelSliderText().actionPerformed(e);
		ebcPanel.getLabelSliderText1().actionPerformed(e);

		if((e.getSource() == ebcPanel.getLabelSliderText().getJTextField()))
			if(ebcPanel.getJCheckBox1().isSelected()){
				int valor = Math.round(Float.parseFloat(ebcPanel.getLabelSliderText().getJTextField().getText()));
				if((valor > ebcPanel.getLabelSliderText().getJSlider().getMaximum()))
					ebcPanel.getLabelSliderText().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMaximum()));
				if((valor < ebcPanel.getLabelSliderText().getJSlider().getMinimum()))
					ebcPanel.getLabelSliderText().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMinimum()));
				processBrightnessContrastPanel();
			}

		if((e.getSource() == ebcPanel.getLabelSliderText1().getJTextField()))
			if(ebcPanel.getJCheckBox1().isSelected()){
				int valor1 = Math.round(Float.parseFloat(ebcPanel.getLabelSliderText1().getJTextField().getText()));
				if((valor1 > ebcPanel.getLabelSliderText1().getJSlider().getMaximum()))
					ebcPanel.getLabelSliderText1().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMaximum()));
				if((valor1 < ebcPanel.getLabelSliderText1().getJSlider().getMinimum()))
					ebcPanel.getLabelSliderText1().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMinimum()));
				processBrightnessContrastPanel();
			}
	}

	public void focusLost(FocusEvent e) {
		EnhancedBrightnessContrastPanel ebcPanel = (EnhancedBrightnessContrastPanel)super.getPanelByClassName("EnhancedBrightnessContrastPanel");

		if((e.getSource() == ebcPanel.getLabelSliderText().getJTextField()))
			if(ebcPanel.getJCheckBox1().isSelected()){
				int valor = Math.round(Float.parseFloat(ebcPanel.getLabelSliderText().getJTextField().getText()));
				if((valor > ebcPanel.getLabelSliderText().getJSlider().getMaximum()))
					ebcPanel.getLabelSliderText().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMaximum()));
				if((valor < ebcPanel.getLabelSliderText().getJSlider().getMinimum()))
					ebcPanel.getLabelSliderText().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMinimum()));
				processBrightnessContrastPanel();
			}

		if((e.getSource() == ebcPanel.getLabelSliderText1().getJTextField()))
			if(ebcPanel.getJCheckBox1().isSelected()){
				int valor1 = Math.round(Float.parseFloat(ebcPanel.getLabelSliderText1().getJTextField().getText()));
				if((valor1 > ebcPanel.getLabelSliderText1().getJSlider().getMaximum()))
					ebcPanel.getLabelSliderText1().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMaximum()));
				if((valor1 < ebcPanel.getLabelSliderText1().getJSlider().getMinimum()))
					ebcPanel.getLabelSliderText1().getJTextField().setText(String.valueOf(ebcPanel.getLabelSliderText().getJSlider().getMinimum()));
				processBrightnessContrastPanel();
			}
		super.focusLost(e);
	}

}

