/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/* CVS MESSAGES:
*
* $Id: ViewPage.java,v 1.4.4.2 2006/09/29 14:12:56 luisw2 Exp $
* $Log: ViewPage.java,v $
* Revision 1.4.4.2  2006/09/29 14:12:56  luisw2
* CRSFactory.getCRS substitutes ProjectionPool.get
*
* Revision 1.4.4.1  2006/09/14 15:41:26  jaume
* default projection now configurable
*
* Revision 1.4  2006/08/29 07:21:08  cesar
* Rename com.iver.cit.gvsig.fmap.Fmap class to com.iver.cit.gvsig.fmap.MapContext
*
* Revision 1.3  2006/08/22 12:30:59  jaume
* *** empty log message ***
*
* Revision 1.2  2006/08/22 07:36:04  jaume
* *** empty log message ***
*
* Revision 1.1  2006/08/04 11:41:05  caballero
* poder especificar el zoom a aplicar en las vistas
*
* Revision 1.3  2006/07/31 10:02:31  jaume
* *** empty log message ***
*
* Revision 1.2  2006/06/13 07:43:08  fjp
* Ajustes sobre los cuadros de dialogos de preferencias
*
* Revision 1.1  2006/06/12 16:04:28  caballero
* Preferencias
*
* Revision 1.11  2006/06/06 10:26:31  jaume
* *** empty log message ***
*
* Revision 1.10  2006/06/05 17:07:17  jaume
* *** empty log message ***
*
* Revision 1.9  2006/06/05 17:00:44  jaume
* *** empty log message ***
*
* Revision 1.8  2006/06/05 16:57:59  jaume
* *** empty log message ***
*
* Revision 1.7  2006/06/05 14:45:06  jaume
* *** empty log message ***
*
* Revision 1.6  2006/06/05 11:00:09  jaume
* *** empty log message ***
*
* Revision 1.5  2006/06/05 10:39:02  jaume
* *** empty log message ***
*
* Revision 1.4  2006/06/05 10:13:40  jaume
* *** empty log message ***
*
* Revision 1.3  2006/06/05 10:06:08  jaume
* *** empty log message ***
*
* Revision 1.2  2006/06/05 09:51:56  jaume
* *** empty log message ***
*
* Revision 1.1  2006/06/02 10:50:18  jaume
* *** empty log message ***
*
*
*/
package com.iver.cit.gvsig.gui.preferencespage;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;

import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.plaf.FontUIResource;

import org.cresques.cts.IProjection;
import org.cresques.cts.ProjectionPool;
import org.gvsig.gui.beans.swing.JButton;

import com.iver.andami.PluginServices;
import com.iver.andami.preferences.AbstractPreferencePage;
import com.iver.andami.preferences.StoreException;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.crs.CRSFactory;
import com.iver.cit.gvsig.gui.dialogs.CSSelectionDialog;
import com.iver.cit.gvsig.project.Project;
import com.iver.utiles.XMLEntity;

public class ViewPage extends AbstractPreferencePage {
	private static final String DEFAULT_PROJECTION_KEY_NAME = "DefaultProjection";
	private static final String FACTORY_DEFAULT_PROJECTION = "EPSG:23030";
	private static final String ZOOM_IN_FACTOR_KEY_NAME = "ZoomInFactor";
	private static final String ZOOM_OUT_FACTOR_KEY_NAME = "ZoomOutFactor";
	private static final String ADD_NEW_LAYERS_IN_INVISIBLE_MODE_KEY_NAME = "NewLayersInInvisibleMode";
	private static final String KEEP_SCALE_ON_RESIZING_KEY_NAME = "KeepScaleOnResizing";

	private JTextField txtZoomInFactor;
	private JTextField txtZoomOutFactor;
	protected String id;
	private ImageIcon icon;
	private boolean changed = false;
	private JLabel lblDefaultProjection;
	private JButton btnChangeProjection;
	private String fontName;
	private JCheckBox chkInvisibleNewLayers;
	private JCheckBox chkKeepScaleOnResizing;

	{
		Enumeration keys = UIManager.getDefaults().keys();
		while (keys.hasMoreElements()) {
			Object key = keys.nextElement();
			Object value = UIManager.get (key);
			if (value instanceof FontUIResource) {
				FontUIResource fur = (FontUIResource) value;
				fontName = fur.getFontName();

			}
		}
	}

	public ViewPage() {
		super();
		id = this.getClass().getName();
		icon = new ImageIcon(this.getClass().getClassLoader().getResource("images/Vista.png"));


		// default projection
		lblDefaultProjection = new JLabel();
		lblDefaultProjection.setFont(new java.awt.Font(
			fontName, java.awt.Font.BOLD, 11));
		btnChangeProjection = new JButton(PluginServices.getText(this, "change"));
		btnChangeProjection.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CSSelectionDialog csSelect = new CSSelectionDialog();
				csSelect.setProjection(	CRSFactory.getCRS(
						lblDefaultProjection.getText()));
				PluginServices.getMDIManager().addWindow(csSelect);

		        if (csSelect.isOkPressed()) {
		        	IProjection proj = csSelect.getProjection();
		        	lblDefaultProjection.setText(proj.getAbrev());
		        }
			}
		});
		addComponent(PluginServices.getText(this, "default_projection") + ":", lblDefaultProjection );
		JPanel aux = new JPanel(new FlowLayout(FlowLayout.LEFT, 0, 0));
		aux.add(btnChangeProjection);
		addComponent("", aux);

		// just a separator
		addComponent(new JLabel(" "));

		// Adding Invisible New Layers
		chkInvisibleNewLayers = new JCheckBox(
				PluginServices.getText(this, "options.view.invisible_new_layers"));

		addComponent("", chkInvisibleNewLayers);
		chkKeepScaleOnResizing = new JCheckBox(
				PluginServices.getText(this, "options.view.keep_scale_on_resizing"));
		chkKeepScaleOnResizing.setEnabled(false);
		addComponent("", chkKeepScaleOnResizing);

		// just a separator
		addComponent(new JLabel(" "));

		// zoom in factor
		addComponent(PluginServices.getText(this, "zoom_in_factor") + ":",
			txtZoomInFactor = new JTextField("", 15));
		// zoom out factor
		addComponent(PluginServices.getText(this, "zoom_out_factor") + ":",
			txtZoomOutFactor = new JTextField("", 15));

		initializeValues();
	}

	public void initializeValues() {
		PluginServices ps = PluginServices.getPluginServices(this);
		XMLEntity xml = ps.getPersistentXML();

		// Default Projection
		if (xml.contains(DEFAULT_PROJECTION_KEY_NAME)) {
			lblDefaultProjection.setText(
				xml.getStringProperty(DEFAULT_PROJECTION_KEY_NAME));
		} else {
			lblDefaultProjection.setText(FACTORY_DEFAULT_PROJECTION);
		}
		Project.setDefaultProjection(CRSFactory.getCRS(lblDefaultProjection.getText()));

		// Adding invisible new layers
		if (xml.contains(ADD_NEW_LAYERS_IN_INVISIBLE_MODE_KEY_NAME)) {
			chkInvisibleNewLayers.setSelected(
				xml.getBooleanProperty(ADD_NEW_LAYERS_IN_INVISIBLE_MODE_KEY_NAME));
		}

		// Keep scale on resizing
		if (xml.contains(KEEP_SCALE_ON_RESIZING_KEY_NAME)) {
			chkKeepScaleOnResizing.setSelected(
				xml.getBooleanProperty(KEEP_SCALE_ON_RESIZING_KEY_NAME));
		}

		// Zoom-in factor
		if (xml.contains(ZOOM_IN_FACTOR_KEY_NAME)) {
			double zoomInFactor = xml.getDoubleProperty(ZOOM_IN_FACTOR_KEY_NAME);
			txtZoomInFactor.setText(String.valueOf( zoomInFactor ));
		} else {
			txtZoomInFactor.setText(
				String.valueOf( MapContext.ZOOMINFACTOR ));
		}
		MapContext.ZOOMINFACTOR = Double.parseDouble(txtZoomInFactor.getText());

		// Zoom-out factor
		if (xml.contains(ZOOM_OUT_FACTOR_KEY_NAME)) {
			double zoomOutFactor = xml.getDoubleProperty(ZOOM_OUT_FACTOR_KEY_NAME);
			txtZoomOutFactor.setText(String.valueOf( zoomOutFactor ));
		} else {
			txtZoomOutFactor.setText(
				String.valueOf( MapContext.ZOOMOUTFACTOR ));
		}
		MapContext.ZOOMOUTFACTOR = Double.parseDouble(txtZoomOutFactor.getText());;

	}

	public String getID() {
		return id;
	}

	public String getTitle() {
		return PluginServices.getText(this, "Vista");
	}

	public JPanel getPanel() {
		return this;
	}

	public void storeValues() throws StoreException {
		String projName = lblDefaultProjection.getText();
		double zif;
		double zof;
		boolean invisibleNewLayers, keepScaleOnResize;
		try {
			zif=Double.parseDouble(txtZoomInFactor.getText());
			zof=Double.parseDouble(txtZoomOutFactor.getText());
			Project.setDefaultProjection(CRSFactory.getCRS(projName));
			invisibleNewLayers = chkInvisibleNewLayers.isSelected();
			keepScaleOnResize = chkKeepScaleOnResizing.isSelected();
		} catch (Exception e) {
			throw new StoreException(PluginServices.getText(this,"factor_zoom_incorrecto"));
		}
		MapContext.ZOOMINFACTOR=zif;
		MapContext.ZOOMOUTFACTOR=zof;
		// MapControl.setScalingOnResize(!keepScaleOnResize);

		PluginServices ps = PluginServices.getPluginServices(this);
		XMLEntity xml = ps.getPersistentXML();
		xml.putProperty(DEFAULT_PROJECTION_KEY_NAME, projName);
		xml.putProperty(ZOOM_IN_FACTOR_KEY_NAME, zif);
		xml.putProperty(ZOOM_OUT_FACTOR_KEY_NAME, zof);
		xml.putProperty(ADD_NEW_LAYERS_IN_INVISIBLE_MODE_KEY_NAME, invisibleNewLayers);
		xml.putProperty(KEEP_SCALE_ON_RESIZING_KEY_NAME, keepScaleOnResize);

	}


	public void initializeDefaults() {
		lblDefaultProjection.setText(FACTORY_DEFAULT_PROJECTION);
		txtZoomInFactor.setText(String.valueOf(MapContext.ZOOMINFACTOR));
		txtZoomOutFactor.setText(String.valueOf(MapContext.ZOOMOUTFACTOR));
		chkInvisibleNewLayers.setSelected(false);
		chkKeepScaleOnResizing.setSelected(false);
	}

	public ImageIcon getIcon() {
		return icon;
	}

	public boolean isValueChanged() {
		return super.hasChanged();
	}

	public void setChangesApplied() {
		setChanged(false);
	}
}
