/*
 * Created on 30-abr-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.thememanager.legendmanager.panels;

import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Paint;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.AffineTransform;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.net.URI;

import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.ListCellRenderer;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.plaf.basic.BasicComboBoxEditor;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.core.FPoint2D;
import com.iver.cit.gvsig.fmap.core.FShape;
import com.iver.cit.gvsig.fmap.core.v02.FConstant;
import com.iver.cit.gvsig.fmap.core.v02.FGraphicUtilities;
import com.iver.cit.gvsig.fmap.core.v02.FSymbol;
import com.iver.cit.gvsig.fmap.core.v02.FSymbolFactory;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.rendering.Legend;
import com.iver.cit.gvsig.fmap.rendering.SingleSymbolLegend;
import com.iver.cit.gvsig.fmap.rendering.styling.FStyle2D;
import com.iver.cit.gvsig.gui.GUIUtil;
import com.iver.cit.gvsig.gui.panels.ColorChooserPanel;
import com.iver.cit.gvsig.gui.panels.TransparencyPanel;
import com.iver.utiles.ImageFilter;
/**
 * @author fjp
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


public class FPanelLegendDefault extends JPanel implements ILegendPanel {

	private FSymbol m_FSymbol = null;
    // private boolean bDisableUpdateControls = true;


	protected static final int SLIDER_TEXT_FIELD_COLUMNS = 3;
	// private Paint[] fillPatterns = new FillPatternFactory().createFillPatterns();
	private JPanel centerPanel = new JPanel();
	// private AbstractPalettePanel palettePanel;
	protected JCheckBox fillCheckBox = new JCheckBox();
	protected JCheckBox lineCheckBox = new JCheckBox();
	protected TransparencyPanel transparencyPanel = new TransparencyPanel();
	protected JLabel transparencyLabel = new JLabel();
	protected ColorChooserPanel lineColorChooserPanel = new ColorChooserPanel();
	protected ColorChooserPanel fillColorChooserPanel = new ColorChooserPanel();
	protected ColorChooserPanel pointColorChooserPanel = new ColorChooserPanel();
	protected FPreviewSymbol m_previewSymbol = new FPreviewSymbol();
	protected JLabel lineWidthLabel = new JLabel();
	protected JCheckBox synchronizeCheckBox = new JCheckBox();
	private JCheckBox linePatternCheckBox = new JCheckBox();
	private JCheckBox fillPatternCheckBox = new JCheckBox();
	private Paint[] fillPatterns = FSymbolFactory.createPatternFills(Color.GRAY);
	private String[] linePatterns = new String[] {
			"1", "3", "5", "5,1", "7", "7,12", "9", "9,2", "15,6", "20,3"
		};

	private Integer[] pointTypes = new Integer[] {
			new Integer(FStyle2D.SYMBOL_STYLE_MARKER_SQUARE),
			new Integer(FStyle2D.SYMBOL_STYLE_MARKER_CIRCLE),
			new Integer(FStyle2D.SYMBOL_STYLE_MARKER_TRIANGLE),
			new Integer(FStyle2D.SYMBOL_STYLE_MARKER_CROSS),
			new Integer(FStyle2D.SYMBOL_STYLE_MARKER_IMAGEN)
		};

	protected String pointTypeToString(Integer pointType)
	{
		String resul = "No reconocido";
		switch (pointType.intValue())
		{
			case FStyle2D.SYMBOL_STYLE_MARKER_SQUARE:
				resul = "Cuadrado";
				break;
			case FStyle2D.SYMBOL_STYLE_MARKER_CIRCLE:
				resul = "Crculo";
				break;
			case FStyle2D.SYMBOL_STYLE_MARKER_TRIANGLE:
				resul = "Tringulo";
				break;
			case FStyle2D.SYMBOL_STYLE_MARKER_CROSS:
				resul = "Cruz";
				break;
			case FStyle2D.SYMBOL_STYLE_MARKER_IMAGEN:
				resul = "Imagen";
				break;

		}
		return resul;
	}
	protected Integer pointTypeToInt(String pointType)
	{
		if (pointType.compareTo("Cuadrado")== 0)
			return new Integer(FStyle2D.SYMBOL_STYLE_MARKER_SQUARE);
		if (pointType.compareTo("Crculo")== 0)
			return new Integer(FStyle2D.SYMBOL_STYLE_MARKER_CIRCLE);
		if (pointType.compareTo("Tringulo")== 0)
			return new Integer(FStyle2D.SYMBOL_STYLE_MARKER_TRIANGLE);
		if (pointType.compareTo("Cruz")== 0)
			return new Integer(FStyle2D.SYMBOL_STYLE_MARKER_CROSS);
		if (pointType.compareTo("Imagen")== 0)
			return new Integer(FStyle2D.SYMBOL_STYLE_MARKER_IMAGEN);
		return new Integer(-1);
	}

    /**
     * Esta funcin traduce el FSymbol.getStyle() al correspondiente ndice
     * dentro del combobox
     * @param fillType
     * @return
     */
    private int fillTypeToInt(int fillType)
    {
        return (fillType - 3);
    }

	private JComboBox pointTypeComboBox = new JComboBox(pointTypes) {

		{
			BasicComboBoxEditor editor1 = new BasicComboBoxEditor();

			setEditor(editor1);
			setEditable(true);
			addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						updateControls(false);
						if (getSelectedItem() instanceof Integer)
						{
                            Integer selected = (Integer) getSelectedItem();
							setSelectedItem(pointTypeToString(selected));
                            if (selected.intValue() == FStyle2D.SYMBOL_STYLE_MARKER_IMAGEN)
                            {
                                getJBtnImagen().setVisible(true);
                                jLblImagen.setVisible(true);
                                jTxtImagen.setVisible(true);
                            }
                            else
                            {
                                getJBtnImagen().setVisible(false);
                                jLblImagen.setVisible(false);
                                jTxtImagen.setVisible(false);
                            }


							updateControls(false);
						}
					}
				});
			setRenderer(new ListCellRenderer() {
				private Integer pointType;
				private FSymbol myFSymbol = new FSymbol(FConstant.SYMBOL_TYPE_POINT);
					private JPanel panel = new JPanel() {

							protected void paintComponent(Graphics g) {
								super.paintComponent(g);

								Graphics2D g2 = (Graphics2D) g;
								AffineTransform mT = new AffineTransform();
								mT.setToIdentity();

								FPoint2D shp = new FPoint2D(panel.getWidth()/2,
										panel.getHeight()/2);
								if (m_FSymbol !=null){
								myFSymbol.setColor(m_FSymbol.getColor());
								FGraphicUtilities.DrawShape(g2,mT, shp,myFSymbol);
								}
							}
						};


					public Component getListCellRendererComponent(
						JList list, Object value, int index,
						boolean isSelected, boolean cellHasFocus) {
						pointType = (Integer) value;
						myFSymbol.setStyle(pointType.intValue());
						// Le hacemos que se dibuje siempre con 10 pixels

						myFSymbol.setSizeInPixels(true);
						myFSymbol.setSize(10);
						myFSymbol.setStroke(new BasicStroke());
						panel.setForeground(UIManager.getColor(isSelected
								? "ComboBox.selectionForeground"
								: "ComboBox.foreground"));
						panel.setBackground(UIManager.getColor(isSelected
								? "ComboBox.selectionBackground"
								: "ComboBox.background"));

						return panel;
					}
				});
		}
	};


	protected JSlider lineWidthSlider = new JSlider() {

			{
				addChangeListener(new ChangeListener() {
						public void stateChanged(ChangeEvent e) {
							updateControls(false);
						}
					});
			}
		};
	private JComboBox linePatternComboBox = new JComboBox(linePatterns) {
	{
				BasicComboBoxEditor editor = new BasicComboBoxEditor();
				setEditor(editor);
				setEditable(true);
				addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							updateControls(false);
						}
					});
				setRenderer(new ListCellRenderer() {
						private JPanel panel = new JPanel() {
								private int lineWidth = 2;

								protected void paintComponent(Graphics g) {
									super.paintComponent(g);

									Graphics2D g2 = (Graphics2D) g;
									g2.setStroke(new BasicStroke(lineWidth,
											BasicStroke.CAP_BUTT,
											BasicStroke.JOIN_BEVEL, 1.0f,
											FSymbol.toArray(linePattern, lineWidth), 0));
									g2.draw(new Line2D.Double(0,
											panel.getHeight() / 2.0,
											panel.getWidth(),
											panel.getHeight() / 2.0));
								}
							};

						private String linePattern;

						public Component getListCellRendererComponent(
							JList list, Object value, int index,
							boolean isSelected, boolean cellHasFocus) {
							linePattern = (String) value;
							panel.setForeground(UIManager.getColor(isSelected
									? "ComboBox.selectionForeground"
									: "ComboBox.foreground"));
							panel.setBackground(UIManager.getColor(isSelected
									? "ComboBox.selectionBackground"
									: "ComboBox.background"));

							return panel;
						}
					});
			}
		};

	private JComboBox fillPatternComboBox=getFillPatternComboBox();
	private JComboBox getFillPatternComboBox(){
		if (fillPatternComboBox==null){
		fillPatternComboBox =new JComboBox(fillPatterns) {

			{
				// setMaximumRowCount(fillPatterns.length);
				setEditable(false);
				addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							updateControls(true);
						}
					});
				setRenderer(new ListCellRenderer() {
						private Paint fillPattern;
						private JLabel label = new JLabel(" ");
						private JPanel panel = new JPanel(new BorderLayout()) {

								{
									label.setPreferredSize(new Dimension(150,
											(int) label.getPreferredSize()
													   .getHeight()));
									add(label, BorderLayout.CENTER);
								}

								protected void paintComponent(Graphics g) {
									super.paintComponent(g);
									((Graphics2D) g).setPaint(fillPattern);
									((Graphics2D) g).fill(new Rectangle2D.Double(
											0, 0, getWidth(), getHeight()));
								}
							};

						public Component getListCellRendererComponent(
							JList list, Object value, int index,
							boolean isSelected, boolean cellHasFocus) {
							fillPattern = (Paint) value;
							// label.setText("" +(1 +
							// 	CollectionUtil.indexOf(fillPattern, fillPatterns)));
							label.setForeground(UIManager.getColor(isSelected
									? "ComboBox.selectionForeground"
									: "ComboBox.foreground"));
							panel.setBackground(UIManager.getColor(isSelected
									? "ComboBox.selectionBackground"
									: "ComboBox.background"));

							return panel;
						}
					});
			}
		};
		}
		if (fillPatternCheckBox.isSelected())fillPatternComboBox.setEnabled(true);
		return fillPatternComboBox;
	}
		//private JComboBox fillPatternComboBox = getFillPatternComboBox();


	private javax.swing.JPanel jPanelPoint = null;  //
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JCheckBox jCheckBox = null;
	private javax.swing.JTextField jTextField_Size = null;
	private javax.swing.JComboBox jComboBox_Symbol_Type = null;
	private javax.swing.JLabel jLabel2 = null;
	private JLabel jLblImagen = null;
	private JTextField jTxtImagen = null;
	private JButton jBtnImagen = null;
	/**
	 *
	 */
	public FPanelLegendDefault() {
		super();
		try {
			jbInit();
			linePatternCheckBox.setSelected(false);
		} catch (Exception e) {
			e.printStackTrace();
		}

		transparencyPanel.getSlider().getModel().addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					updateControls(true);
				}
			});
		/* palettePanel.add(new GridPalettePanel.Listener() {
				public void basicStyleChosen(BasicStyle basicStyle) {
					//Preserve some settings e.g. line and fill patterns, alpha;
					BasicStyle newBasicStyle = getBasicStyle();
					newBasicStyle.setFillColor(basicStyle.getFillColor());
					newBasicStyle.setLineColor(basicStyle.getLineColor());
					newBasicStyle.setLineWidth(basicStyle.getLineWidth());
					newBasicStyle.setRenderingFill(basicStyle.isRenderingFill());
					newBasicStyle.setRenderingLine(basicStyle.isRenderingLine());
					setBasicStyle(newBasicStyle);
				}
			}); */
		updateControls(false);

	}

	void jbInit() throws Exception {
		java.awt.GridBagConstraints consGridBagConstraints2 = new java.awt.GridBagConstraints();

		lineWidthSlider.setPaintLabels(true);
		lineWidthSlider.setValue(1);
		lineWidthSlider.setLabelTable(lineWidthSlider.createStandardLabels(10));
		lineWidthSlider.setMajorTickSpacing(5);
		lineWidthSlider.setMaximum(30);
		lineWidthSlider.setMinorTickSpacing(1);


		JPanel globalPanel = new JPanel();
		globalPanel.setLayout(new FlowLayout());

		linePatternCheckBox.setText(PluginServices.getText(this,"tipo_linea"));
		fillPatternCheckBox.setText(PluginServices.getText(this,"tipo_relleno"));
		linePatternCheckBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					linePatternCheckBox_actionPerformed(e);
				}
			});
		fillPatternCheckBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					fillPatternCheckBox_actionPerformed(e);
				}
			});
		// add(getJPanelPoint());
		globalPanel.add(getCenterPanel());
		///globalPanel.add(getCenterPanel(),
		///	new GridBagConstraints(0, 0, 1, 2, 0, 0, GridBagConstraints.WEST,
		///		GridBagConstraints.NONE, new Insets(2, 2, 2, 2), 0, 0));

		/*globalPanel.add(new JPanel(),
			new GridBagConstraints(3, 0, 1, 1, 1, 0, GridBagConstraints.WEST,
				GridBagConstraints.HORIZONTAL, new Insets(2, 2, 2, 2), 0, 0)); */
		/* globalPanel.add(new JLabel("Previsualizacin de smbolo:"),
			new GridBagConstraints(2, 0, 1, 1, 0, 0, GridBagConstraints.WEST,
				GridBagConstraints.NONE, new Insets(0, 30, 0, 0), 0, 0)); */

		JPanel panelAux = new JPanel();
		panelAux.add(new JLabel(PluginServices.getText(this,"Previsualizacion_de_simbolo")));
		centerPanel.setPreferredSize(new java.awt.Dimension(300,240));
		panelAux.add(m_previewSymbol );
		panelAux.setVisible(false);
		/* globalPanel.add(panelAux, new
				GridBagConstraints(2, 1, 1, 1, 1, 1, GridBagConstraints.WEST,
				GridBagConstraints.BOTH, new Insets(2, 2, 2, 2), 0, 0)); */


		m_previewSymbol.setPreferredSize(new Dimension(80,60));
		m_previewSymbol.setMinimumSize(new Dimension(80,60));

		setLayout(null);
		globalPanel.setBounds(0, 0, 417, 275);

		getJPanelPoint().setBounds(0,0,350,250);
		add(getJPanelPoint()); //, BorderLayout.WEST); //, consGridBagConstraints2);
		add(globalPanel); // , BorderLayout.WEST);

		panelAux.setBounds(350,0,150,100);

		add(panelAux) ; //,BorderLayout.EAST); // Contiene el preview

		/* globalPanel.setBackground(Color.RED);
		getJPanelPoint().setBackground(Color.BLUE);
		panelAux.setBackground(Color.GREEN); */

		getCenterPanel().setLayout(new GridBagLayout());
		setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		this.setSize(419, 293);
 		fillColorChooserPanel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					fillColorChooserPanel_actionPerformed(e);
				}
			});
		lineColorChooserPanel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					lineColorChooserPanel_actionPerformed(e);
				}
			});

		synchronizeCheckBox.setText(PluginServices.getText(this,"sincronizar_color_borde_relleno"));
		synchronizeCheckBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					synchronizeCheckBox_actionPerformed(e);
				}
			});
		fillCheckBox.setText(PluginServices.getText(this,"relleno"));
		fillCheckBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					fillCheckBox_actionPerformed(e);
				}
			});
		lineCheckBox.setText(PluginServices.getText(this,"linea"));
		lineCheckBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					lineCheckBox_actionPerformed(e);
				}
			});
		getCenterPanel().add(GUIUtil.createSyncdTextField(
				transparencyPanel.getSlider(), SLIDER_TEXT_FIELD_COLUMNS),
			new GridBagConstraints(2, 21, 1, 1, 0.0, 0.0,
				GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(lineWidthSlider,
			new GridBagConstraints(1, 19, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(GUIUtil.createSyncdTextField(lineWidthSlider,
				SLIDER_TEXT_FIELD_COLUMNS),
			new GridBagConstraints(2, 19, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		fillColorChooserPanel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					fillColorChooserPanel_actionPerformed(e);
				}
			});
		lineWidthLabel.setText(PluginServices.getText(this,"grosor_linea"));
		transparencyLabel.setText(PluginServices.getText(this,"transparencia"));
		consGridBagConstraints2.gridx = 0;
		consGridBagConstraints2.gridy = 0;
		consGridBagConstraints2.anchor = java.awt.GridBagConstraints.NORTHWEST;
		consGridBagConstraints2.fill = java.awt.GridBagConstraints.NONE;
		getCenterPanel().add(synchronizeCheckBox,
			new GridBagConstraints(0, 18, 3, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(transparencyLabel,
			new GridBagConstraints(0, 21, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(fillColorChooserPanel,
			new GridBagConstraints(1, 5, 2, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));


		getCenterPanel().add(lineColorChooserPanel,
			new GridBagConstraints(1, 11, 2, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(transparencyPanel,
			new GridBagConstraints(1, 21, 1, 1, 0.0, 0.0,
				GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(fillCheckBox,
			new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(lineCheckBox,
			new GridBagConstraints(0, 11, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(lineWidthLabel,
			new GridBagConstraints(0, 19, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(linePatternCheckBox,
			new GridBagConstraints(0, 16, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(fillPatternCheckBox,
			new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(linePatternComboBox,
			new GridBagConstraints(1, 16, 2, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 2, 2), 0, 0));
		getCenterPanel().add(getFillPatternComboBox(),
			new GridBagConstraints(1, 7, 2, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE,
				new Insets(2, 2, 0, 2), 0, 0));

		pointTypeComboBox.setBounds(143, 25, 120, 20);
			lineWidthSlider.setPreferredSize(new java.awt.Dimension(120,33));
		pointColorChooserPanel.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				updateControls(false);
			}
		});

		// this.setSize(348, 243);

	}

	protected void setAlpha(int alpha) {
		transparencyPanel.getSlider().setValue(255 - alpha);
	}

	protected int getAlpha() {
		return 255 - transparencyPanel.getSlider().getValue();
	}

	void fillCheckBox_actionPerformed(ActionEvent e) {
		updateControls(false);
	}

	void lineCheckBox_actionPerformed(ActionEvent e) {
		updateControls(false);
	}

	/*private void setSynchronizingLineColor(boolean newSynchronizingLineColor) {
		synchronizeCheckBox.setSelected(newSynchronizingLineColor);
	}
*/
	protected void synchronizeCheckBox_actionPerformed(ActionEvent e) {
		if (synchronizeCheckBox.isSelected()) {
			syncLineColor();
		}

		updateControls(false);
	}
/*
	private JCheckBox getSynchronizeCheckBox() {
		return synchronizeCheckBox;
	}
*/
	void linePatternCheckBox_actionPerformed(ActionEvent e) {
		updateControls(false);
	}
	void lineColorChooserPanel_actionPerformed(ActionEvent e) {
		if (synchronizeCheckBox.isSelected()) {
			fillColorChooserPanel.setColor(lineColorChooserPanel.getColor()
																.brighter());
		}

		updateControls(false);
	}
	void fillColorChooserPanel_actionPerformed(ActionEvent e) {
		if (synchronizeCheckBox.isSelected()) {
			syncLineColor();
		}

		updateControls(true);
	}
	private void syncLineColor() {
		lineColorChooserPanel.setColor(fillColorChooserPanel.getColor().darker());
	}

	void fillPatternCheckBox_actionPerformed(ActionEvent e) {
		updateControls(false);
	}
	private void updateFillPatternColors(Color newColor) {
		if (newColor != null)
		{
			fillPatterns = FSymbolFactory.createPatternFills(newColor);
			int index=getFillPatternComboBox().getSelectedIndex();
			//fillPatternComboBox=getFillPatternComboBox();
			getFillPatternComboBox().setModel(new DefaultComboBoxModel(fillPatterns));
			getFillPatternComboBox().getModel().setSelectedItem(m_FSymbol.getFill());
			getFillPatternComboBox().setSelectedIndex(index);
		}

	}

	public FSymbol getSymbolFromControls()
	{
		if (m_FSymbol != null)
		{
			FSymbol aux = new FSymbol(m_FSymbol.getSymbolType());
			aux.setShapeVisible(true);
			Color theColor = (lineCheckBox.isSelected() &&
					!fillCheckBox.isSelected()) ? lineColorChooserPanel.getColor()
												: fillColorChooserPanel.getColor();

			if (aux.getSymbolType() == FConstant.SYMBOL_TYPE_POINT)
			{
				int size = (int) Double.parseDouble(getJTextField().getText());
				if (size <= 0)
					size = 1;
				aux.setSize(size);

				//System.out.println("Asigno el m_Size = " + getJTextField().getText());

				if (pointTypeComboBox.getSelectedItem() instanceof Integer)
				{
					Integer styleSelected = (Integer) pointTypeComboBox.getSelectedItem();
					aux.setStyle(styleSelected.intValue());
				}
				else
				{
					Integer styleSelected = pointTypeToInt((String) pointTypeComboBox.getSelectedItem());
					aux.setStyle(styleSelected.intValue());
				}
				if (aux.getStyle() == FConstant.SYMBOL_STYLE_MARKER_IMAGEN)
				{
					if (jTxtImagen.getText().compareTo("") != 0)
					{
						File iconFile = new File(jTxtImagen.getText());
                        URI theUri= iconFile.toURI();
                        aux.setIconURI(theUri);
					}
				}
				aux.setColor(pointColorChooserPanel.getColor());
				aux.setSizeInPixels(!getJCheckBox().isSelected());
				return aux;
			}
			aux.setOutlined(lineCheckBox.isSelected());
			aux.setOutlineColor(lineColorChooserPanel.getColor());
			if (fillCheckBox.isSelected())
			{
				aux.setColor(new Color(theColor.getRed(),
											theColor.getGreen(),
											  theColor.getBlue(),
											  	getAlpha()));
			}
			else
			{
				aux.setColor(null);
			}
			if (fillPatternCheckBox.isSelected())
			{
				Paint fillAux = (Paint) getFillPatternComboBox().getSelectedItem();
				if ((fillAux != null) && (getFillPatternComboBox().getSelectedIndex() != -1))
				{
					aux.setFill((Paint) getFillPatternComboBox().getSelectedItem());
					// Rellenamos el m_Style para que luego podamos escribir
					// el tipo de relleno que lleva.
					aux.setStyle(getFillPatternComboBox().getSelectedIndex()+3);
					System.out.println("Asigno Style=" + m_FSymbol.getStyle());
				}
			}
			else
				aux.setFill(null);

			float lineWidth = lineWidthSlider.getValue();
			if (linePatternCheckBox.isSelected())
			{

				String linePattern = (String) linePatternComboBox.getSelectedItem();

				// System.out.println(m_FSymbol.m_Stroke.toString());
				aux.setStroke(new BasicStroke(lineWidth, BasicStroke.CAP_ROUND,
											BasicStroke.JOIN_BEVEL, 1.0f,
												FSymbol.toArray(linePattern, lineWidth), 0));
				aux.m_LinePattern = linePattern;

			}
			else
			{
				aux.m_LinePattern = "0";
				if (lineWidth ==0)
					aux.setStroke(null);
				else
					aux.setStroke(new BasicStroke(lineWidth, BasicStroke.CAP_ROUND,
								BasicStroke.JOIN_BEVEL));
			}
			// System.out.println(fillPatternComboBox.getSelectedItem().toString() + " " + linePatternComboBox.getSelectedItem().toString());
			// JOptionPane.showMessageDialog(this,"HOla","Colega", JOptionPane.INFORMATION_MESSAGE);
			return aux;
		}
		return null;

	}
	/**
	 * @param bInternal
	 */
	public void updateControls(boolean bInternal) {
        if (m_FSymbol == null)
			return;
        // if (bDisableUpdateControls == true)
        //     return;
		linePatternComboBox.setEnabled(linePatternCheckBox.isSelected());
		getFillPatternComboBox().setEnabled(fillPatternCheckBox.isSelected());
		lineColorChooserPanel.setEnabled(lineCheckBox.isSelected());
		fillColorChooserPanel.setEnabled(fillCheckBox.isSelected());
		fillColorChooserPanel.setAlpha(getAlpha());
		lineColorChooserPanel.setAlpha(getAlpha());
		Color theColor = (lineCheckBox.isSelected() &&
		!fillCheckBox.isSelected()) ? lineColorChooserPanel.getColor()
									: fillColorChooserPanel.getColor();
		transparencyPanel.setColor(theColor);
		/* if (jTxtImagen != null)
		{
			jTxtImagen.setVisible(false);
			jLblImagen.setVisible(false);
			jBtnImagen.setVisible(false);
		} */
		if (m_FSymbol != null)
		{
			/* if (m_FSymbol.getSymbolType() == FConstant.SYMBOL_TYPE_POINT)
			{
				if (m_FSymbol.getStyle() == FConstant.SYMBOL_STYLE_MARKER_IMAGEN)
				{
					jTxtImagen.setVisible(true);
					jLblImagen.setVisible(true);
					jBtnImagen.setVisible(true);
				}
				pointColorChooserPanel.repaint();
			} */
			// System.out.println(fillPatternComboBox.getSelectedItem().toString() + " " + linePatternComboBox.getSelectedItem().toString());
			// JOptionPane.showMessageDialog(this,"HOla","Colega", JOptionPane.INFORMATION_MESSAGE);
		}
		updateFillPatternColors(theColor);
		getFillPatternComboBox().repaint();
		if (m_FSymbol != null)
		{

			m_previewSymbol.setSymbol(getSymbolFromControls());
		}

	}

	public void setFSymbol(FSymbol s)
	{
        // bDisableUpdateControls = true;
		if (s==null)
		{
			m_FSymbol = new FSymbol(FShape.MULTI);
		}
		m_FSymbol = s.fastCloneSymbol();
		m_previewSymbol.setSymbol(m_FSymbol);
		if ((m_FSymbol.getSymbolType() == FConstant.SYMBOL_TYPE_FILL) || (m_FSymbol.getSymbolType() == FShape.MULTI))
		{
			// Deberamos habilitar la pestaa de polgonos
			getJPanelPoint().setVisible(false);
			getCenterPanel().setVisible(true);
			fillCheckBox.setText(PluginServices.getText(this,"relleno"));
			//fillCheckBox.setSelected(true);
			synchronizeCheckBox.setVisible(true);
			fillPatternCheckBox.setVisible(true);
			getFillPatternComboBox().setVisible(true);
			lineCheckBox.setVisible(true);
			lineColorChooserPanel.setVisible(true);

			linePatternCheckBox.setSelected(false);
            if (m_FSymbol.getFill() != null)
            {
                fillPatternCheckBox.setSelected(true);
                // getFillPatternComboBox().setSelectedItem(fillTypeToInt(m_FSymbol.getStyle()));
                // getFillPatternComboBox().setSelectedItem(m_FSymbol.getFill());
                getFillPatternComboBox().setSelectedIndex(fillTypeToInt(m_FSymbol.getStyle()));
            }
            lineCheckBox.setSelected(m_FSymbol.isOutlined());
            if (m_FSymbol.getColor() != null)
            {
                fillCheckBox.setSelected(true);
                fillColorChooserPanel.setColor(m_FSymbol.getColor());
                setAlpha(m_FSymbol.getColor().getAlpha());
                fillColorChooserPanel.setAlpha(getAlpha());
                lineColorChooserPanel.setAlpha(getAlpha());
            }
            else
            {
                fillCheckBox.setSelected(false);
            }
            int outlineSize = 0;
			if (m_FSymbol.getStroke() != null)
			{
				BasicStroke aux = (BasicStroke) m_FSymbol.getStroke();
				if (aux.getDashArray() != null)
				{
					linePatternCheckBox.setSelected(true);
					linePatternComboBox.setSelectedItem(m_FSymbol.m_LinePattern);
				}
                outlineSize = (int) aux.getLineWidth();

			}

            lineColorChooserPanel.setColor(m_FSymbol.getOutlineColor());
            lineWidthSlider.setValue(outlineSize);

		}
		if (m_FSymbol.getSymbolType() == FConstant.SYMBOL_TYPE_LINE)
		{
			getJPanelPoint().setVisible(false);
			getCenterPanel().setVisible(true);
			fillCheckBox.setText(PluginServices.getText(this,"linea"));	// Lo vamos a usar como color de lnea
			fillCheckBox.setSelected(true);
			synchronizeCheckBox.setVisible(false);
			fillPatternCheckBox.setVisible(false);
			getFillPatternComboBox().setVisible(false);
			lineCheckBox.setSelected(true);
			lineCheckBox.setVisible(false);
			fillColorChooserPanel.setColor(m_FSymbol.getColor());
			lineColorChooserPanel.setVisible(false);
			linePatternCheckBox.setSelected(false);
			int outlineSize = 0;
			if (m_FSymbol.getStroke() != null)
			{
				BasicStroke aux = (BasicStroke) m_FSymbol.getStroke();
				// if (aux.getDashArray() != null)
                if (m_FSymbol.m_LinePattern.compareTo("0") != 0)
				{
					linePatternCheckBox.setSelected(true);
					linePatternComboBox.setSelectedItem(m_FSymbol.m_LinePattern);
				}
                outlineSize = (int) (aux.getLineWidth());

			}
            if (m_FSymbol.getColor() != null)
            {
                lineColorChooserPanel.setColor(m_FSymbol.getColor());
                setAlpha(m_FSymbol.getColor().getAlpha());
                lineColorChooserPanel.setAlpha(getAlpha());
            }
            lineWidthSlider.setValue(outlineSize);
		}
		if (m_FSymbol.getSymbolType() == FConstant.SYMBOL_TYPE_POINT)
		{
			getCenterPanel().setVisible(false);
			getJPanelPoint().setVisible(true);
			if (m_FSymbol.getColor()!=null){
			pointColorChooserPanel.setColor(m_FSymbol.getColor());
			}
			getJTextField().setText("" + m_FSymbol.getSize());
			getJCheckBox().setSelected(!m_FSymbol.isSizeInPixels());
			getJComboBox_pointType().setSelectedItem(new Integer(m_FSymbol.getStyle()));

            if (m_FSymbol.getStyle() == FConstant.SYMBOL_STYLE_MARKER_IMAGEN && m_FSymbol.getIconURI()!=null)
            {
                File fProv = new File(m_FSymbol.getIconURI());
                jTxtImagen.setText(fProv.getAbsolutePath());
                jTxtImagen.setVisible(true);
                jLblImagen.setVisible(true);
                jBtnImagen.setVisible(true);
            }

		}
        // bDisableUpdateControls = false;
		// setAlpha(255 - m_FSymbol.m_Transparency);
		updateControls(true);
	}

	/**
	 * @return
	 */
	public FSymbol getFSymbol() {
		return getSymbolFromControls();
		// return m_FSymbol;
	}

	protected void setCenterPanel(JPanel centerPanel) {
		this.centerPanel = centerPanel;
	}

	protected JPanel getCenterPanel() {
		return centerPanel;
	}

	/**

	 * This method initializes jPanel

	 *

	 * @return javax.swing.JPanel

	 */
	protected javax.swing.JPanel getJPanelPoint() {
		if (jPanelPoint == null) {
			jLblImagen = new JLabel();
			jPanelPoint = new javax.swing.JPanel();
			jPanelPoint.setLayout(null);
			jPanelPoint.setPreferredSize(new Dimension(300,200));
			jPanelPoint.setBounds(0, 2, 336, 217);
			jLblImagen.setBounds(25, 139, 71, 18);
			jLblImagen.setText(PluginServices.getText(this,"imagen"));
			jPanelPoint.add(getJLabel2(), null);
			jPanelPoint.add(getJLabel(), null);
			jPanelPoint.add(getJLabel1(), null);
			jPanelPoint.add(getJCheckBox(), null);
			jPanelPoint.add(getJTextField(), null);
			jPanelPoint.add(getJComboBox_pointType(), null);
			pointColorChooserPanel.setBounds(143, 54, 98, 22);
			pointColorChooserPanel.setAlpha(255);
			jPanelPoint.add(pointColorChooserPanel);
			jPanelPoint.add(jLblImagen, null);
			jPanelPoint.add(getJTextField2(), null);
			jPanelPoint.add(getJBtnImagen(), null);
		}
		return jPanelPoint;
	}

	/**

	 * This method initializes jLabel

	 *

	 * @return javax.swing.JLabel

	 */
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText(PluginServices.getText(this,"tipo_simbolo"));
			jLabel.setBounds(25, 23, 113, 22);
		}
		return jLabel;
	}

	/**

	 * This method initializes jLabel1

	 *

	 * @return javax.swing.JLabel

	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setBounds(25, 84, 77, 22);
			jLabel1.setText(PluginServices.getText(this,"tamano"));
		}
		return jLabel1;
	}

	/**

	 * This method initializes jCheckBox

	 *

	 * @return javax.swing.JCheckBox

	 */
	private javax.swing.JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new javax.swing.JCheckBox();
			jCheckBox.setBounds(143, 115, 145, 19);
			jCheckBox.setText(PluginServices.getText(this,"tamano_metros"));
		}
		return jCheckBox;
	}

	/**

	 * This method initializes jTextField

	 *

	 * @return javax.swing.JTextField

	 */
	protected javax.swing.JTextField getJTextField() {
		if (jTextField_Size == null) {
			jTextField_Size = new javax.swing.JTextField();
			jTextField_Size.setBounds(143, 86, 76, 20);
			jTextField_Size.setText("12");
			jTextField_Size.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					updateControls(false);
				}
			});
		}
		return jTextField_Size;
	}

	/**

	 * This method initializes jComboBox

	 *

	 * @return javax.swing.JComboBox

	 */
	private javax.swing.JComboBox getJComboBox_pointType() {
		if (jComboBox_Symbol_Type == null) {
			jComboBox_Symbol_Type = new javax.swing.JComboBox();
			jComboBox_Symbol_Type.setBounds(143, 25, 120, 20);
		}
		// return jComboBox_Symbol_Type;
		return pointTypeComboBox;
	}

	/**

	 * This method initializes jLabel2

	 *

	 * @return javax.swing.JLabel

	 */
	private javax.swing.JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			jLabel2.setBounds(25, 54, 68, 22);
			jLabel2.setText(PluginServices.getText(this,"color"));
		}
		return jLabel2;
	}

	/**
	 * This method initializes jTextField
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField2() {
		if (jTxtImagen == null) {
			jTxtImagen = new JTextField();
			jTxtImagen.setBounds(103, 139, 168, 18);
		}
		return jTxtImagen;
	}
	/**
	 * This method initializes jButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJBtnImagen() {
		if (jBtnImagen == null) {
			jBtnImagen = new JButton();
			jBtnImagen.setBounds(279, 139, 33, 18);
			jBtnImagen.setText("...");
			jBtnImagen.setToolTipText(PluginServices.getText(this,"browse"));
			jBtnImagen.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFileChooser tempChooser = new JFileChooser();
					ImageFilter filter = new ImageFilter();
				    tempChooser.setFileFilter(filter);

                    int result = tempChooser.showOpenDialog((Component) e.getSource());
                    tempChooser.setMultiSelectionEnabled(false);
                    if (result == JFileChooser.APPROVE_OPTION) {
                		File newFile = tempChooser.getSelectedFile();
                		jTxtImagen.setText(newFile.getAbsolutePath());
                	}
				}
			});
		}
		return jBtnImagen;
	}
	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.gui.legendmanager.panels.ILegendPanel#setLayer(com.iver.cit.gvsig.fmap.layers.FLayer, com.iver.cit.gvsig.fmap.rendering.Legend)
	 */
	public void setLayer(FLayer lyr, Legend legend) {
		//FSymbol aux;
		//if (legend.getDefaultSymbol() == null)
		//	aux = new FSymbol(((VectorialLegend)legend).getShapeType());
		//else

		setFSymbol(legend.getDefaultSymbol());

	}
	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.gui.legendmanager.panels.ILegendPanel#getLegend()
	 */
	public Legend getLegend() {
		return new SingleSymbolLegend(getFSymbol());
	}
	/**
	 * @return Returns the m_previewSymbol.
	 */
	public FPreviewSymbol getM_previewSymbol() {
		return m_previewSymbol;
	}
   }  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"