package com.iver.cit.gvsig.gui.toc.actions;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.gui.toc.AbstractTocContextMenuAction;
import com.iver.cit.gvsig.gui.toc.ITocItem;
import com.iver.cit.gvsig.gui.toc.TocItemBranch;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: FirstLayerTocMenuEntry.java,v 1.2.2.1 2006/09/23 16:05:48 jorpiell Exp $
 * $Log: FirstLayerTocMenuEntry.java,v $
 * Revision 1.2.2.1  2006/09/23 16:05:48  jorpiell
 * Se han sacado las opciones de  men del TOC de FPopupMenu a una nueva clase
 *
 *
 */
/**
 * Cambia la posicin actual del layer a la primera posicin.
 *
 * @author Vicente Caballero Navarro
 */
public class FirstLayerTocMenuEntry extends AbstractTocContextMenuAction {
	public String getGroup() {
		return "group4"; //FIXME
	}

	public int getGroupOrder() {
		return 40;
	}

	public int getOrder() {
		return 2;
	}

	public String getText() {
		return PluginServices.getText(this, "colocar_delante");
	}

	public boolean isEnabled(ITocItem item, FLayer[] selectedItems) {
		return true;
	}

	public boolean isVisible(ITocItem item, FLayer[] selectedItems) {
		if (isTocItemBranch(item)){
			return true;
		}
		return false;

	}


	public void execute(ITocItem item, FLayer[] selectedItems) {
      	if (isTocItemBranch(item)){
            if (getMapContext().getLayers().getActives().length == 1) {
                FLayer layer=((TocItemBranch)item).getLayer();
                FLayers layers=layer.getParentLayer();
                for (int i=0;i<layers.getLayersCount();i++){
                    if(layers.getLayer(i).equals(layer)){
                        layers.removeLayer(i);
                        layers.addLayer(layer);
                    }
                }
            } else if (selectedItems.length > 1) {
                FLayer[] actives =selectedItems;
                FLayers layers=actives[0].getParentLayer();
                for (int i=0;i<actives.length;i++){
                    for (int j=0;j<layers.getLayersCount();j++){
                        if(layers.getLayer(j).equals(actives[i])){
                            layers.removeLayer(j);
                            layers.addLayer(actives[i]);
                        }
                    }
                }
            }
		}
		// TRUCO PARA REFRESCAR.
        getMapContext().invalidate();
	}
}
