package com.iver.cit.gvsig.gui.toc.actions;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.gui.toc.AbstractTocContextMenuAction;
import com.iver.cit.gvsig.gui.toc.ChangeName;
import com.iver.cit.gvsig.gui.toc.ITocItem;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: LayersGroupTocMenuEntry.java,v 1.2.2.2 2006/09/25 14:56:31 jmvivo Exp $
 * $Log: LayersGroupTocMenuEntry.java,v $
 * Revision 1.2.2.2  2006/09/25 14:56:31  jmvivo
 * * Modificada la condificion de visibilidad
 * * Modificada la implementacion para permitir agrupaciones anidadas
 *
 * Revision 1.2.2.1  2006/09/23 16:05:48  jorpiell
 * Se han sacado las opciones de  men del TOC de FPopupMenu a una nueva clase
 *
 *
 */
/**
 * Realiza una agrupacin de capas, a partir de las capas que se encuentren activas.
 *
 * @author Vicente Caballero Navarro
 */
public class LayersGroupTocMenuEntry extends AbstractTocContextMenuAction {
	public String getGroup() {
		return "group4"; //FIXME
	}

	public int getGroupOrder() {
		return 40;
	}

	public int getOrder() {
		return 0;
	}

	public String getText() {
		return PluginServices.getText(this, "agrupar_capas");
	}

	public boolean isEnabled(ITocItem item, FLayer[] selectedItems) {
		return selectedItems.length > 1;
	}

	public boolean isVisible(ITocItem item, FLayer[] selectedItems) {
		if (selectedItems.length < 2) {
			return false;
		}
		FLayers parent = selectedItems[0].getParentLayer();
		for (int i = 1; i < selectedItems.length;i++){
			if (parent != selectedItems[i].getParentLayer()){
				return false;
			}
		}
		return true;

	}


	public void execute(ITocItem item, FLayer[] selectedItems) {
		//ITocItem tocItem = (ITocItem) getNodeUserObject();
		ChangeName changename=new ChangeName(null);
		PluginServices.getMDIManager().addWindow(changename);
		String nombre=changename.getName();

		if (nombre != null){
			
			getMapContext().beginAtomicEvent();
			FLayers parent = selectedItems[0].getParentLayer();
			FLayers newGroup = new FLayers(getMapContext(),parent);
			newGroup.setName(nombre);
			for (int j=0;j < selectedItems.length;j++){
				FLayer layer = selectedItems[j];
				parent.removeLayer(layer);
				newGroup.addLayer(layer);
			}
			parent.addLayer(newGroup);
			
			getMapContext().endAtomicEvent();

			// TRUCO PARA REFRESCAR.
			getMapContext().invalidate();
		}
	}
}
