package com.iver.cit.gvsig.gui.toc.actions;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.gui.toc.AbstractTocContextMenuAction;
import com.iver.cit.gvsig.gui.toc.ITocItem;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: LayersUngroupTocMenuEntry.java,v 1.2.2.2 2006/09/25 14:57:30 jmvivo Exp $
 * $Log: LayersUngroupTocMenuEntry.java,v $
 * Revision 1.2.2.2  2006/09/25 14:57:30  jmvivo
 * * Modificada la condicion para que no muestre la opcion cuando el toc esta vacio.
 * * Modificada la implementacion.
 *
 * Revision 1.2.2.1  2006/09/23 16:05:48  jorpiell
 * Se han sacado las opciones de  men del TOC de FPopupMenu a una nueva clase
 *
 *
 */
/**
 * Realiza una desagrupacin de capas, a partir de las capas que se encuentren activas.
 *
 * @author Vicente Caballero Navarro
 */
public class LayersUngroupTocMenuEntry extends AbstractTocContextMenuAction {
	public String getGroup() {
		return "group4"; //FIXME
	}

	public int getGroupOrder() {
		return 40;
	}

	public int getOrder() {
		return 1;
	}

	public String getText() {
		return PluginServices.getText(this, "desagrupar_capas");
	}

	public boolean isEnabled(ITocItem item, FLayer[] selectedItems) {
		return true;
	}

	public boolean isVisible(ITocItem item, FLayer[] selectedItems) {
		if (isTocItemBranch(item)){
			FLayer lyr = getNodeLayer(item);
			if (!(lyr instanceof FLayers) || (lyr instanceof FLayers && lyr.getParentLayer() == null)){
				return false;
			}
			return true;
		}
		return false;

	}


	public void execute(ITocItem item, FLayer[] selectedItems) {
		if (isTocItemBranch(item)){
					
			
			FLayers agrupa = (FLayers)getNodeLayer(item);
			FLayers parent=agrupa.getParentLayer();
			
			if (parent!=null){
				getMapContext().beginAtomicEvent();
				while (agrupa.getLayersCount() > 0){
					FLayer layer = agrupa.getLayer(0);
					parent.addLayer(layer);
					agrupa.removeLayer(layer);
				}
				parent.removeLayer(agrupa);
				getMapContext().endAtomicEvent();
			}
		}
		// TRUCO PARA REFRESCAR.
		getMapContext().invalidate();
	}
}
