package com.iver.cit.gvsig.gui.toc.actions;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.gui.View;
import com.iver.cit.gvsig.gui.toc.AbstractTocContextMenuAction;
import com.iver.cit.gvsig.gui.toc.ITocItem;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: ZoomPixelCursorTocMenuEntry.java,v 1.2.2.1 2006/09/23 16:05:48 jorpiell Exp $
 * $Log: ZoomPixelCursorTocMenuEntry.java,v $
 * Revision 1.2.2.1  2006/09/23 16:05:48  jorpiell
 * Se han sacado las opciones de  men del TOC de FPopupMenu a una nueva clase
 *
 *
 */
/**
 * @author Nacho Brodin <brodin_ign@gva.es>
 *
 * Entrada de men para la activacin de la funcionalidad de zoom a un
 * pixel centrado en el cursor.
 */
public class ZoomPixelCursorTocMenuEntry extends AbstractTocContextMenuAction {
	public static final int ZOOM_TO_IMAGE_CENTER = 0x1;
	public static final int ZOOM_TO_VIEW_CENTER = 0x2;
	FLayer lyr = null;
	public int zoomType = ZOOM_TO_VIEW_CENTER;

	public String getGroup() {
		return "group2"; //FIXME
	}

	public int getGroupOrder() {
		return 20;
	}

	public int getOrder() {
		return 2;
	}

	public String getText() {
		return PluginServices.getText(this, "Zoom_pixel");
	}

	public boolean isEnabled(ITocItem item, FLayer[] selectedItems) {
		return true;
	}

	public boolean isVisible(ITocItem item, FLayer[] selectedItems) {
		if (isTocItemBranch(item)) {
			return getNodeLayer(item) instanceof FLyrRaster;
		}
		return false;

	}


	public void execute(ITocItem item, FLayer[] selectedItems) {
		if (selectedItems.length==1) {
	        lyr = getNodeLayer(item);
	    	View vista = (View) PluginServices.getMDIManager().getActiveWindow();
	    	MapControl mapCtrl = vista.getMapControl();
	    	mapCtrl.setTool("zoom_pixel_cursor");

		}
	}
}
