package com.iver.cit.gvsig.gui.toc.actions;

import java.awt.event.ActionEvent;
import java.awt.geom.Rectangle2D;
import java.util.ArrayList;

import javax.swing.JMenuItem;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.gui.toc.FPopupMenu;
import com.iver.cit.gvsig.gui.toc.TocMenuEntry;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: ZoomPixelTocMenuEntry.java,v 1.2.2.1 2006/09/23 16:05:48 jorpiell Exp $
 * $Log: ZoomPixelTocMenuEntry.java,v $
 * Revision 1.2.2.1  2006/09/23 16:05:48  jorpiell
 * Se han sacado las opciones de  men del TOC de FPopupMenu a una nueva clase
 *
 *
 */
/**
 * @author Nacho Brodin <brodin_ign@gva.es>
 *
 * Entrada de men para la activacin de la funcionalidad de zoom a un
 * pixel.
 */
public class ZoomPixelTocMenuEntry extends TocMenuEntry {
	public static final int ZOOM_TO_IMAGE_CENTER = 0x1;
	public static final int ZOOM_TO_VIEW_CENTER = 0x2;
	private JMenuItem properties;
	FLayer lyr = null;
	public int zoomType = ZOOM_TO_VIEW_CENTER;


	public void initialize(FPopupMenu m) {
		super.initialize(m);

		if (isTocItemBranch()) {
			lyr = getNodeLayer();
    		// Opcciones para capas raster
    		if ((lyr instanceof FLyrRaster)) {
    			properties = new JMenuItem(PluginServices.getText(this, "Zoom_pixel"));
    			getMenu().add( properties );
    			properties.setFont(FPopupMenu.theFont);
    			getMenu().setEnabled(true);

    			properties.addActionListener(this);
     		}
		}
	}

	public void actionPerformed(ActionEvent e) {

		FLayer[] actives = getMapContext().getLayers().getActives();
		if (actives.length==1) {
	        try {
	        	Rectangle2D r = actives[0].getFullExtent();

	        	ArrayList attr = ((FLyrRaster)actives[0]).getSource().getAttributes();
	        	int width = 0, height = 0;
	       		for (int i=0; i<attr.size(); i++) {
	    			Object[] a = (Object []) attr.get(i);
	    			if (a[0].toString().equals("Width"))
	    				width = ((Integer)a[1]).intValue();
	    			if (a[0].toString().equals("Height"))
	    				height = ((Integer)a[1]).intValue();
	    		}
	        	ViewPort v = getMapContext().getViewPort();

	        	if (zoomType == ZOOM_TO_IMAGE_CENTER) {
		        	//A centro de imagen
		        	/*double centroX = width/2;
					double centroY = height/2;
					int minX = (int)Math.round(centroX - (v.getImageWidth()/2));
					int minY = (int)Math.round(centroY - (v.getImageHeight()/2));
					int maxX = (int)Math.round(minX + v.getImageWidth());
					int maxY = (int)Math.round(minY + v.getImageHeight());
					double wcOriginWidth = r.getMaxX() - r.getMinX();
					double wcOriginHeight = r.getMaxY() - r.getMinY();

					double wcDstMinX = r.getMinX()+((minX*wcOriginWidth)/width);
					double wcDstMinY = r.getMinY()+((minY*wcOriginHeight)/height);
					double wcDstMaxX = r.getMinX()+((maxX*wcOriginWidth)/width);
					double wcDstMaxY = r.getMinY()+((maxY*wcOriginHeight)/height);

					double wcDstWidth = wcDstMaxX - wcDstMinX;
					double wcDstHeight = wcDstMaxY - wcDstMinY;*/
	        	} else if (zoomType == ZOOM_TO_VIEW_CENTER) {
		        	//A centro de vista
		        	double wcOriginCenterX = v.getExtent().getMinX()+((v.getExtent().getMaxX()-v.getExtent().getMinX())/2);
		        	double wcOriginCenterY = v.getExtent().getMinY()+((v.getExtent().getMaxY()-v.getExtent().getMinY())/2);

		        	//Hallamos la relacin entre el pixel y las WC a partir de la imagen de la capa
					double relacionPixelWcWidth =  (r.getMaxX() - r.getMinX())/width;
					double relacionPixelWcHeight = (r.getMaxY() - r.getMinY())/height;
					//double desplazamientoX = r.getMinX();
					//double desplazamientoY = r.getMinY();

					double wcOriginX = wcOriginCenterX - ((v.getImageWidth()*relacionPixelWcWidth)/2);
					double wcOriginY = wcOriginCenterY - ((v.getImageHeight()*relacionPixelWcHeight)/2);

					double wcDstMinX = wcOriginX;
					double wcDstMinY = wcOriginY;
					double wcDstMaxX = wcDstMinX + (v.getImageWidth()*relacionPixelWcWidth);
					double wcDstMaxY = wcDstMinY + (v.getImageHeight()*relacionPixelWcHeight);

					double wcDstWidth = wcDstMaxX - wcDstMinX;
					double wcDstHeight = wcDstMaxY - wcDstMinY;

		        	r = new Rectangle2D.Double(wcDstMinX, wcDstMinY, wcDstWidth, wcDstHeight);
		        	getMapContext().getViewPort().setExtent(r);
	        	}
			} catch (com.iver.cit.gvsig.fmap.DriverException e1) {
				e1.printStackTrace();
			}
		}
		//View vista = (View) PluginServices.getMDIManager().getActiveView();
		//MapControl mapCtrl = vista.getMapControl();
	}
}
