/*
 * Created on 26-jun-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: DifferenceGeoprocessPlugin.java,v 1.4 2006/08/29 07:56:30 cesar Exp $
 * $Log: DifferenceGeoprocessPlugin.java,v $
 * Revision 1.4  2006/08/29 07:56:30  cesar
 * Rename the *View* family of classes to *Window* (ie: SingletonView to SingletonWindow, ViewInfo to WindowInfo, etc)
 *
 * Revision 1.3  2006/08/29 07:21:09  cesar
 * Rename com.iver.cit.gvsig.fmap.Fmap class to com.iver.cit.gvsig.fmap.MapContext
 *
 * Revision 1.2  2006/08/11 16:20:24  azabala
 * *** empty log message ***
 *
 * Revision 1.1  2006/06/27 16:11:41  azabala
 * toString() added to Plugin interface to force textual representation of geoprocess plugins
 *
 *
 */
package com.iver.cit.gvsig.geoprocess.impl.difference;

import java.net.URL;
import java.util.Locale;

import org.cresques.cts.IProjection;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessController;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel2;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.cit.gvsig.geoprocess.impl.clip.ClipGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.impl.convexhull.gui.GeoProcessingConvexHullPanel;
import com.iver.cit.gvsig.gui.View;

/**
 * Plugin to register Difference Geoprocess
 * 
 * @author azabala
 * 
 */
public class DifferenceGeoprocessPlugin implements IGeoprocessPlugin {

	private static String analisisPkg;
	private static String overlayPkg;
	private static String geoprocessName;
	
	static{
		analisisPkg = PluginServices.getText(null, "Analisis");
		overlayPkg = PluginServices.getText(null, "Overlay");
		geoprocessName = PluginServices.getText(null, "Diferencia");
	}
	
	
	public IGeoprocessPanel getGeoprocessPanel() {
		View vista = (View) PluginServices.getMDIManager().getActiveWindow();
		FLayers layers = vista.getModel().getMapContext().getLayers();
		String titleText = PluginServices.getText(this,
				"Diferencia_Introduccion_de_datos")
				+ ":";
		return new GeoProcessingOverlayPanel2(layers, titleText);
	}

	public URL getHtmlDescription() {
		Locale locale = Locale.getDefault();
		String localeStr = locale.getLanguage();
		String urlStr = "resources/description_" +
										localeStr +
											".html";
		return DifferenceGeoprocessPlugin.class.
		getResource(urlStr);
	}

	public URL getImgDescription() {
		return DifferenceGeoprocessPlugin.class.
		getResource("resources/differencedesc.png");
	}

	public IGeoprocessController getGpController() {
		return new DifferenceGeoprocessController();
	}

	public String getNamespace() {
		return analisisPkg + "/" + overlayPkg + "/"+ geoprocessName;
	}
	
	public String toString(){
		return geoprocessName;
	}

}
