/*
 * Created on 09-ago-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: GeoProcessingSpatialJoinPanel2.java,v 1.1.2.1 2006/09/19 19:19:32 azabala Exp $
* $Log: GeoProcessingSpatialJoinPanel2.java,v $
* Revision 1.1.2.1  2006/09/19 19:19:32  azabala
* fixed bug in sumarization functions dialog (always showed fields of the first selected layer in combobox)
*
* Revision 1.1  2006/08/11 16:30:38  azabala
* *** empty log message ***
*
*
*/
package com.iver.cit.gvsig.geoprocess.impl.spatialjoin.gui;

import java.awt.Insets;
import java.util.Map;

import javax.swing.JCheckBox;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel2;
import com.iver.cit.gvsig.geoprocess.core.gui.SpatialJoinNumericFieldSelection;

public class GeoProcessingSpatialJoinPanel2 extends
		GeoProcessingOverlayPanel2 implements SpatialJoinPanelIF{

	
	private JCheckBox nearestCheckbox;
	
	private SpatialJoinNumericFieldSelection fieldDialog;
	
	private Map sumarizeFunctions;
	
	
	public GeoProcessingSpatialJoinPanel2(FLayers layers) {
		super(layers, PluginServices.
							getText(null,
							"Enlace_espacial._Introduccion_de_datos") +
							":");
	}
	protected void addSpecificDesign() {
		super.addSpecificDesign();
		Insets insets = new Insets(5, 5, 5, 5);
		nearestCheckbox = new JCheckBox();
		nearestCheckbox.setText(PluginServices.
				getText(this, "Obtener_mas_proximo"));
		addComponent(nearestCheckbox, insets);
	}

	
	public boolean isNearestSelected() {
		return nearestCheckbox.isSelected();
	}
	
	public FLyrVect getFirstLayer(){
		return this.getInputLayer();
	}

	public boolean openSumarizeFunction() {
		//if(fieldDialog == null){
		//TODO Construirlo una vez, y pasar la capa siempre como parametro
			fieldDialog = new SpatialJoinNumericFieldSelection(getSecondLayer());
			fieldDialog.pack();
		//}
		fieldDialog.setSize(560,300);
		fieldDialog.setVisible(true);
		sumarizeFunctions = fieldDialog.getSumarizationFunctions();
		return fieldDialog.isOk();
	}

	

	public Map getSumarizeFunctions() {
		return sumarizeFunctions;
	}

}

