/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */

package org.gvsig.rasterTools.brightnessContrast;

import org.cresques.filter.RasterFilterStackManager;
import org.gvsig.rasterTools.brightnessContrast.filter.BrightnessContrastStackManager;
import org.gvsig.rasterTools.brightnessContrast.toc.BrightnessContrastTocMenuEntry;
import org.gvsig.rasterTools.pansharpening.filter.PanSharpeningStackManager;
import org.gvsig.rasterTools.pansharpening.toc.PanSharpeningTocMenuEntry;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.gui.View;
import com.iver.cit.gvsig.gui.toc.FLyrRasterAdjustPropertiesTocMenuEntry;
import com.iver.cit.gvsig.gui.toc.FPopupMenu;

/**
 * Extension para los filtros de brillo y contraste de raster
 * @author Miguel ngel Querol Carratal  <querol_mig@gva.es>
 *
 */
public class BrightnessContrastModule extends Extension{

	public void execute(String actionCommand) {
		// TODO Auto-generated method stub
		
	}	
	

	public void initialize() {
		FLyrRasterAdjustPropertiesTocMenuEntry menu = 
			(FLyrRasterAdjustPropertiesTocMenuEntry)FPopupMenu.getEntry("FLyrRasterAdjustPropertiesTocMenuEntry");
		
		BrightnessContrastTocMenuEntry menuEntry = new BrightnessContrastTocMenuEntry(menu);
		RasterFilterStackManager.addClassStackManager(BrightnessContrastStackManager.class);
		
	}

	public boolean isEnabled() {
		// TODO Auto-generated method stub
		return true;
	}

	/**
	 * Mostramos el control si hay alguna capa cargada.
	 */
	public boolean isVisible() {
		com.iver.andami.ui.mdiManager.IWindow f = PluginServices.getMDIManager().getActiveWindow();
		if (f == null) 
			return false;

		return (f  instanceof View);
	}

}
