package com.iver.cit.gvsig.gui.toc;

import java.awt.event.ActionEvent;

import javax.swing.JDialog;
import javax.swing.JMenuItem;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.FLyrWFS;
import com.iver.cit.gvsig.fmap.layers.layerOperations.ClassifiableVectorial;
import com.iver.cit.gvsig.gui.thememanager.FThemeManagerWindow;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSVectorialPropsTocMenuEntry.java,v 1.2 2006/08/29 07:56:12 cesar Exp $
 * $Log: WFSVectorialPropsTocMenuEntry.java,v $
 * Revision 1.2  2006/08/29 07:56:12  cesar
 * Rename the *View* family of classes to *Window* (ie: SingletonView to SingletonWindow, ViewInfo to WindowInfo, etc)
 *
 * Revision 1.1  2006/07/05 12:05:41  jorpiell
 * Se ha modificado para que avise si se han recuperado las mismas features que marca el campo buffer
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSVectorialPropsTocMenuEntry extends TocMenuEntry{
	private JMenuItem prop;
	public void initialize(FPopupMenu m) {
		super.initialize(m);
		FLayer lyr = null;
		if (isTocItemBranch()) {			
			lyr = getNodeLayer();
            if ((lyr instanceof FLyrWFS)) {
				prop = new JMenuItem(PluginServices.getText(this, "propiedades"));
				getMenu().add(prop);
				prop.setFont(FPopupMenu.theFont);
				if (getMapContext().getLayers().getActives().length == 1) {
					prop.setEnabled(true);
				} else {
					prop.setEnabled(false);
				}
				//Cambio estilo
				prop.addActionListener(this);
				
			}
		}
	}
	public void actionPerformed(ActionEvent e) {
		FLayer[] actives = getMapContext().getLayers().getActives();
		FThemeManagerWindow fThemeManagerWindow;
		if (actives.length==1) {
			System.out.println("openPliegoThemeProperties(): Una sola capa. Abrimos el panel para la capa " + actives[0]);
			fThemeManagerWindow = new FThemeManagerWindow();
			try {
				fThemeManagerWindow.setMapContext(getMapContext());
			} catch (com.iver.cit.gvsig.fmap.DriverException e1) {
				e1.printStackTrace();
			}
			//PluginServices.getMDIManager().addView(fThemeManagerWindow);
			if (PluginServices.getMainFrame() == null) {
				JDialog dlg = new JDialog();
				fThemeManagerWindow.setPreferredSize(fThemeManagerWindow.getSize());
				dlg.getContentPane().add(fThemeManagerWindow);
				dlg.setModal(false);
				dlg.pack();
				dlg.show();
			} else {
				PluginServices.getMDIManager().addWindow(fThemeManagerWindow);
			}
		} else {
			for (int i = 0; i < actives.length; i++){
				System.out.println("openPliegoThemeProperties(): Muchas capas. Abrimos el panel para la capa " + actives[i]);
				fThemeManagerWindow = new FThemeManagerWindow(actives[i], getMapContext());
				//PluginServices.getMDIManager().addView(fThemeManagerWindow);
				if (PluginServices.getMainFrame() == null) {
					JDialog dlg = new JDialog();
					fThemeManagerWindow.setPreferredSize(fThemeManagerWindow.getSize());
					dlg.getContentPane().add(fThemeManagerWindow);
					dlg.setModal(false);
					dlg.pack();
					dlg.show();
				} else {
					PluginServices.getMDIManager().addWindow(fThemeManagerWindow);
				}
			}
		}		
	}
	
	
}
