/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 */

package org.gvsig.remoteClient.arcims;

import junit.framework.TestCase;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;
import org.gvsig.remoteClient.arcims.exceptions.ArcImsException;
import org.gvsig.remoteClient.arcims.utils.ServiceInformation;

import com.iver.andami.Launcher;

import java.io.File;

/**
 * Clase de test para probar que el parseserviceInfo funciona desde "fuera" del
 * entorno de ejecucin de gvSIG
 * @author jsanz
 *
 */
public class ArcImsProtocolHandlerTest extends TestCase {
    ArcImsProtocolHandler aipFeatures;
    String baseFilePath = "D:/04_ECLIPSE/gvSIG_10RC1/libArcIMS/test";
    String xmlFilePath = baseFilePath+"/test-data/serviceInfo-bug-CTH.xml";
    String log4jprops = baseFilePath+"/test-data/log4j.properties";
    File f;
    private static Logger logger = Logger.getLogger(ArcImsProtocolHandlerTest.class.getName());
    
    public static void main(String[] args) {
        junit.swingui.TestRunner.run(ArcImsProtocolHandlerTest.class);
    }

    protected void setUp() throws Exception {
        super.setUp();
        f = new File(xmlFilePath);
        aipFeatures = new ArcImsProtFeatureHandler();
        
        //Configurar el log4j
		PropertyConfigurator.configure(log4jprops);
    }

    protected void tearDown() throws Exception {
        super.tearDown();
        aipFeatures = null;
        f = null;
    }

    /*
     * Test method for 'org.gvsig.remoteClient.arcims.ArcImsProtocolHandler.parseServiceInfo(ServiceInformation, File)'
     */
    public void testParseServiceInfo() {
        ServiceInformation msi = null;

        try {
            msi = aipFeatures.parseServiceInfo(new ServiceInformation(), f);
        } catch (ArcImsException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        logger.debug("================================================");
        logger.debug("Starting asserts");
        assertNotNull(msi);
        assertEquals(msi.getLocale().getLanguage(), "es");
        assertEquals(msi.getLocale().getCountry(), "ES");
        assertEquals(msi.getMapunits(), "meters");
        assertEquals(msi.getLayer(0).getId(), "0");
        logger.debug("Finishing asserts, check results");
    }
}
