package org.gvsig.gui.beans.comboBoxItemsSeeker;

import java.awt.Color;
import java.awt.Point;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ComboBoxEditor;
import javax.swing.ComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.JTextComponent;
import javax.swing.text.PlainDocument;
import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoManager;
import javax.swing.undo.UndoableEdit;

import org.apache.log4j.Logger;
import org.gvsig.gui.beans.Messages;
import org.gvsig.gui.beans.optionsEditionByMousePopupMenu.JOptionsEditionByMousePopupMenu;


/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/**  VERSIN EN DESARROLLO
 *  REVISAR COMENTARIOS Y CDIGO QUE PUEDA SOBRAR
 *  
 *  POR DEFECTO USA UN MODELO QUE NO FUNCIONA BIEN SI HAY ITEMS REPETIDOS
 *  
* This class allows users to insert a chain of characters and show all the sentences of the JComboBox that match its first ones characters with it.
* This class is also a Java Bean, and is made according the MVC (Model - View - Controller) pattern.
* This class has the View, the Control and can access to the Model.
* The behavior of this componet can be configurated by 7 flags: (Esto lo cambio!!!!!)
*  + The appearence of the items showed at the beginning and when the user presses the ESCAPE key: (This is configured with 2 flags -> 3 different states are possible) 
*  	   -> maintainPositionItems -> When we see the list of all items, this are showed in the ordenation as they have been introduced (if true); (if false) each new item 
*           when we write on the TextField of this Component will be showed at the end (esto ltimo creo q. no -> revisarlo)
*      -> all_Alphanumeric_Sorted -> All items we can see in this Component will be showed in alphanumeric ordenation (if true)
*  + The list of the items showed when the user makes a search writting or pressing the BACK-SPACE key (This is configured with 1 flag -> 2 different states are possible)
*      -> alphanumericSortedSearches -> When we write on the TextField of this Component all results (items) are showed in alphanumeric ordenation (if true)
*  + case Sensitive or not when the user writes 
*      -> case_Sensitive -> When we write on the TextField it can discriminate upper cases from down cases (if true) or not (if false) (This is configured with 1 flag -> 2 different states are possible)
*  + Show all items always
*      -> showAllItems -> If true -> this component shows all items always; if false -> this component only shows items that their first characters match with the string written by the user
*  + Use one color (black) or 2 colors (black by default and red if the string written doesn't match with the beginning of all items)
*      -> only_One_Color -> The text on the textField only will be showed on black color (if true); false -> if the text on the textField doesn't match with any current item of this component -> the text
*            will be showed on red color
*  +   	 * @param boolean (completeMatchedItem (explicar))
*  + @param boolean (useBeep (explicar))
* 
* Default Values of the Flags:
*  -> maintainPositionItems -> true
*  -> all_Alphanumeric_Sorted -> true
*  -> alphanumericSortedSearches -> false 
*  -> case_Sensitive -> false
*  -> showAllItems -> false
*  -> only_One_Color -> false
*  
*  The flags are distributed in two classes:
*  -> ComboBoxSearcheableDynamicModel -> maintainPositionItems, all_Alphanumeric_Sorted, alphanumericSortedSearches, case_Sensitive, showAllItems 
*  -> JComboBoxSearcheableDynamic -> only_One_Color
* 
* Combinations of flags not allowed:
* 	->	maintainPositionItems == allAlphanumericSorted == true
*	->	((maintain_Position_Items == false) && (all_Alphanumeric_Sorted == true) && (alphanumeric_Sorted_Searches == false))
*   ->  showAllItems == true && maintainPositionItems == false (Creo que esta mal)
* 
* Limitations:
* -> When we add more than one item with the same name (string value) -> the behavior of this component only considers one item in most of the cases when it does a search
* -> If this component has Hundreds,Thousands or even Million/s of items is probably that had quite delay to respond the evens of the user; this also depends of the machine where it's executed and other factors
* 
* @author Pablo Piqueras Bartolom (p_queras@hotmail.com)
*/
public class JComboBoxItemsSeekerConfigurable extends JComboBox implements java.io.Serializable {
	//private static final long serialVersionUID = -1853812970336818959L;
	// PONER SERIALIZACIN
	
	// eSTAS HAY QUE BORRARLAS!
/*	private Vector defaultItems;
	private Set notRemovedItems;
	private Set removedItems;*/
	
	private final int BEGINNING_VIEW_STATE = 0;
	private final int START_VIEW_STATE = 1;
	private final int SEARCH_VIEW_STATE = 2;
	private int currentShowState; // 0 -> at the beginning; 1 -> when is showing the start list of items; 2 -> when is showing a search list of items

	
	// CONFIGURATION FLAGS
	private boolean onlyOneColor;
	private boolean completeMatchedItem;
	private boolean beepEnabled;
	// END FLAGS
	
	// PUEDE QUE TB. sOBren
//	private boolean allItemsAreSorted;
	
	// Last selected item
	private Object selectedItem;
	private Object lastSelectedItem; // This is used for only update (refresh) de popup when a different item is selected
	private String lastDocumentText;
	
	// pueDE QUE TB. SOBRE
	private int num = 0;
//	private JTextField txtField;
	
	private final int POPUP_LIST_ITEMS_HEIGHT = 8;
	// Reference to the ui
	//private MetalComboBoxItemsSeekerUI ui;
	
	// Reference to the model
	private AbstractDefaultComboBoxItemsSeekerConfigurableModel model;
	
	// Some listeners for the Control between the View and de Model
	private KeyListener editorKeyListener;
	private MouseAdapter editorMouseListener;
	private FocusListener editorFocusListener;
	private DocumentListener documentListener;
	private ListDataListener modelListDataListener;
	private PopupMenuListener popupMenuListener;
	private PropertyChangeListener editionMenuListener;

	
	// Reference to the document of the Editor of this component for optimize the seeks
	private PlainDocumentSeeker document;
	
//	private String writtenString;
	
	private boolean continueOnStartViewState;
//	private boolean specialKeys; // ESC and TAB keys
	private boolean textKeyPressed;
	private boolean lastWasTheBeginningState;
	private boolean lastWasPressedAKeyModifier;
	private boolean popupWillBeVisible;
	private boolean optionsEditorWasVisible;
//	private boolean keyPressed;
//	private boolean updatePopUp;
//	private boolean upOrDownKeyPressed;
//	private boolean deleteKeyPressed;
//	private boolean escapeKeyPressed;
	
	// OTRAS FLAGS que puede que sobren alguNAS
	private boolean selecting=false;
	private boolean hidePopupOnFocusLoss;
	private boolean hitBackspace;
	private boolean hitBackspaceOnSelection;
	private boolean allowedRepeatedItems;
	
	// TRACE - DEBUG
	private Logger logger = Logger.getLogger(JComboBoxItemsSeekerConfigurable.class.getClass());
	// END TRACE - DEBUG
	
//	OptionsEditionByMouse optionsEditionByMouse = new OptionsEditionByMouse();
	private JOptionsEditionByMousePopupMenu optionsEditionByMouse;
//	OptionsEditionByMouseV2 pme = new OptionsEditionByMouseV2();
	
	// UNDO-REDO
//	protected UndoManager undo = new UndoManager();
	private UndoManager undoManager;
	private Action undoAction;
	private Action redoAction;
	private final String undoActionKey = "Undo";
	private final String redoActionKey = "Redo";
	private int undoRedoLimitActions;
	// END UNDO-REDO	
	
	/**
	 * Default Constructor
	 */
	public JComboBoxItemsSeekerConfigurable() {
		// Invokes to the parent class constructor		
		super();

		// Create attributes and set initial values
		this.initialize();
		
		// Set the default values of the flags
		this.onlyOneColor = false;
		this.completeMatchedItem = false; //true;
		this.beepEnabled = false; //true;
		
		// Other configuration tasks
		this.createDefaultListeners();
		this.configure();
		//this.configure();

	}
	
	/**
	 * Default Constructor with four parameters: configure the 4 flags
	 * 
	 * @param boolean (true -> maintains the position of the items; false -> don't maintains the position of the items)
	 * @param boolean (true -> all items showed when we write on the textfield will be showed in alphanumeric ordenation; false -> they don't have to be in alphanumeric ordenation)
	 * @param boolean (true -> all items showed will be in alphanumeric ordenation; false -> they don't have to be in alphanumeric ordenation)
	 * @param boolean (true -> discriminates capital letters from small letters; false -> don't discriminates capital letters from small letters)
	 */
	public JComboBoxItemsSeekerConfigurable(int start_Behavior, int search_Behavior, boolean case_Sensitive)	{
		// Invokes to the parent class constructor		
		super();	

		// Create attributes and set initial values
		this.initialize();
		
		// Sets the options selected by the user
//		this.model.setMaintainPositionItems(maintain_Position_Items);
//		this.model.setAllAlphanumericSorted(all_Alphanumeric_Sorted);
//		this.model.setAlphanumericSortedSearches(alphanumeric_Sorted_Searches);
		this.model.setStartBehavior(start_Behavior);
		this.model.setStartBehavior(search_Behavior);
		this.model.setCaseSensitive(case_Sensitive);
//		this.model.setShowAllItems(false);
		this.onlyOneColor = false;
		this.completeMatchedItem = false; //true;
		this.beepEnabled = true;
		
		if (!testFlagsConfigurationOK())
			JOptionPane.showMessageDialog(this, Messages.getText("errorMessageJComboBoxItemsSeekerConfigurable"), Messages.getText("exportJOP2Title"), JOptionPane.ERROR_MESSAGE);
		else
			this.configure();
	}

	/**
	 * Default Constructor with six parameters: configure the 6 flags
	 * 
	 * @param boolean (true -> maintains the position of the items; false -> don't maintains the position of the items)
	 * @param boolean (true -> all items showed when we write on the textfield will be showed in alphanumeric ordenation; false -> they don't have to be in alphanumeric ordenation)
	 * @param boolean (true -> all items showed will be in alphanumeric ordenation; false -> they don't have to be in alphanumeric ordenation)
	 * @param boolean (true -> discriminates capital letters from small letters; false -> don't discriminates capital letters from small letters)
	 * @param boolean (true -> the text on the textField only will be showed on black color (if true); false -> if the text on the textField doesn't match with any current item of this component -> the text
	 *                           will be showed on red color)
  	 * @param boolean (true -> this component shows all items always; false -> this component only shows items that their first characters match with the string written by the user)
  	 * @param boolean (completeMatchedItem (explicar))
  	 * @param boolean (beepEnabled (explicar))
  	 * @param boolean (allowedRepeatedItems (explicar))
	 */
	public JComboBoxItemsSeekerConfigurable(int start_Behavior, int search_Behavior, boolean case_Sensitive, boolean only_One_Color, boolean show_All_Items, boolean complete_Matched_Item, boolean use_Beep, boolean allowed_Repeated_Items) {
		// Invokes to the parent class constructor		
		super();	

		// Create attributes and set initial values
		this.initialize();
		
		// Sets the options selected by the user
//		this.model.setMaintainPositionItems(maintain_Position_Items);
//		this.model.setAllAlphanumericSorted(all_Alphanumeric_Sorted);
//		this.model.setAlphanumericSortedSearches(alphanumeric_Sorted_Searches);
		this.model.setStartBehavior(start_Behavior);
		this.model.setStartBehavior(search_Behavior);
		this.model.setCaseSensitive(case_Sensitive);
//		this.model.setShowAllItems(show_All_Items);
		this.onlyOneColor = only_One_Color;
		this.completeMatchedItem = complete_Matched_Item;
		this.beepEnabled = use_Beep;
		this.allowedRepeatedItems = allowed_Repeated_Items;
		
		if (!testFlagsConfigurationOK())
			JOptionPane.showMessageDialog(this, Messages.getText("errorMessageJComboBoxItemsSeekerConfigurable"), Messages.getText("exportJOP2Title"), JOptionPane.ERROR_MESSAGE);
		else
			this.configure();
	}
	

	/**
	 * 
	 */
	private void initialize() {
//		// Creates the ui for this component and gets it reference
//		super.setUI(new MetalComboBoxItemsSeekerUI());
//		this.ui = (MetalComboBoxItemsSeekerUI) super.getUI();
//		super.setUI(new MetalComboBoxItemsSeekerUI());
		
		// Creates the model for this component and gets it reference
		if (this.isAllowedRepeatedItems())
		{
			super.setModel(new ComboBoxItemsSeekerConfigurableModel());
			this.model = (ComboBoxItemsSeekerConfigurableModel) super.getModel();
		}
		else
		{
			super.setModel(new ComboBoxSingularItemsSeekerConfigurableModel());
			this.model = (ComboBoxSingularItemsSeekerConfigurableModel) super.getModel();
		}
		
        // Allows user to edit on the combobox
		super.setEditable(true);
		
		// By default the last state of showign items was showing all the items (at the beginning of this component)
		currentShowState = BEGINNING_VIEW_STATE;
		
		// Set the last selected item -> if there isn't any item -> -1; else -> this will be 0
		super.setSelectedIndex(-1);
		this.selectedItem = null;
//		logger.debug("selectedItem: " + this.getSelectedIndex());
		
		// By default the keys Up and Down aren't pressed
//		this.upOrDownKeyPressed = false;
		
		// By default the keys Delete aren't pressed
//		this.escapeKeyPressed = false;
		
		// By default any text key has been pressed
		textKeyPressed = false;
		
		allowedRepeatedItems = false;
		
		lastWasPressedAKeyModifier = false;
		
		// By default popup won't be visible when gained the focus the editor associated
		popupWillBeVisible = false;
		
		
		
		hitBackspace=false;
		
		optionsEditionByMouse = new JOptionsEditionByMousePopupMenu();
		optionsEditorWasVisible = false;
		
		undoManager = new UndoManager();
		undoRedoLimitActions = 10; // By default is 1
		undoManager.setLimit(undoRedoLimitActions);
		
//		// By default any key has been pressed
//		keyPressed = false;
		
//		specialKeys = false;
//		updatePopUp = false;
		
		// Remove the default mouse listener
//		super.removeMouseListener(super.getMouseListeners()[0]);
		
		
	}
	
	/**
	 * 
	 */
	private void createDefaultListeners() {
		// TODO Auto-generated method stub		
		
		this.defineEditionMenuPropertyChangeListener(this);
		
        // Define the key listener for the editor of this component
        this.defineEditorKeyListener(this);
         
        // Define the focus listener for the editor of this component
        this.defineEditorFocusListener(this);
        
        this.defineEditorMouseListener(this);
        
        // Define a document listener for changes of text
        this.defineDocumentListener();
         
		// Define the list data listener for the model of this component
        this.defineModelListDataListener();
        
        // Define a popup menu listener for the popup of this component
        this.definePopUpMenuListener(this);
        
        this.defineUndoAndRedoActions();
	}
	
	/**
	 * 
	 */
	private void defineUndoAndRedoActions() {
		// TODO Auto-generated method stub
		
		// Create an undo action
		undoAction = new AbstractAction("Undo") {
            public void actionPerformed(ActionEvent evt) {
                try {
                    if (undoManager.canUndo()) {
                    	undoManager.undo();
                    }
                } catch (CannotUndoException e) {
                }
            }
       };
       
       // Create a redo action
       redoAction = new AbstractAction("Redo") {
           public void actionPerformed(ActionEvent evt) {
               try {
                   if (undoManager.canRedo()) {
                   	undoManager.redo();
                   }
               } catch (CannotRedoException e) {
               }
           }
       };
	}

	private void defineEditionMenuPropertyChangeListener(JComboBoxItemsSeekerConfigurable combo_Box) {
		final JComboBoxItemsSeekerConfigurable comboBoxReference = combo_Box;
		editionMenuListener = new PropertyChangeListener() {

			public void propertyChange(PropertyChangeEvent arg0) {
				// TODO Auto-generated method stub

				if (arg0.getPropertyName().equals(JOptionsEditionByMousePopupMenu.SELECTEDOPTION)) {
	            	JTextComponent editor = (JTextComponent) comboBoxReference.getEditor().getEditorComponent();
		
	            	logger.debug("PropertyChanged: " + arg0.getNewValue().toString());
					
			          switch(Integer.parseInt(arg0.getNewValue().toString()))
			          {//HACER!!
				          case JOptionsEditionByMousePopupMenu.UNDO:
				        	  undoManager.undo();
				        	  break;
				          case JOptionsEditionByMousePopupMenu.REDO:
				        	  undoManager.redo();
				        	  break;
				          case JOptionsEditionByMousePopupMenu.CUT:
				        	  editor.cut();
				        	  break;
				          case JOptionsEditionByMousePopupMenu.COPY:
				        	  editor.copy();
				        	  break;
				          case JOptionsEditionByMousePopupMenu.PASTE:
				        	  editor.paste();
				        	  break;
				          case JOptionsEditionByMousePopupMenu.DELETE:
				        	  deleteTextLogic(editor);
				        	  break;
				          case JOptionsEditionByMousePopupMenu.SELECT_ALL:
				        	  editor.selectAll();
				        	  break;
				          default: // do anything
			          }
				}
				else
				{
					if (arg0.getPropertyName().equals(JOptionsEditionByMousePopupMenu.VISIBILITYCHANGED))
					{
						logger.debug("PropertyChanged: " + arg0.getNewValue().toString());
						
						// First True, after False (when false -> optionsEditorWasVisible = true)
						if (!optionsEditionByMouse.isVisible())
							optionsEditorWasVisible = true;
						else
							optionsEditorWasVisible = false;
					}
				}
			}			
		};
	}
	
	
	/**
	 *  Define a document listener for changes of text
	 */
	private void defineDocumentListener() {
		// TODO Auto-generated method stub
	       documentListener = new DocumentListener() {

			public void changedUpdate(DocumentEvent arg0) {
				// TODO Auto-generated method stub
			}

			public void insertUpdate(DocumentEvent arg0) {
				// TODO Auto-generated method stub

				
				logger.debug("NUM: " + num + " DocumentListener->insertUpdate");
				try {
//					lastDocumentText = document.getText(0, document.getLength())
					logger.debug("Texto insertado: ->" + document.getText(0, document.getLength()) + "<-");
					
				} catch (BadLocationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				num++;				
				
				// Indicate to the model that now is disabled the start view
				 // This is used for the first text inserted to the document when the component is loaded and it does setSelectedIndex(0), to avoid use a search view
				if (currentShowState == BEGINNING_VIEW_STATE)
				{
					currentShowState = START_VIEW_STATE;
					lastWasTheBeginningState = true;
					continueOnStartViewState = true;
					logger.debug("Pasa al estado 1 (de vista inicial)");
				}	
			}

			public void removeUpdate(DocumentEvent arg0) {
				// TODO Auto-generated method stub
				logger.debug("NUM: " + num + " DocumentListener->removeUpdate");
				num++;
			}			
		};
	}
	
	private void updateLastSelectionItem() {
		setSelectedItem(selectedItem);
	}

	/**
	 * 
	 */
	private void configure() {
		// TODO Auto-generated method stub
		
		// Configure the document of the editor of this component
		this.configureDocument();
		
		// Configure the editor (ComboBoxEditor) of this component
		this.configureEditor(this.getEditor());	
		
		// Configure the model of this component
		this.configureModel();
		
		// Configure the popup of this component
		this.configurePopUp();
		
		// Configure the ...
		this.configureOptionsEditionByMouse();
	}
	
	private void configureOptionsEditionByMouse() {
		this.optionsEditionByMouse.addPropertyChangeListener(editionMenuListener);
//		optionsEditionByMouse.addPropertyChangeListener(OptionsEditionByMouse.PROPERTYNAME, editionMenuListener);
	}
	
	/**
	 * 
	 *
	 */
	private void configurePopUp() {
		// TODO Auto-generated method stub
		this.addPopupMenuListener(this.popupMenuListener);
	}

//	/**
//	 * 
//	 */
//	private void uninstallDefaultListeners() {
//        
//
//	}

	/**
	 * 
	 */
	private void configureModel() {
		// TODO Auto-generated method stub
		this.model.addListDataListener(this.modelListDataListener);
	}	

	/**
	 * 
	 */
	private void configureDocument() {
		// TODO Auto-generated method stub
		
		// Creates the document of the editor of this component
        document = new PlainDocumentSeeker();
        document.setJComboBoxItemsSeekerDynamicReference(this);
        
		// Set the written String
//		writtenString = "";
		
		// Remove all Previous document Listeners
//		DocumentListener documentListener[] = document.getDocumentListeners();
//		for (int i=0; i < documentListener.length; i++)
//			document.removeDocumentListener(documentListener[i]);
		
		// Defines and add a Document listener for changes on the document of the editor of this component
		document.addDocumentListener(this.documentListener);
	}
	
	
	/**
	 * Define the list data listener for the model of this component
	 */
    public void defineModelListDataListener() {
		
		this.modelListDataListener = new ListDataListener()	{

			public void contentsChanged(ListDataEvent e) {
				// TODO Auto-generated method stub
//				logger.debug("ContentsChanged");
				
				// This flag indicates to the 'insertString' and 'remove' methods of the PlainDocumentSeeker that the text of the item selected or written by the user
				//  hasn't been written on the TextEditor of ths component
				selecting = false;
			}

			public void intervalAdded(ListDataEvent e) {
				// TODO Auto-generated method stub
	//			logger.debug("intervalAdded");
			}

			public void intervalRemoved(ListDataEvent e) {
				// TODO Auto-generated method stub
	//			logger.debug("intervalRemoved");
			}
			
		};

    }

	/**
	 * Sobra? Contiene cdigo interesante
	 */
	private void defineAndAddPropertyChangeListener() {
		// Define and add a Listener for changes on the editor or the model of the JComboBox
        super.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent ev) {
                if (ev.getPropertyName().equals("editor"))
                	configureEditor((ComboBoxEditor) ev.getNewValue());
                if (ev.getPropertyName().equals("model"))
                {
                	if (isAllowedRepeatedItems())
                		model = (ComboBoxItemsSeekerConfigurableModel) ev.getNewValue();
                	else
                		model = (ComboBoxSingularItemsSeekerConfigurableModel) ev.getNewValue();
                }
            }
        });
	}

	/**
	 * (S SE EST USANDO)
	 */
	private void defineEditorFocusListener(JComboBoxItemsSeekerConfigurable combo_Box) {
		final JComboBoxItemsSeekerConfigurable comboBoxReference = combo_Box;
		
//		 Bug 5100422 on Java 1.5: Editable JComboBox won't hide popup when tabbing out		
		hidePopupOnFocusLoss=System.getProperty("java.version").startsWith("1.5");
		
		// TODO Auto-generated method stub
		// Highlight whole text when gaining focus
		editorFocusListener = new FocusAdapter() {
			public void focusGained(FocusEvent e) {
				if (!optionsEditorWasVisible)
				{
					highlightCompletedText(0);
					logger.debug("currentShowState: " + currentShowState);
					logger.debug("EDITOR FOCUS GAINED");
					
					// This is used when the component has lost the focus, the popup whas in show state and is restored the focus -> update the popup
					//if (() && (currentShowState != BEGINNING_VIEW_STATE))
					if (popupWillBeVisible)
					{
						logger.debug("UPDATE POPUP DESDE EL FOCUSGAINED");
						comboBoxReference.updatePopUpView();
					}
				}
			}
			
			public void focusLost(FocusEvent e) {
				logger.debug("EDITOR FOCUS LOST");
				
				if (isPopupVisible())
					popupWillBeVisible = true;
				else
					popupWillBeVisible = false;
				
				// Workaround for Bug 5100422 - Hide Popup on focus loss
				if (hidePopupOnFocusLoss) comboBoxReference.setPopupVisible(false);
			}
		};
	}
	
	private void defineEditorMouseListener(JComboBoxItemsSeekerConfigurable combo_Box) {
		final JComboBoxItemsSeekerConfigurable comboBoxReference = combo_Box;
		editorMouseListener = new MouseAdapter() {
		
//			public void mousePressed(MouseEvent e) {
//
//	            if (e.isPopupTrigger()) {
//	            	logger.debug("MousePopupTrigered");
//	            }
//			}
//			
//			public void mouseReleased(MouseEvent e) {

			// Debera ser mouseRelease, pero en linux slo deja mousePressed
//			public void mousePressed(MouseEvent e) {
			public void mouseClicked(MouseEvent e) {
				logger.debug("MOUSE-LISTENER : MOUSE-mouseClicked!" + e.getButton());
				logger.debug("MOUSE-LISTENER : MOUSE-mouseClicked!" +e.isPopupTrigger());

				
//	            if (e.isPopupTrigger()) { // Esta lnea funciona de distinta manera en linux ue en windows, en linux va en mousePressed, y en windows va en mouseReleased
				if (e.getButton() == MouseEvent.BUTTON3) {
	            	JTextComponent editor = (JTextComponent) comboBoxReference.getEditor().getEditorComponent();

//	            	editor.selectAll();
	            	
	            	// By default disable all options
	            	optionsEditionByMouse.setEnabledAllOptions(false);
	            	
	            	// Habilitar las opciones disponibles (HACER!!)            	
	            	
	            	
	            	// Enable the "Undo" option if there is any previous state to restore
	            	if (undoManager.canUndo())
	            		optionsEditionByMouse.setEnabledUndoOption(true);
	            	
	            	// Enable the "Redo" option if there is any later state to restore
	            	if (undoManager.canRedo())
	            		optionsEditionByMouse.setEnabledRedoOption(true);
	            	
	            	// Enable the "Copy", "Cut" and "Delete" options if there is text selected
	            	if (editor.getCaretPosition() != editor.getCaret().getMark())
	            	{
	            		optionsEditionByMouse.setEnabledCopyOption(true);
	            		optionsEditionByMouse.setEnabledCutOption(true);
	            		optionsEditionByMouse.setEnabledDeleteOption(true);
	            	}
	            	
//	            	Clipboard clipboard = getToolkit().getSystemClipboard();
//	                Transferable content = clipboard.getContents(this);
	            	// Enable the "Paste" option if there is text on the system's clipboard
	            	if ( getToolkit().getSystemClipboard().getContents(this).toString().length() > 0 )
	            		optionsEditionByMouse.setEnabledPasteOption(true);
	            	
	            	// Enable the "Select-All" option (by default it's always enabled)
	            	optionsEditionByMouse.setEnabledSelectAllOption(true);
	            	
					optionsEditionByMouse.setLocation((int)comboBoxReference.getLocationOnScreen().getX() + e.getX(), (int)comboBoxReference.getLocationOnScreen().getY() + e.getY());
	            	optionsEditionByMouse.setInvoker(comboBoxReference);
	            	optionsEditionByMouse.setVisible(true);
//	            	optionsEditorWasVisible = true;
	            }
	        }
		};
	}

	/**
	 * 
	 */
	private void defineEditorKeyListener(JComboBoxItemsSeekerConfigurable combo_Box) {
		final JComboBoxItemsSeekerConfigurable comboBoxReference = combo_Box;

//		keyPressed = true;
		
		
		// This flag indicates to the 'insertString' and 'remove' methods of the PlainDocumentSeeker that the text of the item selected or written by the user
		//  hasn't been written on the TextEditor of ths component
		
		// TODO Auto-generated method stub
		editorKeyListener = new KeyAdapter()
		{
//			public void keyTyped(KeyEvent ke) {
//				logger.debug("Tecla tecleada: ->" + ke.getKeyChar() + "<- ; Su keyCode es: " + ke.getKeyCode());
//			}
			
			public void keyPressed(KeyEvent ke)  // Executed on the Start view state or Search view state
			{
				// DISTINGUIR SI: slo tienen keyChar  slo keyCode  ambas!!!
				
				logger.debug("Tecla apretada: ->" + ke.getKeyChar() + "<- ; Su keyCode es: " + ke.getKeyCode() + " TIPO: " + Character.getType(ke.getKeyChar()));
				
				if (model.getParentSize() == 0)
				{
					if (beepEnabled)
						comboBoxReference.getToolkit().beep(); // when available use: UIManager.getLookAndFeel().provideErrorFeedback(comboBox);
				}
				else
				{								
					// This flag indicates to the 'insertString' and 'remove' methods of the PlainDocumentSeeker that the text of the item selected or written by the user
					//  hasn't been written on the TextEditor of ths component
					selecting = false;
					
					// This resolves the bug when the popup wasn't seen any time and the uses press a key that updates the view of the popup (the bug is that popup has the items but
					//  aren't seen
					if (lastWasTheBeginningState)
					{
						// This maintains visible the popup
						if (comboBoxReference.isDisplayable())
							comboBoxReference.setPopupVisible(true);
						lastWasTheBeginningState = false;
					}
					
					if (Character.isLetterOrDigit(ke.getKeyChar())) {
						logger.debug("IS LETTER OR DIGIT");
					}
					else
						logger.debug("ISN'T LETTER OR DIGIT");
					
					
//					hitBackspace=false;
					JTextComponent editor = (JTextComponent) comboBoxReference.getEditor().getEditorComponent();
					
//					if (ke.getKeyCode() == 0)
//					{
//						logger.debug("CASO -> KEYCHAR");
//						
//						switch (ke.getKeyChar())
//						{
//							
//						}
//					}
//					else
//					{
//					logger.debug("CASO -> KEYCODE");
					
					

						
						switch (ke.getKeyCode())
						{
							// determine if the pressed key is backspace (needed by the remove method)
							case KeyEvent.VK_BACK_SPACE :
								hitBackspace=true;
								hitBackspaceOnSelection=editor.getSelectionStart()!=editor.getSelectionEnd();

								break;
							// ignore delete key
							case KeyEvent.VK_DELETE : // supr key in spanish keyboard
		//						specialKeys = true;
	//							 This avoids that popup listener could report about it detected item (Este no va)
	//							textKeyPressed = true; 
				
															
										
								deleteTextLogic(editor);
								
//								// Remove selected text:
//								logger.debug("GETMARK: " + editor.getCaret().getMark() + "GETCARETPOSITION" + editor.getCaretPosition());
//	
//								try {
//									// If no characters are selected
//									if (editor.getCaret().getMark() == editor.getCaretPosition())
//									{
//										// Remove the character which is on the right of the caret position
//										if (editor.getCaretPosition() < document.getLength())									
//											document.remove(editor.getCaretPosition(), 1);										
//									}
//									else // If there are characters selected
//									{
//										// Remove the characters which are selected
//		//								int documentLength = document.getLength();
//										int length = Math.abs(editor.getCaret().getMark() - editor.getCaretPosition());
//										
//										// Remove the characters which are selected
//										document.remove(Math.min(editor.getCaret().getMark(), editor.getCaretPosition()), length);
//									}
//								} catch (BadLocationException e) {
//									// TODO Auto-generated catch block
//									e.printStackTrace();
//								}
//								
//								switch(currentShowState)
//								{
//									case START_VIEW_STATE :
//										if (document.getLength() > 0)
//										{										
//											// If dynamic searches:
//											try {
//												// If the search will be dynamic:
//												if (isDynamicSearchConfiguration())
//												{
//													model.setWrittenText(document.getText(0, document.getLength()));
//													logger.debug("Texto que se le enva al modelo desde SUPR: ->" + document.getText(0, document.getLength()) + "<-");						
//												}
//											} catch (BadLocationException e) {
//												// TODO Auto-generated catch block
//												e.printStackTrace();
//											}									
//										
//											// Indicate to the model that now is disabled the start view
//											if (currentShowState == START_VIEW_STATE)
//											{
//												model.setStartViewFlag(false);
//												currentShowState = SEARCH_VIEW_STATE;
//				//								updateLastSelectionItem();
//											}
//										}
//										break;
//									case SEARCH_VIEW_STATE :
//										 // If there isn't characters
//										if (document.getLength() == 0)
//										{
//											// This instruction avoids popup could failure when got invisible
//											hidePopup();
//											
//											// If it's a dynamic search
//											if (isDynamicSearchConfiguration())
//											{
//												model.setWrittenText("");
//												logger.debug("Texto que se le enva al modelo desde SUPR: ->\"\"<-");
//											}
//											
//											// Return to the start view state
//											model.setStartViewFlag(true);
//											currentShowState = START_VIEW_STATE;
//	
//											// Select the first Item 
//											setSelectedIndex(0);
//	
//											highlightCompletedText(0);
//										}
//										else
//										{
//											// If dynamic searches:
//											try {
//												// If the search will be dynamic:
//												if (isDynamicSearchConfiguration())
//												{
//													model.setWrittenText(document.getText(0, document.getLength()));
//													logger.debug("Texto que se le enva al modelo desde SUPR: ->" + document.getText(0, document.getLength()) + "<-");						
//												}
//											} catch (BadLocationException e) {
//												// TODO Auto-generated catch block
//												e.printStackTrace();
//											}
//										}									
//										break;									
//								}
//								
//								updatePopUpView();
								
								break;
							case KeyEvent.VK_ENTER :
		//						try {
		//							specialKeys = true;
									logger.debug("ENTRA EN EL CDIGO DE ENTER");
		
									// Reports about the written text to the model
							        try {
										// Reports about the written text to the model
										if (model.isDynamicSearch())
											model.setWrittenText(document.getText(0, document.getLength()));
								} catch (BadLocationException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
									
									// Indicate to the model that now is disabled the start view
									if (currentShowState == START_VIEW_STATE)
									{
										model.setStartViewFlag(false);
										currentShowState = SEARCH_VIEW_STATE;
		//								updateLastSelectionItem();
									}
		
									
		//							String text = document.getText(0, document.getLength());
		//							document.remove(0, document.getLength());
		//							document.insertString(0, text, null);
		//							
		//							
		//							
		////							// If the text doesn't completely match with the selectedItem.toString() -> if allow 2 colors -> set foreground color to red
		////							if (!onlyOneColor)
		////							{
		////								if (model.isCaseSensitive())
		////								{
		////									if (text.compareTo(getSelectedItem().toString()) != 0)
		////										editor.setForeground(Color.RED);
		////								}
		////								else
		////								{
		////									if (text.toUpperCase().compareTo(getSelectedItem().toString().toUpperCase()) != 0)
		////										editor.setForeground(Color.RED);
		////								}
		////							}
		//						} catch (BadLocationException e1) {
		//							// TODO Auto-generated catch block
		//							e1.printStackTrace();
		//						}
								hidePopup();
								break;
							case KeyEvent.VK_DOWN :
							    // If the key (typed, pressed and) released has been the Down Key -> when there isn't any text (item of the list) selected, select the first
		//						ke.consume();
			//					selecting = true; // For indicate to the 'insertString' of the 'PlainDocumentSeeker' class that an item has been selected
		//						upOrDownKeyPressed = true;
		//						continueOnStartViewState = true;
								
								// This allows user press the key DOWN for select another item of the start view list
		//						if ((model.isStartViewFlag()) && (lastWasStartShow))
		//							lastWasStartShow = true;
								
		//						// Reports about the written text to the model						
		//						try {
		//							if (model.isDynamicSearch())
		//								model.setWrittenText(document.getText(0, document.getLength()));
		//						} catch (BadLocationException e2) {
		//							// TODO Auto-generated catch block
		//							e2.printStackTrace();
		//						}
								
								// If items are disordered -> get the index of the selected item
								if (model.nowItemsAreDisordered())
									updateLastSelectionItem();
								
								if (getItemCount() > 0)
								{
									if (getSelectedIndex() == (getItemCount()-1))
										((JComboBox)comboBoxReference).setSelectedIndex(0);
									else
										((JComboBox)comboBoxReference).setSelectedIndex(getSelectedIndex()+1);
								}
								
		//						model.setCurrentString(getSelectedItem().toString());
								
		//						lastSelectedIndex = getSelectedIndex();
								selectedItem = getSelectedItem();
								showPopup();
								
								break;
							case KeyEvent.VK_UP :
							    // If the key (typed, pressed and) released has been the Up Key -> when there isn't any text (item of the list) selected, select the last
		//						ke.consume();
			//					selecting = true; // For indicate to the 'insertString' of the 'PlainDocumentSeeker' class that an item has been selected
		//						upOrDownKeyPressed = true;
		//						continueOnStartViewState = true;
								
								// This allows user press the key UP for select another item of the start view list
		//						if ((model.isStartViewFlag()) && (lastWasStartShow))
		//							lastWasStartShow = true;
								
		//						// Reports about the written text to the model						
		//						try {
		//							if (model.isDynamicSearch())
		//								model.setWrittenText(document.getText(0, document.getLength()));
		//						} catch (BadLocationException e2) {
		//							// TODO Auto-generated catch block
		//							e2.printStackTrace();
		//						}
		
								// If items are disordered -> get the index of the selected item
								if (model.nowItemsAreDisordered())
									updateLastSelectionItem();
								
								switch(getSelectedIndex())
								{
									case -1: case 0:
										((JComboBox)comboBoxReference).setSelectedIndex(getItemCount()-1);
										break;
									default:
										((JComboBox)comboBoxReference).setSelectedIndex(getSelectedIndex()-1);
								}
								
		//						model.setCurrentString(getSelectedItem().toString());
								selectedItem = getSelectedItem();
		//						lastSelectedIndex = getSelectedIndex();
								showPopup();
								break;
							case KeyEvent.VK_LEFT :						
								// Move the caret to left
								if (editor.getCaretPosition() > 0)
									editor.setCaretPosition(editor.getCaretPosition() - 1);
								else
								{
					                // User hit backspace with the cursor positioned on the start => beep
					            	if (beepEnabled)
					            		getToolkit().beep(); // when available use: UIManager.getLookAndFeel().provideErrorFeedback(comboBox);
								}
								//ke.consume();
								break;
							case  KeyEvent.VK_RIGHT :
								// Move the caret to right
								try {
									if (editor.getCaretPosition() < (document.getText(0, document.getLength())).length())
										editor.setCaretPosition(editor.getCaretPosition() + 1);
									else
									{
									    // User hit backspace with the cursor positioned on the start => beep
										if (beepEnabled)
											getToolkit().beep(); // when available use: UIManager.getLookAndFeel().provideErrorFeedback(comboBox);
									}
								} catch (BadLocationException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								//ke.consume();
								break;
							case  KeyEvent.VK_PAGE_DOWN :
								if (getItemCount() > 0)
//								if (getSelectedIndex() != -1)
								{
		//							// Reports about the written text to the model						
		//							try {
		//								if (model.isDynamicSearch())
		//									model.setWrittenText(document.getText(0, document.getLength()));
		//							} catch (BadLocationException e2) {
		//								// TODO Auto-generated catch block
		//								e2.printStackTrace();
		//							}
									
									int index;
									
									if (getSelectedIndex() == -1)
										index = 0;
									else
										index = getSelectedIndex() + POPUP_LIST_ITEMS_HEIGHT;
									
									if (index < getItemCount())
										setSelectedIndex(index);
									else
										setSelectedIndex(getItemCount()-1);
									
									selectedItem = getSelectedItem();
								}
		
							//	ke.consume();
								break;
							case KeyEvent.VK_PAGE_UP :
								if (getItemCount() > 0)
//								if (getSelectedIndex() != -1)
								{
		//							// Reports about the written text to the model						
		//							try {
		//								if (model.isDynamicSearch())
		//									model.setWrittenText(document.getText(0, document.getLength()));
		//							} catch (BadLocationException e2) {
		//								// TODO Auto-generated catch block
		//								e2.printStackTrace();
		//							}
									
									int index;
									
									if (getSelectedIndex() == -1)
										index = getItemCount() - 1;
									else
										index = getSelectedIndex() - POPUP_LIST_ITEMS_HEIGHT;
									
									if (index > -1)
										setSelectedIndex(index);
									else
										setSelectedIndex(0);
									
									selectedItem = getSelectedItem();
								}
		
							//	ke.consume();
								break;
							case KeyEvent.VK_HOME : // 'Inicio' key on the spanish keyboard
								editor.setCaretPosition(0);
								break;
							case KeyEvent.VK_END :  // 'Fin' key on the spanish keyboard
								editor.setCaretPosition(document.getLength());
								break;
							case KeyEvent.VK_TAB :
		//						specialKeys = true;
								
								// This avoids that popup listener could report about it detected item
								textKeyPressed = true;
								
								if (model.getSize() > 0)
								{
		//							logger.debug("SelectedIndex: " + getSelectedIndex());
		//							boolean update = false;
									
									if (((JComboBox)comboBoxReference).getSelectedIndex() == -1)
									{
		//								lastSelectedIndex = 0;
		//								((JComboBox)comboBoxReference).setSelectedIndex(0);
										//updatePopUp = true; // Indicate to the document.insertString that has update the popup after insert
		//								updatePopUpView();
		//								comboBoxReference.setSelectedIndex(0);
										selectedItem = comboBoxReference.getItemAt(0); //.getSelectedItem();
									}
									else
									{
		//								lastSelectedIndex = getSelectedIndex();
		//								updatePopUp = true; // Indicate to the document.insertString that has update the popup after insert
		//								updatePopUpView();
										selectedItem = comboBoxReference.getSelectedItem();
										
		//								setSelectedIndex());	// Complete the item string value in the document of the editor
		//								update = true;
									}
		
									document.setText(selectedItem.toString());
									
									// Reports about the written text to the model						
	//								try {
									if (model.isDynamicSearch()) {
										model.setWrittenText(selectedItem.toString());
										logger.debug("Texto que se le enva al modelo: ->" + selectedItem.toString() + "<-");
									}		
											
	//								} catch (BadLocationException e2) {
	//									// TODO Auto-generated catch block
	//									e2.printStackTrace();
	//								}
	//								
									if (currentShowState == START_VIEW_STATE)
									{
										model.setStartViewFlag(false);
										currentShowState = SEARCH_VIEW_STATE;
		//								updatePopUpView(); // Update to the new popup view
									}
		
									
									// It's supposed that the text on the document is equal as the string value of the selected item -> then text must be on black color
									comboBoxReference.getEditor().getEditorComponent().setForeground(Color.BLACK);
									
									updatePopUpView();
		
									
		//							document.setText(selectedItem.toString());
									
		//							continueOnStartViewState = false;
		
									// HidePopUp + ShowPopUp to force update the popup list of items
		//							hidePopup();
		//							showPopup();
		////							hidePopup();
								}
								break;
							case KeyEvent.VK_ESCAPE :
								// Reset to the Start View State
		//						model.setStartViewFlag(true);
								
								// Force update the popup
								if (isPopupVisible())
									hidePopup();
		
								model.setWrittenText("");
								selectedItem = null;
								
		//						currentShowState = START_VIEW_STATE;
								if (currentShowState == SEARCH_VIEW_STATE)
								{	
									try {
										document.remove(0, document.getLength());
									} catch (BadLocationException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
									
		//							setSelectedItem(selectedItem);
		//							setSelectedIndex(model.getIndexOf(selectedItem));
									
									// Return to the start view state
									model.setStartViewFlag(true);
									currentShowState = START_VIEW_STATE;
			//						escapeKeyPressed = true;
		//							continueOnStartViewState = true;
			
									// If items are disordered -> get the index of the selected item
		//							if (model.nowItemsAreDisordered())
		//								updateLastSelectionItem();
	
									// Select the first Item
									setSelectedIndex(0);
	//								selectFirstItemAddedToModel();
		
		//							updatePopUp = true;
		//							updatePopUpView();
									
									//updateLastSelectionItem();
			//						setSelectedIndex(lastSelectedIndex);
									highlightCompletedText(0);
									// HidePopUp + ShowPopUp to force update the popup list of items
			//						hidePopup();
			//						showPopup();
								}
								else
								{
		//							 Select the first Item
									setSelectedIndex(0);
	//								selectFirstItemAddedToModel();
									
									highlightCompletedText(0);
								}
								updatePopUpView();
								break;
							case KeyEvent.VK_SHIFT : // Do nothing
								break;
							case KeyEvent.VK_ALT_GRAPH : // Do nothing
								break;
							case KeyEvent.VK_ALT : // Do nothing			
								break;
							case KeyEvent.VK_CONTROL : // Do nothing
								break;
							case KeyEvent.VK_NUM_LOCK : // Do nothing
								break;
							case KeyEvent.VK_CAPS_LOCK : // Do nothing
								break;
							default:
								logger.debug("Actualiza view flag a false");
							
								logger.debug("LASTITEM1 :" + lastSelectedItem);
		
								logger.debug("GETMARK: " + editor.getCaret().getMark() + "GETCARETPOSITION" + editor.getCaretPosition());
	
								// If it has been pressed a modifier key (Examples: ^ `  ), not consume the key pressed
								if ((Character.getType(ke.getKeyChar()) == Character.MODIFIER_LETTER) || (Character.getType(ke.getKeyChar()) == Character.MODIFIER_SYMBOL))
								{
									logger.debug("CARCTER MODIFICADOR");
									lastWasPressedAKeyModifier = true;
								}
								else
								{
									logger.debug("CARCTER NO MODIFICADOR");
	
						        	if (lastWasPressedAKeyModifier)
						        	{
						        		logger.debug("PRESSED: " + editor.getText().substring(0));
						        		lastWasPressedAKeyModifier = false;
						        	}
						        	
//							        if (!isOnlyOneColor())
//							        	comboBoxReference.getEditor().getEditorComponent().setForeground(Color.RED);
//									
							        if (model.isDynamicSearch())
							        {
							        	// Force update the popup	
	
							        	String text;
							        	if (editor.getCaretPosition() == editor.getCaret().getMark())
							        		text = editor.getText().substring(0, editor.getCaretPosition()) + ke.getKeyChar() + editor.getText().substring(editor.getCaretPosition(), editor.getText().length());
							        	else
							        	{
							        		text = "" + editor.getText().substring(0, (int) Math.min(editor.getCaretPosition(), editor.getCaret().getMark())) + ke.getKeyChar();
							        		text += editor.getText().substring((int) Math.max(editor.getCaretPosition(), editor.getCaret().getMark()), editor.getText().length());
							        	}
							        	
							    		// Reports about the written text to the model						
						   				logger.debug("Texto que se le enva KEY al modelo: ->" + text + "<-");
					    				model.setWrittenText(text);	
							    		
							    		// Indicate to the model that now is disabled the start view
							    		if (currentShowState == START_VIEW_STATE)
							    		{
							    			model.setStartViewFlag(false);
							    			currentShowState = SEARCH_VIEW_STATE;
			//				    			updateLastSelectionItem();
							    		}
							    		
			
			//				    		textKeyPressed = false;
							        }
		
						        updatePopUpView();
								textKeyPressed = true;
								
								
								logger.debug("Key Pressed:" + ke.getKeyCode());
							}
						}
						
						// Consume the key event for not to use the handler of the keyboard of other components
						// Only if it has been pressed a modifier key, not consume the key pressed
						if (!lastWasPressedAKeyModifier)
						{
							ke.consume();
						}
		            }
				}
//			}
		};
		
//		keyPressed = false;
	}
	
	private void deleteTextLogic(JTextComponent editor) {
		
		// Remove selected text:
		logger.debug("GETMARK: " + editor.getCaret().getMark() + "GETCARETPOSITION" + editor.getCaretPosition());

		try {
			// If no characters are selected
			if (editor.getCaret().getMark() == editor.getCaretPosition())
			{
				// Remove the character which is on the right of the caret position
				if (editor.getCaretPosition() < document.getLength())									
					document.remove(editor.getCaretPosition(), 1);										
			}
			else // If there are characters selected
			{
				// Remove the characters which are selected
//								int documentLength = document.getLength();
				int length = Math.abs(editor.getCaret().getMark() - editor.getCaretPosition());
				
				// Remove the characters which are selected
				document.remove(Math.min(editor.getCaret().getMark(), editor.getCaretPosition()), length);
			}
		} catch (BadLocationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		
		switch(currentShowState)
		{
			case START_VIEW_STATE :
				if (document.getLength() > 0)
				{										
					// If dynamic searches:
					try {
						// If the search will be dynamic:
						if (isDynamicSearchConfiguration())
						{
							model.setWrittenText(document.getText(0, document.getLength()));
							logger.debug("Texto que se le enva al modelo desde SUPR: ->" + document.getText(0, document.getLength()) + "<-");						
						}
					} catch (BadLocationException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}									
				
					// Indicate to the model that now is disabled the start view
					if (currentShowState == START_VIEW_STATE)
					{
						model.setStartViewFlag(false);
						currentShowState = SEARCH_VIEW_STATE;
//								updateLastSelectionItem();
					}
				}
				break;
			case SEARCH_VIEW_STATE :
				 // If there isn't characters
				if (document.getLength() == 0)
				{
					// This instruction avoids popup could failure when got invisible
					hidePopup();
					
					// If it's a dynamic search
					if (isDynamicSearchConfiguration())
					{
						model.setWrittenText("");
						logger.debug("Texto que se le enva al modelo desde SUPR: ->\"\"<-");
					}
					
					// Return to the start view state
					model.setStartViewFlag(true);
					currentShowState = START_VIEW_STATE;

					// Select the first Item 
					setSelectedIndex(0);

					highlightCompletedText(0);
				}
				else
				{
					// If dynamic searches:
					try {
						// If the search will be dynamic:
						if (isDynamicSearchConfiguration())
						{
							model.setWrittenText(document.getText(0, document.getLength()));
							logger.debug("Texto que se le enva al modelo desde SUPR: ->" + document.getText(0, document.getLength()) + "<-");						
						}
					} catch (BadLocationException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}									
				break;									
		}
		
		updatePopUpView();
		
	}
	
	/**
	 * 
	 */
	private void definePopUpMenuListener(JComboBoxItemsSeekerConfigurable combo_Box) {
		final JComboBoxItemsSeekerConfigurable comboBoxReference = combo_Box;
				
			this.popupMenuListener = new PopupMenuListener() {

			/*
			 *  (non-Javadoc)
			 * @see javax.swing.event.PopupMenuListener#popupMenuCanceled(javax.swing.event.PopupMenuEvent)
			 */
			public void popupMenuCanceled(PopupMenuEvent e) {
				// TODO Auto-generated method stub
				logger.debug("MenuCANCELED");
				
//				// This is used when the component has lost the focus, the popup whas in show state and is restored the focus -> update the popup
//				if (isPopupVisible())
//					popupVisible = true;
//				else
//					popupVisible = false;
			}

			/*
			 *  (non-Javadoc)
			 * @see javax.swing.event.PopupMenuListener#popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent)
			 */
			public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
				// TODO Auto-generated method stub
				logger.debug("MenuBECOMEINVISIBLE");
//				popupVisible = false;
				
			
//				if ((!textKeyPressed) && (!optionsEditorWasVisible))
				if (!textKeyPressed)
				{
					if (lastSelectedItem != null)
					{
				        // If the user has select a different item with the mouse, and this is in the Start View State -> change to the Search View State 
						if (!getSelectedItem().equals(lastSelectedItem))
						{
							logger.debug("POPUP: NO SON IGUALES");
							
							// Reports about the written text to the model
							if (model.isDynamicSearch())
							{
								model.setWrittenText(getSelectedItem().toString());
								logger.debug("Texto que le envia POPUP al modelo: ->" + getSelectedItem().toString() + "<-");
							}
								
							if (currentShowState == START_VIEW_STATE)
							{
								model.setStartViewFlag(false);
								currentShowState = SEARCH_VIEW_STATE;
		//						updateLastSelectionItem();
							}
							logger.debug("Selected index of item: " + lastSelectedItem.toString() + " is " + getSelectedIndex());
	//						updatePopUpView();
	//						setSelectedIndex(1);
						}
						else
							logger.debug("POPUP: SON IGUALES");
					}
				}
			}

			/*
			 *  (non-Javadoc)
			 * @see javax.swing.event.PopupMenuListener#popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent)
			 */
			public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
				// TODO Auto-generated method stub
				logger.debug("MenuBECOMEVISIBLE");
//				popupVisible = true;
				lastSelectedItem = selectedItem; // This object is used for know if the user has select a different item with the mouse
			}			
		};
	 }
		 

/**
 * Returns true if the model has a dynamic search configuration
 * 
 * @return
 */
private boolean isDynamicSearchConfiguration() {
	switch(model.getSearchBehavior())
	{
		case AbstractDefaultComboBoxItemsSeekerConfigurableModel.MAINTAIN_ORIGINAL_POSITION_DYNAMIC_SEARCH :
		case AbstractDefaultComboBoxItemsSeekerConfigurableModel.ORDERED_DYNAMIC_SEARCH :
		case AbstractDefaultComboBoxItemsSeekerConfigurableModel.DISORDERED_DYNAMIC_SEARCH :
			return true;
	}
	
	return false;
}
		 
		 
//		comboBoxReference.getUI().
//		for (int i=0; i<comboBoxReference.getComponentCount(); i++) {
//			logger.debug("Componente: " + comboBoxReference.getComponent(i).getName());
//			comboBoxReference.getComponent(i).addMouseListener(editorMouseListener);
//			
//			}
//		this.addMouseListener(editorMouseListener);
//	}
	
	/**
	 * Selects the first item added to the model
	 */
	public void selectFirstItemAddedToModel() {
		// Select the first Item added
		Object item = model.getFirstItemAdded();
		if (item != null)
			setSelectedItem(item);
	}
	
	private void configureEditor(ComboBoxEditor newEditor) {
    	JTextComponent editor = (JTextComponent) this.getEditor().getEditorComponent();		

    	// If there isn't any change on the editor
    	if (editor == newEditor)
    		return;
    	
		// Remove the default or last keyListener and FocusListener of the editor of this component
        if (editor != null) {
            editor.removeKeyListener(this.editorKeyListener);
            editor.removeMouseListener(this.editorMouseListener);
            editor.removeFocusListener(this.editorFocusListener);
 
            editor.getActionMap().remove(this.undoActionKey); // If exists -> remove this action
            editor.getActionMap().remove(this.redoActionKey); // If exists -> remove this action
        }
        
        // Add the new keyListener and FocusListener for this editor and sets
        //   it document as a PlainDocument to optimize the searches of items
        //   when user writes on this editor
        if (newEditor != null) {
            editor = (JTextComponent) newEditor.getEditorComponent();
            editor.addKeyListener(this.editorKeyListener);
            editor.addMouseListener(this.editorMouseListener);
            editor.addFocusListener(this.editorFocusListener);
            editor.setDocument(this.document);
            
    		// Disable the focus transversal keys (Example: CTRL+TAB) for enable the TAB key
    		editor.setFocusTraversalKeysEnabled(false);
    		
	        
	        // Add it to the text component
	        editor.getActionMap().put(this.undoActionKey, undoAction);
	        
	        // Bind the undo action to ctl-Z
//	        editor.getInputMap().put(KeyStroke.getKeyStroke("control Z"), "Undo");
	        
	        // Add a redo action to the text component
	        editor.getActionMap().put(this.redoActionKey, redoAction);

	        
	        // Bind the redo action to ctl-Y
//	        editor.getInputMap().put(KeyStroke.getKeyStroke("control Y"), "Redo");

        }
        
//        editor.add(optionsEditionByMouse);
//        ((JButton)this.getComponent(0)).add(optionsEditionByMouse);
	}
	
	/**
	 * Marks text since 'start' position to its end on a grey color
	 *  
	 * @param start Start position for mark the text
	 */
    private void highlightCompletedText(int start) {
    	JTextComponent editor = (JTextComponent) this.getEditor().getEditorComponent();
    	
        editor.setCaretPosition(document.getLength());
        editor.moveCaretPosition(start);
    }
    
    /**
     *
     */
    private void updatePopUpView() {
    	// HidePopUp + ShowPopUp to force update the popup list of items
		hidePopup();
		showPopup();
		this.setVisible(true);
    }
    
////// REDEFINITION OF SOME METHODS OF JCOMBOBOX //////


	/*
	 *  (non-Javadoc)
	 * @see javax.swing.JComboBox#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e)
	{
		super.actionPerformed(e);
//		logger.debug("Action-Performed");

		// This flag indicates to the 'insertString' method of the PlainDocumentSeeker that the text of the item selected or written by the user
		//  hasn't been written on the TextEditor of ths component
		selecting = false;
	}

    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#addItem(java.lang.Object)
     */
    public void addItem(Object anObject) {
		// Adds the item to this component		
		model.addElement(anObject);
		
//		logger.debug("LastSelectedIndexWas: " + this.lastSelectedIndex);
		
		// Set the last selected item -> by default select the first item:
		// This is used to show the first item that model returns when we add a new item. This also
		//  corrects the 'mistake' produced by 'ComboBoxModel' when is added a new item and there wasn't
		//  any selected -> that the 'ComboBoxModel' selects by default the first added (that in our case 
		//  might not be the same as the first item seen in the popup list)
		if (this.getSelectedIndex() != 0)
		{
			this.setSelectedIndex(0);
			this.selectedItem = this.getSelectedItem();
		}
	}
    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#removeAllItems()
     */
    public void	removeAllItems() {
    	// Removes all items from the model
    	model.removeAllElements();
    	
    	currentShowState = BEGINNING_VIEW_STATE;
    }
    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#removeItem(java.lang.Object)
     */
    public void	removeItem(Object anObject) {
    	// Removes an object from the model
    	model.removeElement(anObject);
    	
    	if (model.getSize() == 0)
    		currentShowState = BEGINNING_VIEW_STATE;
    }

    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#removeItemAt(int)
     */
    public void	removeItemAt(int anIndex) {
       	// Removes an object, which is in a determinated position (index), from the model
    	model.removeElementAt(anIndex);
    	
    	if (model.getSize() == 0)
    		currentShowState = BEGINNING_VIEW_STATE;
    }
    
//    /*
//     * (non-Javadoc)
//     * @see javax.swing.JComboBox#getSelectedIndex()
//     */
//    public int getSelectedIndex() {
//    	// ?Modificarlo?
//    	return super.getSelectedIndex();
//    }
    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#getItemCount()
     */
    public int getItemCount() {
    	return model.getSize();
    }
    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#getItemAt(int)
     */
    public Object getItemAt(int index) {
    	return model.getElementAt(index);
    }
    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#setModel(javax.swing.ComboBoxModel)
     */
    public void setModel(ComboBoxModel aModel) { //PROBLEMA
    	
    	// Depending on the type of class of the current object, this object will execute different code
    	if ( (aModel instanceof ComboBoxSingularItemsSeekerConfigurableModel) || (aModel instanceof ComboBoxItemsSeekerConfigurableModel) )
    	{
//    		logger.debug("A");
    		//super.setModel(aModel);
    		super.setModel(aModel);
    		
    		if (aModel instanceof ComboBoxSingularItemsSeekerConfigurableModel)
    			model = (ComboBoxSingularItemsSeekerConfigurableModel)super.getModel();
    		else
    			model = (ComboBoxItemsSeekerConfigurableModel)super.getModel();
    		
    		// If we insert a model with items -> select by default the first
    		if (aModel.getSize() > 0)
    		{
    			this.setSelectedIndex(0);
    			this.selectedItem = this.getSelectedItem();
//    			model.setCurrentString(this.getSelectedItem().toString());
    		}
    		else
    		{
    			// Else -> set the default index (-1) and current showed string ("")
    			this.selectedItem = null;
    			this.setSelectedIndex(-1);
//    			model.setCurrentString("");
    		}
    		
    		this.configureModel();
    	}
    	else
    	{
    		// If it's an instance of DefaultComboBoxModel:
    		
//    		logger.debug("B");
    		super.setModel(aModel);    		
    	}    		
     }
    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#setSelectedIndex(int)
     */
    public void setSelectedIndex(int anIndex) {
    	super.setSelectedIndex(anIndex);
    	this.selectedItem = super.getSelectedItem();
    	
//    	this.lastSelectedIndex = anIndex;
    	
    	try {
			document.remove(0, document.getLength());
			if (getSelectedIndex() > -1)
				document.insertString(0, getSelectedItem().toString(), null);
//			else
//				this.lastSelectedIndex = -1;
			
		} catch (BadLocationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
    }
    
    /*
     * (non-Javadoc)
     * @see javax.swing.JComboBox#getSelectedIndex()
     */
    public int getSelectedIndex() {
    	Object item = this.getSelectedItem();
    	
    	if (item == null)
    		return -1;
    	else
    		return model.getIndexOf(item);
    }
    
    /*
     *  (non-Javadoc)
     * @see javax.swing.JComboBox#setSelectedItem(java.lang.Object)
     */
    public void setSelectedItem(Object anObject) {
    	super.setSelectedItem(anObject);
    	this.selectedItem = super.getSelectedItem();
//    	this.lastSelectedIndex = model.getIndexOf(anObject);
//    	logger.debug("Posicin: " + this.lastSelectedIndex);
    	
    	//super.setSelectedIndex(this.lastSelectedIndex);
    	
//    	try {
//			document.remove(0, document.getLength());
//			if (getSelectedIndex() > -1)
//				document.insertString(0, getSelectedItem().toString(), null);
//			else
//				this.lastSelectedIndex = -1;
//			
//		} catch (BadLocationException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}		
    }
    
//    
    ////// END REDEFINITION OF SOME METHODS OF JCOMBOBOX //////
	
    
    
    
	
	////// METHODS FOR THE BEHAVIOR FLAGS  //////

	/**
	 * This method tests the configuration of the flags and returns true or false if its ok or not with the
	 *   logical behavior of this component
	 * 
	 * @return boolean True if the configuration of the flags is oks, false if not
	 */
	public boolean testFlagsConfigurationOK() {
		return this.model.testFlagsConfigurationOK();
	}
	
	public int getStartBehavior() {
		return this.model.getStartBehavior();
	}
	
	public void setStartBehavior(int start_Behavior) {
		this.model.setStartBehavior(start_Behavior);
		
		if (!this.model.testFlagsConfigurationOK())
			JOptionPane.showMessageDialog(this, Messages.getText("errorMessageJComboBoxItemsSeekerConfigurable"), Messages.getText("exportJOP2Title"), JOptionPane.ERROR_MESSAGE);
		else
			updateLastSelectionItem();
	}

	public int getSearchBehavior() {
		return this.model.getSearchBehavior();
	}

	public void setSearchBehavior(int search_Behavior) {
		this.model.setSearchBehavior(search_Behavior);
		
		if (!this.model.testFlagsConfigurationOK())
			JOptionPane.showMessageDialog(this, Messages.getText("errorMessageJComboBoxItemsSeekerConfigurable"), Messages.getText("exportJOP2Title"), JOptionPane.ERROR_MESSAGE);
		else
			updateLastSelectionItem();
	}

	
	/**
	 * Gets the flag of the configuration of the caseSensitive flag of this component 
	 * (true -> discriminates capital letters from small letters ,false -> don't discriminates capital letters from small letters)
	 * 
	 * @return boolean The value of the flag
	 */
	public boolean isCaseSensitive() {
		return this.model.isCaseSensitive();
	}
	
	/**
	 * Sets the flag of the configuration of the caseSensitive flag of this component 
	 * (true -> discriminates capital letters from small letters ,false -> don't discriminates capital letters from small letters)
	 * 
	 * @param boolean The value of the flag
	 */
	public void setCaseSensitive(boolean case_Sensitive) {
		this.model.setCaseSensitive(case_Sensitive);
		
		if (!this.model.testFlagsConfigurationOK())
			JOptionPane.showMessageDialog(this, Messages.getText("errorMessageJComboBoxItemsSeekerConfigurable"), Messages.getText("exportJOP2Title"), JOptionPane.ERROR_MESSAGE);
	}

	/**
	 * Gets the flag of the configuration of the onlyOneColor flag of this component
	 * (true -> The text on the textField only will be showed on black color; false -> if the text on the textField doesn't match with any current item of this 
	 *            component -> the text will be showed on red color)
	 * 
	 * @return boolean The value of the flag
	 */
	public boolean isOnlyOneColor() {
		return onlyOneColor;
	}

	
	/**
	 * Sets the flag of the configuration of the onlyOneColor flag of this component 
	 * (true -> discriminates capital letters from small letters ,false -> don't discriminates capital letters from small letters)
	 * 
	 * @param boolean The value of the flag
	 */
	public void setOnlyOneColor(boolean only_One_Color) {
		this.onlyOneColor = only_One_Color;
		
		if (!this.model.testFlagsConfigurationOK())
			JOptionPane.showMessageDialog(this, Messages.getText("errorMessageJComboBoxItemsSeekerConfigurable"), Messages.getText("exportJOP2Title"), JOptionPane.ERROR_MESSAGE);
	}
	

	public boolean isBeepEnabled() {
		return this.beepEnabled;
	}
	
	public void setBeepEnabled(boolean beep_Enabled) {
		this.beepEnabled = beep_Enabled;
	}
	
	public boolean isCompleteMatchedItem() {
		return this.completeMatchedItem;
	}
	
	public void setCompleteMatchedItem(boolean Complete_Matched_Item) {
		this.completeMatchedItem = Complete_Matched_Item;
	}

	public boolean isAllowedRepeatedItems() {
		return this.allowedRepeatedItems;
	}
	
	public void setAllowedRepeatedItems(boolean allowed_Repeated_Items) {
		this.allowedRepeatedItems = allowed_Repeated_Items;
		
		try {
			AbstractDefaultComboBoxItemsSeekerConfigurableModel model_temp;
//			if (model.getSize() > 0)
//			{
				// Add the items to the new model
				if (allowed_Repeated_Items)
					model_temp = new ComboBoxItemsSeekerConfigurableModel(model.getParentAllData());
				else
					model_temp = new ComboBoxSingularItemsSeekerConfigurableModel(model.getParentAllData());
								
				// Copy the behavior of the model
				model_temp.setStartBehavior(this.getStartBehavior());
				model_temp.setSearchBehavior(this.getSearchBehavior());
				model_temp.setCaseSensitive(this.isCaseSensitive());
				
				// Set the new model
				this.setModel(model_temp);
//			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	
	
	////// END METHODS FOR THE BEHAVIOR FLAGS  //////
	
	////// IMPLEMENTATION OF THE METHODS OF THE INTERFACE 'PropertyChangeListener' //////
	/* (non-Javadoc)
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
//	public void propertyChange(PropertyChangeEvent arg0) {
//		// TODO Auto-generated method stub
//    	logger.debug("AAAAAAAAA");
//
//		if (arg0.getPropertyName().equals(OptionsEditionByMouse.PROPERTYNAME)) {
//        	JTextComponent editor = (JTextComponent) getEditor().getEditorComponent();
//
//        	logger.debug("PropertyChanged: " + arg0.getNewValue().toString());
//			
//	          switch(Integer.parseInt(arg0.getNewValue().toString()))
//	          {//HACER!!
//		          case OptionsEditionByMouse.UNDO:
//		        	  break;
//		          case OptionsEditionByMouse.REDO:
//		        	  break;
//		          case OptionsEditionByMouse.CUT:
//		        	  break;
//		          case OptionsEditionByMouse.COPY:
//		        	  break;
//		          case OptionsEditionByMouse.PASTE:
//		        	  break;
//		          case OptionsEditionByMouse.DELETE:
//		        	  try {
//						document.remove(0, document.getLength());
//					} catch (BadLocationException e) {
//						// TODO Auto-generated catch block
//						e.printStackTrace();
//					}
//		        	  break;
//		          case OptionsEditionByMouse.SELECT_ALL:
//		        	  break;
//		          default: // do anything
//	          }
//		}
//
//	}

	////// END IMPLEMENTATION OF THE METHODS OF THE INTERFACE 'PropertyChangeListener' //////
	
	/** REVISAR COMENTARIOS Y CDIGO
	 * Inner class for optimize the seek of items
	 * 
	 * @author Pablo Piqueras Bartolom (p_queras@hotmail.com)
	 *
	 */
	private class PlainDocumentSeeker extends PlainDocument{
		private JComboBoxItemsSeekerConfigurable comboBoxReference;
//    	private final UndoManager undoManager = new UndoManager();

		/**
		 * Default Constructor
		 */
		public PlainDocumentSeeker() {
			super();
			this.configureUndoManager();
		}
		
		/**
		 * 
		 */
		private void configureUndoManager() {
			// TODO Auto-generated method stub
			
	        // Listen for undo and redo events
	        this.addUndoableEditListener(new UndoableEditListener() {
	            public void undoableEditHappened(UndoableEditEvent evt) {
	                undoManager.addEdit(evt.getEdit());
	            }
	        });
		}

		/**
		 * Sets a reference of the combo_Box
		 * 
		 * @param combo_Box
		 */
		public void setJComboBoxItemsSeekerDynamicReference(JComboBoxItemsSeekerConfigurable combo_Box) {
			comboBoxReference = combo_Box;
		}
		
		/* REVISAR
		 *  (non-Javadoc)
		 * @see javax.swing.text.Document#remove(int, int)
		 */
		public void remove(int offs, int len) throws BadLocationException {
	        // return immediately when selecting an item
	        if (selecting) return;

	        if (hitBackspace)
	        {
	            // user hit backspace => move the selection backwards
	            // old item keeps being selected
	            if (offs>0)
	            {
	                if (hitBackspaceOnSelection)
	                	offs--;
	            }
	            else
	            {
	                // User hit backspace with the cursor positioned on the start => beep
	            	if (beepEnabled)
	            		comboBoxReference.getToolkit().beep(); // when available use: UIManager.getLookAndFeel().provideErrorFeedback(comboBox);
	            }
	            
	            highlightCompletedText(offs);
	            hitBackspace=false;
	        }
	        else
	        {
	            super.remove(offs, len);
	        }
	        
	        lookupItem(document.getText(0, document.getLength()));
	        
	        
//	        if ((!isOnlyOneColor()) && (selectedItem == null))
//	        	comboBox.getEditor().getEditorComponent().setForeground(Color.RED);

//	        
//			if (updatePopUp)
//			{
//				updatePopUpView();
//				updatePopUp = false;
//			}

	    }
		
		/*VERSIN NUEVA
		 *  (non-Javadoc)
		 * @see javax.swing.text.Document#insertString(int, java.lang.String, javax.swing.text.AttributeSet)
		 */
	    public void insertString(int offs, String str, AttributeSet a) throws BadLocationException {
	//	    	super.insertString(offs, str, a);
	    	logger.debug("INSERTSTRING: " + str);
//	    	model.setCurrentString(str);
	    	
	    	// For UNDO-REDO
//	    	undoManager.addEdit(new UndoableDocumentEdition(str));
//	    	undoManager.addEdit(new UndoableDocumentEdition(iiiii++, false, true, false));
	     
	    	if (model.getParentSize() > 0)
	    	{    
		        // Insert the string into the document
		        
		        // If we aren't in the particular case of show all items at the beginning and is enabled the flag for complete the matched item:
		        //   this is for not insert two strings to the document of the editor of this component
		        if (!((completeMatchedItem) && (model.isStartViewFlag())))
	//		        if (!completeMatchedItem)
		        {
		        	super.insertString(offs, str, a);
		            logger.debug("INSERT STRING DE PLAINDOCUMENTSEEKER AADE : " + str);
		        }      
	  	
		        String text = getText(0, getLength());
		        // Lookup and select a matching item
		        Object item = lookupItem(text);
		        
		        if (item != null)
		        {
		        	logger.debug("ITEM NOT NULL");
		        	
		        	setSelectedItem(item);
		        	
		        	if (!completeMatchedItem)
		        		
			        	
			        // Set the complete item value matched
			        if (completeMatchedItem)
			        	setText(item.toString());
			        else
			        {
			        	editor.getEditorComponent().setForeground(Color.BLACK);
			        	setText(text);
			        }
			        
		            // Imitate no insert (later on offs will be incremented by str.length(): selection won't move forward)
			        offs+=str.length();
		        }
		        else
		        {
		        	logger.debug("ITEM NULL");
		        	
		        	// If no item matches -> default selection (no item selection)
		        	selectedItem = null;
		        	setSelectedIndex(-1);
		        	super.insertString(0, text, null);
	 
		            // Provide feedback to the user that his input has been received but can not be accepted
		            if (beepEnabled)
		            	comboBoxReference.getToolkit().beep(); // when available use: UIManager.getLookAndFeel().provideErrorFeedback(comboBox);
		            
		            // Update the popup view for not see any item selected
		            updatePopUpView();
		        }
		        
		        // Select the completed part
		        highlightCompletedText(offs);
		    
		        if (textKeyPressed)
		        {
//		        	updatePopUpView();
		        	
		        	textKeyPressed = false;
		        }
	    	}		        
	    }


//		/*VERSIN ANTIGUA
//		 *  (non-Javadoc)
//		 * @see javax.swing.text.Document#insertString(int, java.lang.String, javax.swing.text.AttributeSet)
//		 */
//	    public void insertString(int offs, String str, AttributeSet a) throws BadLocationException {
////	    	super.insertString(offs, str, a);
//	    	logger.debug("INSERTSTRING: " + str);
////	    	model.setCurrentString(str);	    		    	
//	     
//	    	if (model.getParentSize() > 0)
//	    	{    
//		        // Insert the string into the document
//		        
//		        // If we aren't in the particular case of show al items at the beginning and is enabled the flag for complete the matched item:
//		        //   this is for not insert two strings to the document of the editor of this component
//		        if (!((completeMatchedItem) && (model.isStartViewFlag())))
//	//		        if (!completeMatchedItem)
//		        {
//		        	super.insertString(offs, str, a);
//		            logger.debug("INSERT STRING DE PLAINDOCUMENTSEEKER AADE : " + str);
//		        }      
//	  	
//		        // Lookup and select a matching item
//		        Object item = lookupItem(getText(0, getLength()));
//		        
//		        if (item != null)
//		        {
//		        	logger.debug("ITEM NOT NULL");
//			        if ((completeMatchedItem) || (getSearchBehavior() == AbstractDefaultComboBoxItemsSeekerConfigurableModel.MAINTAIN_ORIGINAL_POSITION_ALL_ITEMS_SEARCH))
//			        	setSelectedItem(item);
//			        
//	
//	//		            model.setCurrentString(getSelectedItem().toString());
//	//		            lastSelectedIndex = getSelectedIndex();
//		        }
//		        else
//		        {
//		        	logger.debug("ITEM NULL");
//		            // Keep old item selected if there is no match
//		            item = comboBox.getSelectedItem();
//		            logger.debug("ITEM QUE SELECCIONA CUANDO NULL: ->" + item.toString() + "<-");
//		            
//		            // Imitate no insert (later on offs will be incremented by str.length(): selection won't move forward)
//		            offs = offs-str.length();
//		            
//		            // Provide feedback to the user that his input has been received but can not be accepted
//		            if (beepEnabled)
//		            	comboBox.getToolkit().beep(); // when available use: UIManager.getLookAndFeel().provideErrorFeedback(comboBox);
//		        }
//		        
//		        // Set the complete item value matched
//		        if (completeMatchedItem)
//		        	setText(item.toString());
//		        
//		        // Select the completed part
//		        highlightCompletedText(offs+str.length());
//		    
//		        if (textKeyPressed)
//		        {
////		        	updatePopUpView();
//		        	
//		        	textKeyPressed = false;
//		        }
//	    	}		        
//	    }

	    /** Sobra?
	     * This method sets the string value of the item to the PlainDocument removing the previous value of the PlainDocument
	     * 
	     * @param text The string value of the item
	     */
	    private void setText(String text) {
	        try
	        {
	            // remove all text and insert the completed string
	            super.remove(0, super.getLength());
	            super.insertString(0, text, null);
	            logger.debug("SET TEXT DE PLAINDOCUMENTSEEKER AADE : " + text);
	        }
	        catch (BadLocationException e)
	        {
	            throw new RuntimeException(e.toString());
	        }
	    }
	    
	    /** ANTIGUO (USO STE)
	     * Only in red color if is allowed by the configuration and any item starts with this pattern
	     */
	    private Object lookupItem(String pattern) {
	    	logger.debug("LOOKUP -> patrn ->" + pattern + "<-");
	    	// Reset the color to the default
//	    	editor.getEditorComponent().setForeground(Color.BLACK);
	    	
	        // If no item starts with the pattern => return null and set the text written on red color if it's allowed	        
	    	
	        Object selectedItem = model.getSelectedItem();
	        
//	        if (selectedItem.toString().length() >= pattern.length())
//	        {
		        // only search for a different item if the currently selected does not match
		        if ((selectedItem != null) && (str1StartsWithStr2(selectedItem.toString(), pattern)))
		        {
		        	editor.getEditorComponent().setForeground(Color.BLACK);
		        	
		        	this.setRedColorToTextIfDoesntMatch(selectedItem.toString(), pattern);
		        	
		            return selectedItem;
		        }
		        else
		        {
		            // iterate over all items
		            for (int i=0, n=model.getSize(); i < n; i++)
		            {
		                Object currentItem = model.getElementAt(i);
		                
		                // current item starts with the pattern?
		                if ((currentItem != null) && (str1StartsWithStr2(currentItem.toString(), pattern)))
		                {
		                	editor.getEditorComponent().setForeground(Color.BLACK);
		                	
		                	this.setRedColorToTextIfDoesntMatch(currentItem.toString(), pattern);
		                	
		                    return currentItem;
		                }
		            }
		        }
		        
		    if (!comboBoxReference.isOnlyOneColor()){
		    	editor.getEditorComponent().setForeground(Color.RED);
		    	logger.debug("Pone a Rojo Lookup");
		    }
		    
	        return null;
	    }
	    
//	    /** NUEVO
//	     * Only in red color if is allowed by the configuration and any item starts with this pattern
//	     */
//	    private Object lookupItem(String pattern) {
//	    	logger.debug("LOOKUP -> patrn ->" + pattern + "<-");
//	    	// Reset the color to the default
////	    	editor.getEditorComponent().setForeground(Color.BLACK);
//	    	
//	        // If no item starts with the pattern => return null and set the text written on red color if it's allowed	        
//	    	
//	        Object selectedItem = model.getSelectedItem();
//	        
//	        if (isCaseSensitive())
//	        {
//		        // only search for a different item if the currently selected does not match
//		        if ((selectedItem != null) && (startsWith(selectedItem.toString(), pattern)))
//		        {
//		        	editor.getEditorComponent().setForeground(Color.BLACK);
//		        	
//		        	if (!isOnlyOneColor()){
//				    	editor.getEditorComponent().setForeground(Color.RED);
//				    	logger.debug("Pone a Rojo Lookup");
//				    }
//		            return selectedItem;
//		        }
//		        else
//		        {
//		            // iterate over all items
//		            for (int i=0, n=model.getSize(); i < n; i++)
//		            {
//		                Object currentItem = model.getElementAt(i);
//		                
//		                // current item starts with the pattern?
//		                if ((currentItem != null) && (startsWith(currentItem.toString(), pattern)))
//		                {
//		                	editor.getEditorComponent().setForeground(Color.BLACK);
//		                	
//		                	if (!isOnlyOneColor()){
//		        		    	editor.getEditorComponent().setForeground(Color.RED);
//		        		    	logger.debug("Pone a Rojo Lookup");
//		        		    }
//		                    return currentItem;
//		                }
//		            }
//		        }
//	        }
//	        else
//	        {
//		        // only search for a different item if the currently selected does not match
//		        if ((selectedItem != null) && (startsWithIgnoreCase(selectedItem.toString(), pattern)))
//		        {
//		        	editor.getEditorComponent().setForeground(Color.BLACK);
//		        	
//		        	if (!isOnlyOneColor()){
//				    	editor.getEditorComponent().setForeground(Color.RED);
//				    	logger.debug("Pone a Rojo Lookup");
//				    }
//		            return selectedItem;
//		        }
//		        else
//		        {
//		            // iterate over all items
//		            for (int i=0, n=model.getSize(); i < n; i++)
//		            {
//		                Object currentItem = model.getElementAt(i);
//		                
//		                // current item starts with the pattern?
//		                if ((currentItem != null) && (startsWithIgnoreCase(currentItem.toString(), pattern)))
//		                {
//		                	editor.getEditorComponent().setForeground(Color.BLACK);
//		                	
//		                	if (!isOnlyOneColor()){
//		        		    	editor.getEditorComponent().setForeground(Color.RED);
//		        		    	logger.debug("Pone a Rojo Lookup");
//		        		    }
//		                    return currentItem;
//		                }
//		            }
//		        }	        	
//	        }
//	        
//		    if (!isOnlyOneColor()){
//		    	editor.getEditorComponent().setForeground(Color.RED);
//		    	logger.debug("Pone a Rojo Lookup");
//		    }
//		    
//	        return null;
//	    }

	    
	    private void setRedColorToTextIfDoesntMatch(String str1, String str2) {
	    	if (!isOnlyOneColor()){
	    		if (comboBoxReference.isCaseSensitive())
	    		{
	    			if (str1.compareTo(str2) != 0)
	    			{
	    				editor.getEditorComponent().setForeground(Color.RED);
	    		    	logger.debug("Pone a Rojo Lookup");
	    			}	    				
	    		}
	    		else
	    		{
	    			if (str1.compareToIgnoreCase(str2) != 0)
	    			{
	    				editor.getEditorComponent().setForeground(Color.RED);
	    		    	logger.debug("Pone a Rojo Lookup");
	    			}	   
	    		}		    	
		    }
	    }
	    
	    
	    /**
	     * Checks if the starts of two strings agrees
	     */
	    private boolean str1StartsWithStr2(String str1, String str2) {
	    	if (comboBoxReference.isCaseSensitive())
	    		return str1.startsWith(str2);
	    	else
	    		return str1.toUpperCase().startsWith(str2.toUpperCase());
	    }
	}




	
	// Class for 
//	private class UndoableDocumentEdition extends AbstractUndoableEdit {
//		private String modification;
//
//		/**
//		 * @param modification
//		 */
//		public UndoableDocumentEdition(String modification) {
//			super();
//			this.modification = modification;
//		}
//		
//		public String toString() {
//			return this.modification;
//		}
//		
//
//		private boolean isSignificant;
//
//		  private boolean isReplacer;
//
//		  private int number;
//
//		  private boolean allowAdds;
//
//		  private Vector addedEdits;
//
//		  private UndoableEdit replaced;
//		
//		/**
//		 * 
//		 */
//		public UndoableDocumentEdition() {
//			super();
//			// TODO Auto-generated constructor stub
//		}
//		
//		 // Create a new edit with an identifying number. The boolean arguments
//		  // define
//		  // the edit's behavior.
//		  public UndoableDocumentEdition(int number, boolean allowAdds,
//		      boolean isSignificant, boolean isReplacer) {
//		    this.number = number;
//		    this.allowAdds = allowAdds;
//		    if (allowAdds)
//		      addedEdits = new Vector();
//		    this.isSignificant = isSignificant;
//		    this.isReplacer = isReplacer;
//		  }
//
//		  // "Undo" the edit by printing a message to the screen.
//		  public void undo() throws CannotUndoException {
//		    super.undo();
//		    System.out.print("Undo " + number);
//		    dumpState();
//		  }
//
//		  // "Redo" the edit by printing a message to the screen.
//		  public void redo() throws CannotRedoException {
//		    super.redo();
//		    System.out.print("Redo " + number);
//		    dumpState();
//		  }
//
//		  // If allowAdds is true, we store the input edit. If not, just return false.
//		  public boolean addEdit(UndoableEdit anEdit) {
//		    if (allowAdds) {
//		      addedEdits.addElement(anEdit);
//		      return true;
//		    } else
//		      return false;
//		  }
//
//		  // If isReplacer is true, we store the edit we are replacing.
//		  public boolean replaceEdit(UndoableEdit anEdit) {
//		    if (isReplacer) {
//		      replaced = anEdit;
//		      return true;
//		    } else
//		      return false;
//		  }
//
//		  // Significance is based on constructor parameter.
//		  public boolean isSignificant() {
//		    return isSignificant;
//		  }
//
//		  // Just return our identifier.
//		  public String toString() {
//		    return "<" + number + ">";
//		  }
//
//		  // Debug output.
//		  public void dumpState() {
//		    if (allowAdds && addedEdits.size() > 0) {
//		      Enumeration e = addedEdits.elements();
//		      System.out.print(" (absorbed: ");
//		      while (e.hasMoreElements()) {
//		        System.out.print(e.nextElement());
//		      }
//		      System.out.print(")");
//		    }
//		    if (isReplacer && replaced != null) {
//		      System.out.print(" (replaced: " + replaced + ")");
//		    }
//		    System.out.println();
//		  }
//	}  
}